//
// HPB_bot - botman's High Ping Bastard bot
//
// (http://planethalflife.com/botman/)
//
// bot.h
//

#ifndef BOT_H
#define BOT_H

//#define _DEBUG

#define MIN(x,y) (x<y?x:y)
#define MAX(x,y) (x>y?x:y)


// define constants used to identify the MOD we are playing...

#define VALVE_DLL      1
#define TFC_DLL        2
#define CSTRIKE_DLL    3
#define GEARBOX_DLL    4
#define SI_DLL 6
#define FLF_DLL 7

// define some function prototypes...

void FakeClientCommand (edict_t *pFakeClient, const char *fmt, ...);


#define BOT_PITCH_SPEED  20  // degrees per frame for rotation
#define BOT_YAW_SPEED    20  // degrees per frame for rotation
#define DEGREES_PER_SECOND (180)
#define DEGREES_PER_MSEC (1.8)

#define RESPAWN_IDLE             1
#define RESPAWN_NEED_TO_RESPAWN  2
#define RESPAWN_IS_RESPAWNING    3

// game start messages for TFC...
#define MSG_TFC_IDLE          1
#define MSG_TFC_TEAM_SELECT   2
#define MSG_TFC_CLASS_SELECT  3

// game start messages for CS...
#define MSG_CS_IDLE         1
#define MSG_CS_TEAM_SELECT  2
#define MSG_CS_CT_SELECT    3
#define MSG_CS_T_SELECT     4

// define player classes used in TFC
#define TFC_CLASS_CIVILIAN  0
#define TFC_CLASS_SCOUT     1
#define TFC_CLASS_SNIPER    2
#define TFC_CLASS_SOLDIER   3
#define TFC_CLASS_DEMOMAN   4
#define TFC_CLASS_MEDIC     5
#define TFC_CLASS_HWGUY     6
#define TFC_CLASS_PYRO      7
#define TFC_CLASS_SPY       8
#define TFC_CLASS_ENGINEER  9

//si stuff
#define MSG_SI_IDLE        1
#define MSG_SI_TEAM_SELECT 2
#define MSG_SI_CLASS_SELECT 3

//flf stuff
#define MSG_FLF_IDLE 1
#define MSG_FLF_TEAM_SELECT 2
#define MSG_FLF_CLASS_SELECT 3
#define MSG_FLF_SUB_SELECT 72
#define MSG_FLF_SHOTGUN_SELECT 73
#define MSG_FLF_RIFLE_SELECT 75
#define MSG_FLF_PISTOL_SELECT 76
#define MSG_FLF_HEAVY_SELECT 78
#define MSG_FLF_WEAPON_CLASS_SELECT 70

#define FLF_CLASS_RECON 1
#define FLF_CLASS_ASSAULT 2
#define FLF_CLASS_SUPPORT 3

#define BOT_SKIN_LEN 32
#define BOT_NAME_LEN 32


typedef struct bot_s * bot_ptr;

typedef struct
{
	int nails, cells, rockets, shells, detpack, gren1, gren2, health, armorvalue;
	edict_t * pEdict;
} TF_BackPack;

typedef struct
{
   int  iId;     // weapon ID
   int  iClip;   // amount of ammo in the clip
   int  iAmmo1;  // amount of ammo in primary reserve
   int  iAmmo2;  // amount of ammo in secondary reserve
} bot_current_weapon_t;

typedef struct
{
   char szClassname[64];
   int  iAmmo1;     // ammo index for primary ammo
   int  iAmmo1Max;  // max primary ammo
   int  iAmmo2;     // ammo index for secondary ammo
   int  iAmmo2Max;  // max secondary ammo
   int  iSlot;      // HUD slot (0 based)
   int  iPosition;  // slot position
   int  iId;        // weapon ID
   int  iFlags;     // flags???
} bot_weapon_t;

typedef enum
{
	TargetType_player,
	TargetType_sentry,
	TargetType_breakable,
	TargetType_button,
} TargetType;

class CBotWeapon
{
public:
	int iId; //id number
	int iClip; //in clip
	int iAmmo1Index; //index of primary
	int iAmmo2Index; //index of secondary
	int iAmmo1Amt;
	int iAmmo2Amt;
	int iAmmo1Max;
	int iAmmo2Max;

	float baseFitness;

	bool hasClip;
	bool hasZoom;
	bool underwater;

	float firingJitter;
	float firingArc;

	int clipSize;

	bot_ptr pBot;

	CBotWeapon(void);
	CBotWeapon(bot_weapon_t, bot_ptr pBot);

	virtual float Fitness(Vector target, float targetDistance, TargetType targetType);
	virtual int Fire(Vector target);
	virtual Vector GetBarrelOffset(void);
	virtual Vector GetTargetVector(Vector botOrigin, Vector targetOrigin, edict_t * pBotEnemy);
	virtual Vector FuzzAiming(Vector aimVector);
	virtual bool CanFire(void);
	virtual bool ShouldPickup(TF_BackPack * pack);
	virtual bool NeedAmmo();
};

typedef struct bot_s{
	bool is_used;
	int respawn_state;
	edict_t *pEdict;
	bool need_to_initialize;
	char name[BOT_NAME_LEN+1];
	char skin[BOT_SKIN_LEN+1];
	int not_started;
	int start_action;
	float start_action_time;
	int next_start_action;

// TheFatal - START
   int msecnum;
   float msecdel;
   float msecval;
// TheFatal - END

   // things from pev in CBasePlayer...
   int bot_team;
   int bot_class;
   int bot_health;
   int bot_armor;
   int bot_weapons;  // bit map of weapons the bot is carrying
   int bot_money;    // for Counter-Strike

   edict_t *pBotEnemy;

   float f_max_speed;
   float prev_speed;
   Vector v_prev_origin;
   float f_pause_time;

   float f_move_speed;

   bot_current_weapon_t current_weapon;  // one current weapon for each bot
   int m_rgAmmo[MAX_AMMO_SLOTS];  // total ammo amounts (1 array for each bot)
   class CBotWeapon *weapons[32];

	 int rgflAim;

	 // ****** my stuff *******
	 int currentPoint;
	 int destination;
	 bool checkPath;
	 bool stopped;
	 float checkTime;

	 int state;
	 float stateTime;

	 int next_waypoints[10];
	 int waypoints_upto;

	 float ignoreItemTime;
	 float pickupItemTime;
	 bool pickingup;

	 float f_strafe_speed;
	 float last_strafe_speed;
	 bool gotFlag;

	 float lastCommandTime;
	 float weaponChargeTime;
	 bool voting;

	 int behaviour;
	 edict_t *commander;
	 int lastpoint;
	 int bot_skill;

	 bool weapon_classes[3];
	 bool flf_attacking;
	 float flashTime;
	 float fov;
	 float reactionTime;
	 float grenadeTime;
	 float cantCaptureTime;
	 float crouchTime;
	 float f_captureTime;

	 int tfc_grenades[2];
	 int grenadeNum; //grenade we are currently throwing

	 bool detpack;

	 edict_t * pSentry;
	 edict_t * pDispenser;
	 edict_t * pKiller;

	 Vector view_target;

	 byte waypoint_position;

	 float kick_time; //for botmans new startframe
	 int round_end;

	 int last_point;
	 int sentry_point;

	 float f_ideal_speed;
	 int moveType;

	float f_last_distance;
	bool was_alive;

	float dont_disguise_time;
	int weapon_status;

	float last_yaw; //last turn angle
	float last_pitch; //last pitch angle
	float to_pitch;
	float to_yaw;

	float f_change_weapon_time;
	float f_detonate_dispenser_time;
	float f_click_time; //respawn in SI

	int sentry_ammo;
	int dispenser_health;
	bool debug;
	struct BotMessage_s * pChatMessages;
	float f_chat_time;
	float f_see_enemy_time;
	Vector lastEnemyOrigin;
} bot_t;

// new UTIL.CPP functions...
edict_t *UTIL_FindEntityInSphere( edict_t *pentStart, const Vector &vecCenter, float flRadius );
edict_t *UTIL_FindEntityByString( edict_t *pentStart, const char *szKeyword, const char *szValue );
edict_t *UTIL_FindEntityByClassname( edict_t *pentStart, const char *szName );
edict_t *UTIL_FindEntityByTargetname( edict_t *pentStart, const char *szName );
void UTIL_SayText( char *pText, edict_t *pEdict, bool teamonly );
int UTIL_GetTeam(edict_t *pEntity);
int UTIL_GetBotIndex(edict_t *pEdict);
bot_t *UTIL_GetBotPointer(edict_t *pEdict);
bool IsAlive(edict_t *pEdict);
bool FInViewCone(Vector *pOrigin, edict_t *pEdict);
bool FVisible( const Vector &vecOrigin, edict_t *pEdict );
Vector Center(edict_t *pEdict);
Vector GetGunPosition(edict_t *pEdict);
void UTIL_SelectItem(edict_t *pEdict, char *item_name);
Vector VecBModelOrigin(edict_t *pEdict);
bool UpdateSounds(edict_t *pEdict, edict_t *pPlayer);
void UTIL_ShowMenu( edict_t *pEdict, int slots, int displaytime, bool needmore, char *pText );

//***** my new functions *******
void BotNewDestination(bot_t * pBot);
bool BotCanSnipe(bot_t * pBot);
bool BotCanBuildSentry(bot_t * pBot);
bool BotCanBuildDispenser(bot_t * pBot);
bool BotCanDetpack(bot_t *pBot);
bool BotCanGuard(bot_t *pBot);
bool BotNeedArmor(bot_t *pBot); // for engies
int BotMaxHealth(bot_t * pBot);
int BotMaxArmor(bot_t *pBot);
void HandleKeyValueData(edict_t* pent, KeyValueData *pkvd);
int TFC_GetAvailableClass(int team);
int TFC_GetAvailableTeam(void);

int RepairSentry(bot_t *pBot);

void CombatMove(bot_t *);
void TakeCover(bot_t*);
void BotThrowGrenade(bot_t *);
int GetAllianceTeam(int team);
int GetLargestTeamBot(void);




int GetAvailableTeam(edict_t *pEdict);

void ResetTFCData(void);

void CreateSinTable(void);
inline float sinTable(float f_angle);
bool BotCanMoveTowardsLift(bot_t *pBot);


float RandomValue(int, int); //placeholder function for dopath
void BotSetMoveType(bot_t * pBot);

#define STATE_NONE 0
#define STATE_SNIPING 1
#define STATE_BUILDING_SENTRY 2
#define STATE_WAITING 3
#define STATE_GUARDING 4
#define STATE_DOORS_OPEN 5
#define STATE_BUILDING_DISPENSER 6
#define STATE_DETPACKING 7

#define BEHAVE_NONE 0
#define BEHAVE_GUARD 1
#define BEHAVE_ATTACK 2
#define BEHAVE_FOLLOW 3

#define POSITION_FRONT 1
#define POSITION_BEHIND 2
#define POSITION_UNKNOWN 3

#define MOVETYPE_NORMAL 0
#define MOVETYPE_SCARED 1
#define MOVETYPE_KILL 2

typedef struct {
	int available_classes;
	bool available_teams;
	int max_players;
	int allies;
} tf_team_data ;

typedef struct {
	int roundTime;
	int warmupTime;
	int aRespawnTime;
	int dRespawnTime;
	int weather;
} flf_data_t;

typedef struct {
	bool resetSentries;
	bool dontCheckTeams;
	bool reverseCTF;
} tf_map_data_t;


TF_BackPack * GetBackPack(edict_t *pEdict, bool alloc);
void RemoveBackPacks(void);
bool BotNeedBackPack(bot_t * pBot, TF_BackPack * pack);
bool BotNeedAmmo(bot_t *pBot);

#endif // BOT_H
