//
// HPB bot - botman's High Ping Bastard bot
//
// (http://planethalflife.com/botman/)
//
// bot.cpp
//

#include <assert.h>

#ifndef _WIN32
#include <string.h>
#endif

#include <extdll.h>
#include <dllapi.h>
#include <h_export.h>
#include <meta_api.h>

#include "bot.h"
#include "bot_func.h"
#include "waypoint.h"
#include "bot_weapons.h"
#include "bot_communicate.h"
#include "my_navigate.h"
#include "logging.h"

#include <sys/types.h>
#include <sys/stat.h>

extern int mod_id;
extern int num_waypoints;
extern WAYPOINT waypoints[MAX_WAYPOINTS];

extern int names_used;
extern char bot_names[128][35];
extern int victory_used;
extern char bot_victory[64][96];
extern int loss_used;
extern char bot_loss[64][96];
extern int bot_chat_freq;
static FILE *fp;

extern int IsMyBot[32];

bool check_teams = TRUE;

flf_data_t flf_data = {5*60,30,5,10,0};
tf_map_data_t tf_map = {FALSE, FALSE};

#define PLAYER_SEARCH_RADIUS 40.0

bot_t bots[32];   // max of 32 bots in a game

int bot_names_first=0;
int bot_names_last=-1;

extern int max_bots;

extern int UTIL_GetSpyTeam(edict_t *pPlayer);

int   need_init = 1;

#define VALVE_MAX_SKINS    10
#define GEARBOX_MAX_SKINS  20

// indicate which models are currently used for random model allocation
bool valve_skin_used[VALVE_MAX_SKINS] = {
   FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE};

bool gearbox_skin_used[GEARBOX_MAX_SKINS] = {
   FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE,
   FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE};

// store the names of the models...
char *valve_bot_skins[VALVE_MAX_SKINS] = {
   "barney", "gina", "gman", "gordon", "fredrick", //"helmet",
   "hgrunt", "recon", "robo", "scientist", "zombie"};

char *gearbox_bot_skins[GEARBOX_MAX_SKINS] = {
   "barney", "beret", "cl_suit", "drill", "fassn", "gina", "gman",
   "gordon", "grunt", "helmet", "hgrunt", "massn", "otis", "recon",
   "recruit", "robo", "scientist", "shepard", "tower", "zombie"};

// store the player names for each of the models...
char *valve_bot_names[VALVE_MAX_SKINS] = {
   "Barney", "Gina", "G-Man", "Gordon", "Helmet",
   "H-Grunt", "Recon", "Robo", "Scientist", "Zombie"};

char *gearbox_bot_names[GEARBOX_MAX_SKINS] = {
   "Barney", "Beret", "Cl_suit", "Drill", "Fassn", "Gina", "G-Man",
   "Gordon", "Grunt", "Helmet", "H-Grunt", "Massn", "Otis", "Recon",
   "Recruit", "Robo", "Scientist", "Shepard", "Tower", "Zombie"};

// tf class and team stuff
//int tf_available_classes[4] = {0,0,0,0};
//bool tf_available_teams[4] = {FALSE, FALSE, FALSE, FALSE};
//int tf_max_players[4] = {0,0,0,0};
//int tf_allies[4] = {0,0,0,0};

tf_team_data tf_data[4] = {
	{0,TRUE,0,0},
	{0,TRUE,0,0},
	{0,0,0,0},
	{0,0,0,0}
};

extern int current_skill;

// how often (out of 1000 times) the bot will pause, based on bot skill
float pause_frequency[5] = {4, 7, 10, 15, 20};

float pause_time[5][2] = {
   {0.2, 0.5}, {0.5, 1.0}, {0.7, 1.3}, {1.0, 1.7}, {1.2, 2.0}};


inline edict_t *CREATE_FAKE_CLIENT( const char *netname )
{
   return (*g_engfuncs.pfnCreateFakeClient)( netname );
}

void BotRespawnInit(bot_t *pBot, bool killSentries) {
	 int i;
	 pBot->crouchTime = 0;
	 pBot->detpack = TRUE;
	 pBot->pKiller = NULL;
	 pBot->view_target= Vector(0,0,0);
	 pBot->rgflAim = 1.0;

   pBot->f_max_speed = CVAR_GET_FLOAT("sv_maxspeed");

   pBot->prev_speed = 0.0;  // fake "paused" since bot is NOT stuck

   pBot->pBotEnemy = NULL;  // no enemy yet

	 pBot->currentPoint = -1;
	 pBot->destination = -1;
	 pBot->stopped = FALSE;
	 pBot->state = STATE_NONE;
	 pBot->stateTime = 0;
	 pBot->ignoreItemTime = 0;
	 pBot->pickupItemTime = 0;
	 pBot->pickingup = FALSE;
	 for (i = 0; i < 10; i++) {
		 pBot->next_waypoints[i] = -1;
	 }
	 pBot->waypoints_upto = -1;
	 pBot->gotFlag = FALSE;
	 pBot->lastCommandTime = 0;
	 pBot->lastpoint = -1;
	 pBot->flashTime = 0;
	 pBot->reactionTime = 0;
	 pBot->weaponChargeTime = 0;
	 pBot->dont_disguise_time = 0;
	 pBot->waypoint_position = POSITION_UNKNOWN;

	 pBot->round_end = 0;
	 pBot->last_point = -1;
	 pBot->f_ideal_speed = pBot->f_max_speed;
	 pBot->moveType = 0;
	 pBot->f_last_distance = -1;
	 pBot->weapon_status = BOT_WEAPON_FIRED;
	 pBot->fov = 1.0;

	 pBot->f_change_weapon_time = 0.0;
	 pBot->f_detonate_dispenser_time = 0.0;
	 pBot->f_click_time = 0.0;

	 pBot->f_captureTime = 0.0;
	 
	 pBot->grenadeTime = 0;
	 pBot->cantCaptureTime = 0;


	 /*
	 if (killSentries && tf_map.resetSentries)
	 {
		 pBot->pSentry = NULL;
		 pBot->pDispenser = NULL;
	 }
	 */

}


void BotSpawnInit( bot_t *pBot)
{
   pBot->v_prev_origin = Vector(0,0,0);

   pBot->msecnum = 0;
   pBot->msecdel = 0.0;
   pBot->msecval = 0.0;

   pBot->bot_health = -1;
   pBot->bot_armor = -1;
   pBot->bot_weapons = 0;
   pBot->bot_money = 0;


   memset(&(pBot->current_weapon), 0, sizeof(pBot->current_weapon));
   memset(&(pBot->m_rgAmmo), 0, sizeof(pBot->m_rgAmmo));

   pBot->need_to_initialize = FALSE;

	 //**** my stuff ****
	 BotRespawnInit(pBot, FALSE);
}


void BotCreate( edict_t *pPlayer, const char *arg1, const char *arg2,
                const char *arg3, const char *arg4)
{
   edict_t *BotEnt;
   bot_t *pBot;
   char name[32];
   int bot_team = -1;
   int bot_class = -1;
   int name_team = -1;
   int index;
   char * skin = NULL;

   if (CVAR_GET_FLOAT("strict_max_bots"))
   {
	   int count = 0;
	   for (index = 0; index < 32; index ++)
	   {
		   if (bots[index].is_used)
		   {
			   count++;
		   }
	   }
	   if (count >= max_bots && max_bots != -1)
	   {
			(*g_engfuncs.pfnServerPrint)("max_bots reached, cannot create bot!\n");
			return;
	   }
   }
	if ((mod_id == TFC_DLL) || (mod_id == CSTRIKE_DLL) || (mod_id == SI_DLL) || mod_id == FLF_DLL)
	{
		if ((arg1 != NULL) && (arg1[0] != 0))
		{
			bot_team = atoi(arg1);
			if ((arg2 != NULL) && (arg2[0] != 0))
			{
				bot_class = atoi(arg2);
			}
		}
	}
	if (!IsValidTeam(bot_team)) {
		bot_team = -1;
		bot_class = -1;
	}
	else if (!IsValidClass(bot_class, bot_team))
	{
		bot_class = -1;
	}

	if (bot_team == -1)
	{
		if (CVAR_GET_FLOAT("bot_balance"))
		{
			bot_team = GetBalancedTeam(NULL);
		}
		else
		{
			bot_team = GetAvailableTeam(NULL);
		}
	}

	if (mod_id == VALVE_DLL)
	{
		int skin_index;
		for (skin_index = 0; skin_index < VALVE_MAX_SKINS; skin_index++)
		{
			if (!valve_skin_used[skin_index])
			{
				skin = valve_bot_skins[skin_index];
				valve_skin_used[skin_index] = TRUE;
				break;
			}
		}
		if (skin_index == VALVE_MAX_SKINS)
		{
			for (skin_index = 0; skin_index < VALVE_MAX_SKINS; skin_index++)
			{
				valve_skin_used[skin_index] = FALSE;
			}
			skin = valve_bot_skins[0];
		}
	}
			



	 if (arg3 == NULL || *arg3 == '\0')
	 {
	 	if (names_used > 0)
	 	{
			int name_to_use;
			if (CVAR_GET_FLOAT("bot_random_names"))
			{
				name_to_use = RANDOM_LONG(0, names_used);
			}
			else
			{
				name_team = GetAllianceTeam(bot_team);
				if (name_team == 1 || name_team == 3)
				{
					name_to_use = bot_names_first;
					bot_names_first++;
					if (bot_names_first >= names_used)
					{
						bot_names_first = 0;
					}
				}
				else
				{
					if (bot_names_last < 0)
					{ //different order from above because we don't know the last name
						bot_names_last = names_used; //untill now
					}
					bot_names_last--;
					name_to_use = bot_names_last;
				}
			}
			strncpy(name, bot_names[name_to_use], 30);
		 } else {
			 strcpy(name, "ODD_Bot");
		 }
	 } else {
		 strncpy(name, arg3, 30);
	 }

   // initialize the bots array of structures if first time here...
   if (need_init == 1)
   {
      need_init = 0;
      memset(bots, 0, sizeof(bots));
   }

   BotEnt = CREATE_FAKE_CLIENT( name );

   if (FNullEnt( BotEnt ))
   {
      if (pPlayer)
         ClientPrint( VARS(pPlayer), HUD_PRINTNOTIFY, "Max. Players reached.  Can't create bot!\n");
   }
   else
   {
      char ptr[128];  // allocate space for message from ClientConnect
      char *infobuffer;
      int clientIndex;

      if (IS_DEDICATED_SERVER())
         printf("Creating bot...\n");
      else if (pPlayer)
         ClientPrint( VARS(pPlayer), HUD_PRINTNOTIFY, "Creating bot...\n");

      index = 0;
      while ((bots[index].is_used) && (index < 32))
         index++;

      if (index == 32)
      {
         ClientPrint( VARS(pPlayer), HUD_PRINTNOTIFY, "Can't create bot!\n");
         return;
      }

      // create the player entity by calling MOD's player function
      // (from LINK_ENTITY_TO_CLASS for player object)

      CALL_GAME_ENTITY (PLID, "player", VARS(BotEnt) );

      infobuffer = GET_INFOKEYBUFFER( BotEnt );
      clientIndex = ENTINDEX( BotEnt );

			//IsMyBot[clientIndex-1] = 1;


      if (skin == NULL)
	  {
		  SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "model", "gina" );
	  }
	  else
	  {
		  SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "model", skin );
	  }


      if (mod_id == CSTRIKE_DLL)
      {
         SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "rate", "3500.000000");
         SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "cl_updaterate", "20");
         SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "cl_lw", "1");
         SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "cl_lc", "1");
         SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "tracker", "0");
         SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "cl_dlmax", "128");
         SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "lefthand", "1");
         SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "friends", "0");
         SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "dm", "0");
         SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "ah", "1");
      }

      MDLL_ClientConnect( BotEnt, name, "127.0.0.1", ptr );

      // Pieter van Dijk - use instead of DispatchSpawn() - Hip Hip Hurray!
      MDLL_ClientPutInServer( BotEnt );

      BotEnt->v.flags |= FL_FAKECLIENT;

      // initialize all the variables for this bot...

      pBot = &bots[index];

	  for (index = 0; index <32; index++)
	  {
			/*if (pBot->weapons[index])
			  delete pBot->weapons[index];
		  pBot->weapons[index] = new CBotWeapon();
		  */
		  if (!pBot->weapons[index])
		  {
			  pBot->weapons[index] = new CBotWeapon();
			  pBot->weapons[index]->pBot = pBot;
		  }
	  }

      pBot->is_used = TRUE;
      pBot->respawn_state = RESPAWN_IDLE;
      pBot->name[0] = 0;  // name not set by server yet

      pBot->pEdict = BotEnt;
	  pBot->commander = NULL;
	  pBot->pSentry = NULL;
      pBot->pDispenser = NULL;
	  pBot->flf_attacking = FALSE;
      pBot->not_started = 1;  // hasn't joined game yet

      if (mod_id == TFC_DLL)
      {
		  pBot->start_action = MSG_TFC_IDLE;
		  pBot->next_start_action = MSG_TFC_TEAM_SELECT;
		  pBot->start_action_time = gpGlobals->time + 1.5;
	  }
      else if (mod_id == CSTRIKE_DLL)
      {
         pBot->start_action = MSG_CS_IDLE;
	  }
	  else if (mod_id == SI_DLL)
	  {
		 pBot->start_action = MSG_SI_IDLE;
		 pBot->next_start_action = MSG_SI_TEAM_SELECT;
		 pBot->start_action_time = gpGlobals->time + 1.5;
	  }
	  else if (mod_id == FLF_DLL)
	  {
		int i;
		for (i = 0; i < 3; i++) {
		  pBot->weapon_classes[i] = FALSE;
		}
		pBot->start_action = MSG_FLF_IDLE;
		pBot->next_start_action = MSG_FLF_TEAM_SELECT;
		pBot->start_action_time = gpGlobals->time + 1.5;
	  }
      else
      {
         pBot->start_action = 0;  // not needed for non-team MODs
	  }

	  pBot->bot_skill = current_skill;
      BotSpawnInit(pBot);

      BotEnt->v.idealpitch = BotEnt->v.v_angle.x;
      BotEnt->v.ideal_yaw = BotEnt->v.v_angle.y;
      BotEnt->v.pitch_speed = BOT_PITCH_SPEED;
      BotEnt->v.yaw_speed = BOT_YAW_SPEED;

      pBot->bot_team = -1;  // don't know what these are yet, server can change them
      pBot->bot_class = -1;
	  pBot->not_started = TRUE;
	  pBot->sentry_ammo = 0;

   	  if ((mod_id == TFC_DLL) || (mod_id == CSTRIKE_DLL) || (mod_id == SI_DLL) || mod_id == FLF_DLL)
      {
	     pBot->bot_team = bot_team;
	     pBot->bot_class = bot_class;
      }
   }
}


void BotStartGame( bot_t *pBot )
{
   char c_team[32];
   char c_class[32];

   edict_t *pEdict = pBot->pEdict;

	 pBot->behaviour = BEHAVE_NONE;

   if (mod_id == TFC_DLL)
   {
		 if (pBot->start_action_time < gpGlobals->time && pBot->start_action_time != 0) {
			 if (pBot->start_action == MSG_TFC_IDLE) {
				 pBot->start_action = pBot->next_start_action;
				 if (pBot->next_start_action == MSG_TFC_TEAM_SELECT) {
					 pBot->next_start_action = MSG_TFC_CLASS_SELECT;
				 }
				 pBot->start_action_time = gpGlobals->time + 1.5;
			 }
		 }
      // handle Team Fortress Classic stuff here...

      if (pBot->start_action == MSG_TFC_TEAM_SELECT)
      {
         pBot->start_action = MSG_TFC_IDLE;  // switch back to idle

         if ((pBot->bot_team != 1) && (pBot->bot_team != 2) && (pBot->bot_team != 3) && (pBot->bot_team != 4) &&
             (pBot->bot_team != 5))
            pBot->bot_team = -1;

         if (pBot->bot_team == -1)
				    pBot->bot_team = TFC_GetAvailableTeam();
            //pBot->bot_team = RANDOM_LONG(1, 2);

         // select the team the bot wishes to join...
         if (pBot->bot_team == 1)
            strcpy(c_team, "1");
         else if (pBot->bot_team == 2)
            strcpy(c_team, "2");
         else if (pBot->bot_team == 3)
            strcpy(c_team, "3");
         else if (pBot->bot_team == 4)
            strcpy(c_team, "4");
				 else
            strcpy(c_team, "5");

         FakeClientCommand(pEdict, "jointeam %s", c_team);

         return;
      }

      if (pBot->start_action == MSG_TFC_CLASS_SELECT)
      {
         pBot->start_action = MSG_TFC_IDLE;  // switch back to idle

         if ((pBot->bot_class < 0) || (pBot->bot_class > 10))
            pBot->bot_class = -1;

         if (pBot->bot_class == -1)
				    pBot->bot_class = TFC_GetAvailableClass(pBot->bot_team-1);
            //pBot->bot_class = RANDOM_LONG(1, 10);

         // select the class the bot wishes to use...
         if (pBot->bot_class == 0)
            strcpy(c_class, "civilian");
         else if (pBot->bot_class == 1)
            strcpy(c_class, "scout");
         else if (pBot->bot_class == 2)
            strcpy(c_class, "sniper");
         else if (pBot->bot_class == 3)
            strcpy(c_class, "soldier");
         else if (pBot->bot_class == 4)
            strcpy(c_class, "demoman");
         else if (pBot->bot_class == 5)
            strcpy(c_class, "medic");
         else if (pBot->bot_class == 6)
            strcpy(c_class, "hwguy");
         else if (pBot->bot_class == 7)
            strcpy(c_class, "pyro");
         else if (pBot->bot_class == 8)
            strcpy(c_class, "spy");
         else if (pBot->bot_class == 9)
            strcpy(c_class, "engineer");
         else
            strcpy(c_class, "randompc");

         FakeClientCommand(pEdict, c_class);

         // bot has now joined the game (doesn't need to be started)
         pBot->not_started = 0;

         return;
      }
   }
   else if (mod_id == CSTRIKE_DLL)
   {
      // handle Counter-Strike stuff here...

      if (pBot->start_action == MSG_CS_TEAM_SELECT)
      {
         pBot->start_action = MSG_CS_IDLE;  // switch back to idle

         if ((pBot->bot_team != 1) && (pBot->bot_team != 2) &&
             (pBot->bot_team != 5))
            pBot->bot_team = -1;

         if (pBot->bot_team == -1)
            pBot->bot_team = RANDOM_LONG(1, 2);

         // select the team the bot wishes to join...
         if (pBot->bot_team == 1)
            strcpy(c_team, "1");
         else if (pBot->bot_team == 2)
            strcpy(c_team, "2");
         else
            strcpy(c_team, "5");

         FakeClientCommand(pEdict, "menuselect %s", c_team);

         return;
      }

      if (pBot->start_action == MSG_CS_CT_SELECT)  // counter terrorist
      {
         pBot->start_action = MSG_CS_IDLE;  // switch back to idle

         if ((pBot->bot_class < 1) || (pBot->bot_class > 4))
            pBot->bot_class = -1;  // use random if invalid

         if (pBot->bot_class == -1)
            pBot->bot_class = RANDOM_LONG(1, 4);

         // select the class the bot wishes to use...
         if (pBot->bot_class == 1)
            strcpy(c_class, "1");
         else if (pBot->bot_class == 2)
            strcpy(c_class, "2");
         else if (pBot->bot_class == 3)
            strcpy(c_class, "3");
         else if (pBot->bot_class == 4)
            strcpy(c_class, "4");
         else
            strcpy(c_class, "5");  // random

         FakeClientCommand(pEdict, "menuselect %s", c_class);

         // bot has now joined the game (doesn't need to be started)
         pBot->not_started = 0;

         return;
      }

      if (pBot->start_action == MSG_CS_T_SELECT)  // terrorist select
      {
         pBot->start_action = MSG_CS_IDLE;  // switch back to idle

         if ((pBot->bot_class < 1) || (pBot->bot_class > 4))
            pBot->bot_class = -1;  // use random if invalid

         if (pBot->bot_class == -1)
            pBot->bot_class = RANDOM_LONG(1, 4);

         // select the class the bot wishes to use...
         if (pBot->bot_class == 1)
            strcpy(c_class, "1");
         else if (pBot->bot_class == 2)
            strcpy(c_class, "2");
         else if (pBot->bot_class == 3)
            strcpy(c_class, "3");
         else if (pBot->bot_class == 4)
            strcpy(c_class, "4");
         else
            strcpy(c_class, "5");  // random

         FakeClientCommand(pEdict, "menuselect %s", c_class);

         // bot has now joined the game (doesn't need to be started)
         pBot->not_started = 0;

         return;
      }
   }
	 else if (mod_id == SI_DLL)
	 {
		 if (pBot->start_action_time < gpGlobals->time && pBot->start_action_time != 0) {
			 pBot->start_action = pBot->next_start_action;
		 }
		 if (pBot->start_action == MSG_SI_TEAM_SELECT) {
			 pBot->start_action_time = 0;
			 if (pBot->bot_team < 1 || pBot->bot_team > 2) {
				 pBot->bot_team = -1;
			 }
			 if (pBot->bot_team == -1) {
				 pBot->bot_team = RANDOM_LONG(1,2);
			 }
			 if (pBot->bot_team == 1) {
				 strcpy(c_team, "1");
			 } else {
				 strcpy(c_team, "2");
			 }
			 //join a team
			 pBot->start_action = MSG_SI_IDLE;
			 pBot->next_start_action = MSG_SI_CLASS_SELECT;
			 pBot->start_action_time = gpGlobals->time + 1.5;
			 FakeClientCommand(pBot->pEdict, "setteam %s", c_team);
		 } else if (pBot->start_action == MSG_SI_CLASS_SELECT) {
			 if (pBot->bot_class < 1 || pBot->bot_class > 3) {
				 pBot->bot_class = -1;
			 }
			 if (pBot->bot_class == -1) {
				 pBot->bot_class = RANDOM_LONG(1,3);
			 }
			 if (pBot->bot_class == 1) {
				 strcpy(c_class, "1");
			 } else if (pBot->bot_class == 2) {
				 strcpy(c_class, "2");
			 } else {
				 strcpy(c_class, "3");
			 }
			 //choose a class
			 FakeClientCommand(pBot->pEdict, "setmodel %s", c_class);
			 pBot->not_started = 0; //can play now
		 }
	 }
	 else if (mod_id ==FLF_DLL)
	 {
		 if (pBot->start_action_time < gpGlobals->time && pBot->start_action_time != 0) 
		 {
			 pBot->start_action = pBot->next_start_action;
		 }
		 if (pBot->start_action == MSG_FLF_TEAM_SELECT) 
		 {
			 char c_team[3];
			 if (pBot->bot_team < 1 || pBot->bot_team > 2) 
			 {
				 pBot->bot_team = RANDOM_LONG(1,2);
			 }
			 if (pBot->bot_team == 1) 
			 {
				 strcpy(c_team, "1");
			 }
			 else
			 {
				 pBot->bot_team = 2;
				 strcpy(c_team, "2");
			 }
			 pBot->start_action = MSG_FLF_IDLE;
			 pBot->start_action_time = 0;
			 FakeClientCommand(pBot->pEdict, "jointeam %s", c_team);
		 } 
		 else if (pBot->start_action == MSG_FLF_CLASS_SELECT)
		 {
			 char buffer[32];

			 if (pBot->bot_class < 1 || pBot->bot_class > 3)
			 { // valid team
				 pBot->bot_class = RANDOM_LONG(1,3);
			 }

			 if (pBot->bot_team == 1) 
			 {
				 if (pBot->bot_class == 1) 
				 {
				   strcpy(buffer, "rebelsrecon");
				 }
				 else if (pBot->bot_class == 2) 
				 {
					 strcpy(buffer, "rebelsassault");
				 }
				 else
				 {
					 strcpy(buffer, "rebelssupport");
				 }
			 } 
			 else 
			 { //team 2
			   pBot->bot_team = 2; //to be sure to be sure
				 if (pBot->bot_class == 1) 
				 {
				   strcpy(buffer, "commandosrecon");
				 } 
				 else if (pBot->bot_class == 2) 
				 {
					 strcpy(buffer, "commandosassault");
				 }
				 else 
				 {
					 strcpy(buffer, "commandossupport");
				 }
			 }
			 pBot->start_action = MSG_FLF_IDLE;
			 FakeClientCommand(pBot->pEdict, buffer);
		 } 
		 else if (pBot->start_action == MSG_FLF_PISTOL_SELECT) 
		 {//buy a pistol
			 char num[4];
			 if (RANDOM_LONG(0,100) <=50) 
			 {
				 strcpy(num, "23");
			 }
			 else 
			 {
				 strcpy(num, "26");
			 }
			 pBot->start_action = MSG_FLF_IDLE;
			 FakeClientCommand(pBot->pEdict, "pistols %s", num);
		 } 
		 else if (pBot->start_action == MSG_FLF_WEAPON_CLASS_SELECT) 
		 {
			 char buffer[80];
			 int weapon=-1;
			 bool gotWeapon = FALSE;
			 if (pBot->bot_class == FLF_CLASS_RECON || pBot->bot_class == FLF_CLASS_ASSAULT) 
			 {
				 if (!pBot->weapon_classes[2]) 
				 {
					 weapon = 2;
				 }
			 } 
			 else if (pBot->bot_class == FLF_CLASS_SUPPORT) 
			 {
				 if (!pBot->weapon_classes[2]) 
				 {
					 weapon = 3;
				 }
			 }
			 if (weapon == -1) 
			 {
			 	 weapon = RANDOM_LONG(0,1);
			 }
			 switch(weapon) 
			 {
				 case 0: strcpy(buffer, "shotgun"); break;
				 case 1: strcpy(buffer, "submachine"); break;
				 case 2: strcpy(buffer, "rifles"); break;
				 case 3: strcpy(buffer, "heavyweapons"); break;
			 }
			 if (weapon == 3) weapon--; // heavy or rifle
			 pBot->weapon_classes[weapon] = TRUE; //got one of these now
			 //fp = fopen("bot.txt", "a"); fprintf(fp,"My weapon is: %d used is: ", weapon);
			 for (weapon = 0; weapon < 3; weapon++) 
			 {
				 //fprintf(fp, "%d ");
			 }
			 //fprintf(fp, "\n"); fclose(fp);
			 pBot->start_action = MSG_FLF_IDLE;
			 FakeClientCommand(pBot->pEdict, "wpnclass %s", buffer);
		 } 
		 else if (pBot->start_action == MSG_FLF_HEAVY_SELECT) 
		 {
			 int count = 0, i =0;
			 pBot->start_action = MSG_FLF_IDLE;
			 FakeClientCommand(pBot->pEdict, "heavyweapons 29");
			 for (i = 0; i < 3; i++)
			 {
				 if (pBot->weapon_classes[i]) count++;
			 }
			 if (count >= 2)
			 { //selected 2 guns
				 pBot->not_started = 0;
			 }
		 } 
		 else if (pBot->start_action == MSG_FLF_SHOTGUN_SELECT) 
		 {
			 int count = 0, i =0;
			 char num[4];
			 pBot->start_action = MSG_FLF_IDLE;
			 switch(RANDOM_LONG(0,1)) {
				 case 0: strcpy(num, "11"); break;
				 case 1: strcpy(num, "22"); break;
			 }
			 FakeClientCommand(pBot->pEdict, "shotgun %s", num);
			 for (i = 0; i < 3; i++)
			 {
				 if (pBot->weapon_classes[i]) count++;
			 }
			 if (count >= 2)
			 { //selected 2 guns
				 pBot->not_started = 0;
			 }
		 }
		 else if (pBot->start_action == MSG_FLF_SUB_SELECT) 
		 {
			 int count = 0, i =0;
			 char num[4];
			 pBot->start_action = MSG_FLF_IDLE;
			 switch(RANDOM_LONG(0,3)) {
				 case 0: strcpy(num, "16"); break;
				 case 1: strcpy(num, "20"); break;
				 case 2: strcpy(num, "25"); break;
				 case 3: strcpy(num, "21"); break;
			 }
			 FakeClientCommand(pBot->pEdict, "submach %s", num); // 20 or 25
			 for (i = 0; i < 3; i++) {
				 if (pBot->weapon_classes[i]) count++;
			 }
			 if (count >= 2) { //selected 2 guns
				 pBot->not_started = 0;
			 }
		 }
		 else if (pBot->start_action == MSG_FLF_RIFLE_SELECT)
		 {
			 int count = 0, i =0;
			 char num[4];
			 pBot->start_action = MSG_FLF_IDLE;
			 if (pBot->bot_class == FLF_CLASS_RECON)
			 {
				 switch(RANDOM_LONG(0,1)) 
				 {
					 case 0: strcpy(num, "9"); break;
					 case 1: strcpy(num, "27"); break;
				 }
			 } 
			 else
			 {
				 switch (RANDOM_LONG(0,2))
				 {
					 case 0: strcpy(num, "10"); break;
					 case 1: strcpy(num, "17"); break;
					 case 2: strcpy(num, "28"); break;
				 }
			 }

			 FakeClientCommand(pBot->pEdict, "rifles %s", num);
			 for (i = 0; i < 3; i++) 
			 {
				 if (pBot->weapon_classes[i]) count++;
			 }
			 if (count >= 2) 
			 { //selected 2 guns
				 pBot->not_started = 0;
			 }
		 }
	 }
   else
   {
      // otherwise, don't need to do anything to start game...
      pBot->not_started = 0;
   }
}


int BotInFieldOfView(bot_t *pBot, Vector dest)
{
   // find angles from source to destination...
   Vector entity_angles = UTIL_VecToAngles( dest );

   // make yaw angle 0 to 360 degrees if negative...
   if (entity_angles.y < 0)
      entity_angles.y += 360;

   // get bot's current view angle...
   float view_angle = pBot->pEdict->v.v_angle.y;

   // make view angle 0 to 360 degrees if negative...
   if (view_angle < 0)
      view_angle += 360;

   // return the absolute value of angle to destination entity
   // zero degrees means straight ahead,  45 degrees to the left or
   // 45 degrees to the right is the limit of the normal view angle

   // rsm - START angle bug fix
   int angle = abs((int)view_angle - (int)entity_angles.y);

   if (angle > 180)
      angle = 360 - angle;

   return angle;
   // rsm - END
}


bool BotEntityIsVisible( bot_t *pBot, Vector dest, edict_t * pEnt)
{
   TraceResult tr;

   // trace a line from bot's eyes to destination...
   UTIL_TraceLine( pBot->pEdict->v.origin + pBot->pEdict->v.view_ofs,
                   dest, ignore_monsters,
                   pBot->pEdict->v.pContainingEntity, &tr );

   // check if line of sight to object is not blocked (i.e. visible)
   if (tr.flFraction >= 1.0 || tr.pHit == pEnt && pEnt != NULL)
      return TRUE;
   else
      return FALSE;
}


void BotThink( bot_t *pBot )
{
	int index = 0;
	Vector v_diff;             // vector from previous to current location
	float yaw_degrees;
	float moved_distance;      // length of v_diff vector (distance bot moved)
	TraceResult tr;
	bool found_waypoint=FALSE;
	bool found_enemy = FALSE;
	bool turning = FALSE;

	edict_t *pEdict = pBot->pEdict;
	edict_t *pAvoid = NULL;
	
	pBot->stopped = FALSE; // unstop the bot

	pEdict->v.flags |= FL_FAKECLIENT;
	
	if (pBot->name[0] == 0)  // name filled in yet?
		strcpy(pBot->name, STRING(pBot->pEdict->v.netname));

/*
	if (pBot->voting) {
		char vote[3];
		switch(RANDOM_LONG(1,4)) {
		case 1: strcpy(vote, "1"); break;
		case 2: strcpy(vote, "2"); break;
		case 3: strcpy(vote, "3"); break;
		case 4: strcpy(vote, "4"); break;
		}
	FakeClientCommand(pBot->pEdict, "menuselect %s", vote);
	}
*/


// TheFatal - START from Advanced Bot Framework (Thanks Rich!)

   // adjust the millisecond delay based on the frame rate interval...
   if (pBot->msecdel <= gpGlobals->time)
   {
      pBot->msecdel = gpGlobals->time + 0.5;
      if (pBot->msecnum > 0)
         pBot->msecval = 450.0/pBot->msecnum;
      pBot->msecnum = 0;
   }
   else
      pBot->msecnum++;

   if (pBot->msecval < 5)    // don't allow msec to be less than 5...
      pBot->msecval = 5;

   if (pBot->msecval > 100)  // ...or greater than 100
      pBot->msecval = 100;

// TheFatal - END
#ifdef _DEBUG
	if (pBot->debug)
	{
		assert(FALSE);
		if (0) pBot->debug = FALSE;
	}
#endif

   pEdict->v.button = 0;
   pBot->f_move_speed = 0.0;
	pBot->last_strafe_speed = pBot->f_strafe_speed;
	 pBot->f_strafe_speed = 0.0;
	 //pEdict->v.v_angle.x = 0.0;
	 //pEdict->v.angles.x = 0.0;

   // if the bot hasn't selected stuff to start the game yet, go do that...
   if (pBot->not_started)
   {
      BotStartGame( pBot );

      g_engfuncs.pfnRunPlayerMove( pEdict, pEdict->v.v_angle, 0.0,
                                   0, 0, pEdict->v.button, 0, pBot->msecval);

      return;
   }

   if (pBot->bot_health == -1)
   {
	   pBot->bot_health = pEdict->v.health;
	   pBot->bot_armor = pEdict->v.armorvalue;
   }

   if (pBot->behaviour == BEHAVE_FOLLOW)
   {
	   if (!pBot->commander || !IsAlive(pBot->commander))
	   {
		   pBot->behaviour = BEHAVE_NONE;
		   pBot->commander = NULL;
	   }
   }

   if ((pEdict->v.health < 1) || (pEdict->v.deadflag != DEAD_NO))
   {
     if (pBot->need_to_initialize) {
			 if (loss_used > -1) {
					if (pBot->pKiller != NULL) {
				 		if (RANDOM_LONG(0,100) < bot_chat_freq) {
						 if (strcmp(STRING(pBot->pKiller->v.classname), "player") == 0) {
					     char buffer[256];
					     sprintf(buffer, bot_loss[RANDOM_LONG(0,loss_used)], STRING(pBot->pKiller->v.netname));
				 	     //UTIL_SayText(buffer, pBot->pEdict,FALSE);
						 BotSayText(pBot, buffer, RANDOM_FLOAT(1.5,5), FALSE, FALSE);
						 }
					 }
				 }
			 }
		     BotSpawnInit(pBot);
			 if (mod_id == SI_DLL) pBot->f_click_time = gpGlobals->time + 15;
		 }
		
		 if (pBot->f_click_time < gpGlobals->time)
		 {
			 if (RANDOM_LONG(0,100) < 50)
			 {
				pEdict->v.button |= IN_ATTACK;
				if (mod_id == SI_DLL) pBot->f_click_time = gpGlobals->time + 5;
			 }
			 g_engfuncs.pfnRunPlayerMove( pEdict, pEdict->v.v_angle, pBot->f_move_speed,
                                   0, 0, pEdict->v.button, 0, pBot->msecval);
		 }

		pBot->was_alive = FALSE;


      return;
   }

	 if ((mod_id == FLF_DLL) && (pBot->round_end)) {
		 BotRespawnInit(pBot, FALSE);
	 }

   v_diff = pBot->v_prev_origin - pEdict->v.origin;
   moved_distance = v_diff.Length();
	if (moved_distance > 300 && pBot->was_alive) { //start of a new round of some description
	 	BotRespawnInit(pBot, TRUE);
	}
	pBot->was_alive = TRUE;

   // save current position as previous
   pBot->v_prev_origin = pEdict->v.origin;
   // set this for the next time the bot dies so it will initialize stuff
   pBot->need_to_initialize = TRUE;


   pBot->f_move_speed = pBot->f_max_speed;  // set to max speed

	 if (pBot->pSentry != NULL) {
		 if ((pBot->pSentry->v.deadflag != DEAD_NO) || (pBot->pSentry->v.effects & EF_NODRAW) || (pBot->pSentry->v.solid == SOLID_NOT) || (pBot->pSentry->free) ) {
			 pBot->pSentry = NULL;
		 }
	 }

	 if (pBot->pDispenser != NULL) {
		 if ((pBot->pDispenser->v.deadflag != DEAD_NO) || (pBot->pDispenser->v.effects & EF_NODRAW) || (pBot->pDispenser->v.solid == SOLID_NOT) || (pBot->pDispenser->free) ) {
			 pBot->pDispenser = NULL;
		 }
	 }

	 if (pBot->pBotEnemy != NULL && pBot->pBotEnemy->v.deadflag != DEAD_NO) {
		 if (victory_used > -1) {
	 		 if (RANDOM_LONG(0,100) < bot_chat_freq) {
			 	if (strcmp(STRING(pBot->pBotEnemy->v.classname), "player")==0) {
			 		char buffer[256];
					sprintf(buffer, bot_victory[RANDOM_LONG(0, victory_used)], STRING(pBot->pBotEnemy->v.netname));
					 BotSayText(pBot, buffer, RANDOM_FLOAT(1.5,5), FALSE, FALSE);
					//UTIL_SayText(buffer, pBot->pEdict, FALSE);
			 	}
			 }
		 }
		 pBot->pBotEnemy = NULL;
		 pBot->f_see_enemy_time = 0;
	 }

	 if (pBot->grenadeTime < gpGlobals->time && pBot->grenadeTime != 0) {
		 if (pBot->grenadeNum == 0) {
			 pBot->grenadeTime = 0;
		 } else {
			 if (pBot->grenadeNum == 1) {
				 FakeClientCommand(pBot->pEdict, "-gren1 102");
			 } else if (pBot->grenadeNum == 2) {
				 FakeClientCommand(pBot->pEdict, "-gren2 103");
			 }
			 pBot->grenadeNum = 0;
			 pBot->grenadeTime = gpGlobals->time + RANDOM_FLOAT(5,15);
		 }
	 }

	 if (pBot->f_detonate_dispenser_time > gpGlobals->time)
	 {
		 FakeClientCommand(pEdict, "detdispenser");
		 pBot->f_detonate_dispenser_time = 0.0;
	 }

	 if (pBot->pChatMessages && pBot->f_chat_time < gpGlobals->time)
	 {
		 BotChat(pBot);
	 }

   // see how far bot has moved since the previous position...

	 /*
	 if (pBot->view_target.Length() > 1.0) {
	   pEdict->v.ideal_yaw = UTIL_VecToAngles(pBot->view_target- pEdict->v.origin).y;
	 	 BotFixIdealYaw(pEdict);
	 }
	 */

	 	/*
		if(pBot->currentPoint > -1) {
			int waypoint_position;
	 		float angle = UTIL_VecToAngles(waypoints[pBot->currentPoint].origin - pBot->pEdict->v.origin).y;
	 		angle -= pBot->pEdict->v.angles.y;
	 		while (angle > 180) angle -= 360;
	 		while (angle < -180) angle += 360;
	 		if (angle > 90 || angle < -90) {
	 			waypoint_position = POSITION_BEHIND;
	 			if (RANDOM_LONG(1,50)) UTIL_SayText("Postion behind!!", pBot->pEdict, FALSE);
	 		} else {
	 			waypoint_position = POSITION_FRONT;
	 			if (RANDOM_LONG(0,50) == -1) UTIL_SayText("Postion front!!", pBot->pEdict, FALSE);
	 		}
	 	}
		*/


   // turn towards ideal_yaw by yaw_speed degrees
	 //int degrees_to_turn = (int)(DEGREES_PER_MSEC * pBot->msecval);
   //yaw_degrees = BotChangeYaw( pBot, pEdict->v.yaw_speed );
	 yaw_degrees = BotChangeYaw(pBot, DEGREES_PER_MSEC * pBot->msecval);

   if (yaw_degrees >= pEdict->v.yaw_speed)
   {
      pBot->f_move_speed = 0.0;  // don't move while turning a lot
			turning = TRUE;
   }
   else if (yaw_degrees >= 10)   // turning more than 10 degrees?
   {
      pBot->f_move_speed = pBot->f_ideal_speed / 4;  // slow down while turning
			turning = TRUE;
   }
	 if (!turning) {
		 pBot->f_ideal_speed = pBot->f_max_speed;
	 	 pBot->view_target= Vector(0,0,0);

	 	 if (pBot->flashTime > gpGlobals->time) {
			 pBot->pEdict->v.ideal_yaw += RANDOM_LONG(-30,30);
			 if (RANDOM_LONG(0,100) < 10) {
			 	 pBot->pEdict->v.button |= IN_ATTACK;
			 }
		   pBot->stateTime = 0;
		   BotFixIdealYaw(pBot->pEdict);
			 turning = TRUE;
	   }
	 }
	 if (!turning)
	 {
		 if (!pBot->pBotEnemy)
		 {
			edict_t * newEnemy = BotFindEnemy( pBot );
			if (newEnemy != NULL)
			{
				 pBot->pBotEnemy = newEnemy;
				pBot->view_target = pBot->pBotEnemy->v.origin;
			}
		 }

	      if (pBot->pBotEnemy != NULL)  // does an enemy exist?
	      {
			  if ( BotShootAtEnemy(pBot)) // shoot at the enemy
			  {
				  if (pBot->pBotEnemy != NULL) CombatMove(pBot);
			  }
			  else
			  {
				  if (pBot->pBotEnemy != NULL) TakeCover(pBot);
			  }
			  found_enemy = (pBot->pBotEnemy != NULL);
		  }
		  if (mod_id == TFC_DLL)
		  {
			  if (found_enemy)
			{
			  if ((pBot->bot_class != TFC_CLASS_SPY) || (UTIL_GetTeam(pEdict) == UTIL_GetSpyTeam(pEdict)))
			  {
				  BotThrowGrenade(pBot);
			  }
		  }
	  }
		/*
		pAvoid = BotGetAvoidEntity(pBot);
		if (pAvoid)
		{
			BotMoveAvoidEntity(pBot, pAvoid);
		}
		*/

			if (mod_id == TFC_DLL && pBot->bot_class == TFC_CLASS_SPY)
			{
				if (pBot->dont_disguise_time < gpGlobals->time)
				{
					if (UTIL_GetSpyTeam(pEdict) == UTIL_GetTeam(pEdict))
					{
						char spy_class[3] = "1";
						sprintf(spy_class, "%d", RANDOM_LONG(1,6));
						FakeClientCommand(pEdict, "disguise_enemy %s", spy_class);
					}
					pBot->dont_disguise_time = gpGlobals->time + 10;
				}
			}

		 if (pBot->state == STATE_WAITING || pBot->state == STATE_GUARDING || pBot->state == STATE_DOORS_OPEN) {
			 if (pBot->stateTime < gpGlobals->time) { //stop waiting if it's time
			 	 if (pBot->state == STATE_DOORS_OPEN) {
					 pBot->destination = -1;
				 }
				 pBot->state = STATE_NONE;
				 pBot->stateTime = 0;
			 }
		 }


		 if (mod_id == TFC_DLL && pBot->bot_health < BotMaxHealth(pBot)/2) {
			 if (RANDOM_LONG(0,10000) < 3) {
			 	FakeClientCommand(pEdict, "saveme");
			 }
		 }

		 if (pBot->stateTime > gpGlobals->time) 
		 {
			 if (pBot->state == STATE_SNIPING) 
			 {
				 if (mod_id == FLF_DLL || pBot->bot_health > BotMaxHealth(pBot)/2) 
				 { // should we still be sniping ??
					 pBot->stopped = TRUE;
					 if (!found_enemy) {
						 //pBot->pEdict->v.ideal_yaw = pBot->pEdict->v.v_angle.y+3;
					 	 //BotFixIdealYaw(pBot->pEdict);
					 }
					 pBot->f_move_speed = 0;
					 pBot->f_strafe_speed = 0;
					 found_waypoint = TRUE;
					 //UTIL_ClientPrintAll( HUD_PRINTNOTIFY, "I am, I am\n");
				 }
				 else 
				 {
					 pBot->state = STATE_NONE;
				 }
			 } 
			 else if (pBot->state == STATE_BUILDING_SENTRY) 
			 {
				 //UTIL_ClientPrintAll(HUD_PRINTNOTIFY, "Building a sentry...\n");
				 edict_t *pent = NULL;
				 bool ok = TRUE;
				 while ( (pent = UTIL_FindEntityInSphere(pent, pEdict->v.origin, 200)) != NULL) 
				 {
					 if (strcmp(STRING(pent->v.classname), "building_sentrygun") == 0) 
					 {
						 ok = FALSE;
						 break;
					 }
					 if (strcmp(STRING(pent->v.classname), "building_sentrygun_base") == 0) 
					 {
						 ok = FALSE;
						 break;
					 }
				 }
				 if (ok) 
				 {
				 	 FakeClientCommand(pBot->pEdict, "build 2");
				   pBot->state = STATE_WAITING;
				   pBot->stateTime = gpGlobals->time+5; //wait for 5 secs
				   found_waypoint = TRUE;
				 } 
				 else
				 {
					 pBot->state = STATE_NONE;
					 pBot->stateTime = 0;
				 }
			 } 
			 else if (pBot->state == STATE_BUILDING_DISPENSER) 
			 {
				 edict_t *pent = NULL;
				 bool ok = TRUE;
				 while ( (pent = UTIL_FindEntityInSphere(pent, pEdict->v.origin, 200)) != NULL) 
				 {
					 if (strcmp(STRING(pent->v.classname), "building_dispenser") == 0) 
					 {
						 ok = FALSE;
						 break;
					 }
				 }
				 if (ok) {
				 	 FakeClientCommand(pBot->pEdict, "build 1");
				   pBot->state = STATE_WAITING;
				   pBot->stateTime = gpGlobals->time+3;
				   found_waypoint = TRUE;
				 } else {
					 pBot->state = STATE_NONE;
					 pBot->stateTime = 0;
				 }
			 } else if (pBot->state == STATE_DETPACKING) {
				 //UTIL_ClientPrintAll(HUD_PRINTNOTIFY, "Setting a detpack...\n");
				 pBot->detpack = FALSE;
				 FakeClientCommand(pBot->pEdict, "detstart 5");
				 pBot->state = STATE_WAITING;
				 pBot->stateTime = gpGlobals->time+5; //wait for 5 secs
				 found_waypoint = TRUE;
			 } else if (pBot->state == STATE_WAITING) {
				 pBot->f_move_speed = 0;
				 pBot->f_strafe_speed = 0;
				 found_waypoint = TRUE;
			 }
		 }

		 if (!found_enemy) {
				//reload if we need to
				if (pBot->current_weapon.iClip < 1 ) {
					pBot->pEdict->v.button |= IN_RELOAD;
				}
				pBot->weaponChargeTime = 0; // stop charging
         // no enemy, let's just wander around...

         pEdict->v.v_angle.z = 0;  // reset roll to 0 (straight up and down)

         // set body angles to match view angles...
         pEdict->v.angles.x = 0;
         pEdict->v.angles.y = pEdict->v.v_angle.y;
         pEdict->v.angles.z = 0;

  			 if (!found_waypoint) 
			 {
					 found_waypoint = BotFindInteresting(pBot);
				 }
				 if (pBot->behaviour == BEHAVE_FOLLOW && !found_waypoint) 
				 {
		 			 int distance = (pBot->pEdict->v.origin - pBot->commander->v.origin).Length();
		 			 bool cansee = FALSE;
	 				 TraceResult tr;
	 				 UTIL_TraceLine(pBot->pEdict->v.origin, pBot->commander->v.origin, ignore_monsters, pBot->pEdict, &tr);
	 				 if (tr.flFraction >= 1.0) {
	 					 cansee = TRUE;
	 				 } else {
	 					 cansee = FALSE;
	 				 }
		 			 if (cansee) 
					 {
						 if (distance < 150)
						 {
			 				 pBot->pEdict->v.ideal_yaw = pBot->commander->v.v_angle.y;
							 pBot->pEdict->v.v_angle.x = pBot->commander->v.v_angle.x;
			 				 pBot->f_move_speed = 0;
			 				 pBot->f_strafe_speed = 0;
							 pBot->stopped = TRUE;
						 } 
						 else
						 {
							 pBot->pEdict->v.ideal_yaw = UTIL_VecToAngles((pBot->commander->v.origin - pBot->pEdict->v.origin)).y;
						 }
		 				 BotFixIdealYaw(pBot->pEdict);
		 				 found_waypoint = TRUE;
		 			 } 
					 else 
					 {
		 				 int dest = WaypointFindNearest(pBot->commander, 400, Waypoint_GetTeam(pBot) );
		 				 if (!(BotHeadTowardWaypoint(pBot)) ) 
						 {
		 					 UTIL_SayText("Negative, i cannot follow.\n", pBot->pEdict, FALSE);
		 				 } 
						 else 
						 {
		 					 found_waypoint = TRUE;
		 				 }
		 				 if (dest != pBot->destination) 
						 {
							 /*
							 if (RANDOM_LONG(0, 100) == 0)
							 {
		 					 	UTIL_SayText("Roger that, following you.\n", pBot->pEdict, FALSE);
							 }
							 */
		 					 pBot->destination = dest;
		 					 pBot->waypoints_upto = -1;
		 				 }
		 			 }
		 		 }
   			 if (!found_waypoint) 
			 {
         		found_waypoint = BotHeadTowardWaypoint(pBot);
			 }
				 if (!pBot->stopped && moved_distance <= 1.0 && pBot->prev_speed >= 1.0 && (pBot->pEdict->v.movetype != MOVETYPE_FLY)) {
					 Vector forward, right, current, origin, head;
					 TraceResult originTrace, headTrace, rightTrace, leftTrace;
					 bool originClear, headClear, leftClear, rightClear;
					 origin = pBot->pEdict->v.origin;
					 if (pBot->pEdict->v.flags & FL_DUCKING) {
					 	 origin.z -=9; // origin is now at feet
					 } else {
						 origin.z -=18; // origin is now at feet
					 }
					 if (pEdict->v.movetype == MOVETYPE_FLY)
					 {
						 pEdict->v.button |= IN_JUMP;
					 }
				   if (RANDOM_LONG(1,1000) <= 1) {
					   pBot->currentPoint = pBot->lastpoint;
					   pBot->lastpoint = -1;
				   }
					 head = GetGunPosition(pBot->pEdict)-origin;
					 UTIL_MakeVectors(pBot->pEdict->v.v_angle);
					 forward = gpGlobals->v_forward;
					 right = gpGlobals->v_right;
					 current = (50 * forward) + origin;
					 UTIL_TraceLine(origin, current, dont_ignore_monsters, pBot->pEdict, &originTrace);
					 UTIL_TraceLine(origin+head, current+head, dont_ignore_monsters, pBot->pEdict, &headTrace);
					 current = (50 * right) + origin;
					 UTIL_TraceLine(origin, current, dont_ignore_monsters, pBot->pEdict, &rightTrace);
					 current = (-50 * right) + origin;
					 UTIL_TraceLine(origin, current, dont_ignore_monsters, pBot->pEdict, &leftTrace);
					 originClear = NavIsClear(pBot, originTrace); //originTrace.flFraction >=1.0;
					 headClear = NavIsClear(pBot, headTrace); //originTrace.flFraction >=1.0;
					 leftClear = NavIsClear(pBot, leftTrace); //originTrace.flFraction >=1.0;
					 rightClear = NavIsClear(pBot, rightTrace); //originTrace.flFraction >=1.0;
					 /*
					 headClear = headTrace.flFraction >=1.0;
					 leftClear = leftTrace.flFraction >=1.0;
					 rightClear = rightTrace.flFraction >=1.0;
					 */
					 if (!originClear && headClear) {
						 pBot->pEdict->v.button |= IN_JUMP; //jump over the obstacle
						 pBot->crouchTime = gpGlobals->time + 0.7;
						 pBot->f_move_speed = pBot->f_max_speed;
						 pBot->f_strafe_speed = 0;
					 } else if (leftClear && rightClear) {
						 pBot->f_move_speed = 0;
						 pBot->f_strafe_speed = pBot->f_max_speed; //go right - less collisions with other bots
					 } else if (leftClear) {
						 pBot->f_move_speed = 0;
						 pBot->f_strafe_speed = -(pBot->f_max_speed);
					 } else if (rightClear) {
						 pBot->f_move_speed = 0;
						 pBot->f_strafe_speed = (pBot->f_max_speed);
					 } else {
					   if (RANDOM_LONG(1,1000) <= 1) {
						   pBot->currentPoint = pBot->lastpoint;
						   pBot->lastpoint = -1;
					   } else {
					 	 	 if (RANDOM_LONG(1, 100) <= 10) {
							   pBot->pEdict->v.ideal_yaw+=RANDOM_LONG(150,210);
						   } else {
							   pBot->pEdict->v.ideal_yaw+=RANDOM_LONG(30,60);
						   }
					   }
					   BotFixIdealYaw(pBot->pEdict);
					   if (RANDOM_LONG(0,100) < 20) pBot->pEdict->v.button |= IN_JUMP; // jump sometimes
				   }
				 }
				 if (!found_waypoint && pBot->pEdict->v.movetype == MOVETYPE_FLY) {
					 // go up the ladder
					 //UTIL_ClientPrintAll( HUD_PRINTCENTER, "I'm on a ladder\n"); //, param1, param2, param3, param4 );
					 pBot->pEdict->v.v_angle.x=-50;
 	 				 pBot->pEdict->v.button |= IN_FORWARD;
					 found_waypoint = TRUE;
				 }

         // if the bot isn't headed toward a waypoint...
         if (found_waypoint == FALSE)
         {
            // check if the bot hasn't moved much since the last location
            if ((moved_distance <= 1.0) && (pBot->prev_speed >= 1.0) && (pBot->pEdict->v.movetype != MOVETYPE_FLY))
            {
               // the bot must be stuck!
               pBot->f_move_speed = 0;  // don't move while turning

               if (RANDOM_LONG(1, 100) <= 10)
               {
                  // 10 percent of the time turn completely around...
                  pBot->pEdict->v.ideal_yaw += 180;
               }
               else
               {
                  // turn randomly between 30 and 60 degress
                  if (RANDOM_LONG(1, 100) <= 50)
                     pBot->pEdict->v.ideal_yaw += RANDOM_LONG(30, 60);
                  else
                     pBot->pEdict->v.ideal_yaw -= RANDOM_LONG(30, 60);
               }

               BotFixIdealYaw(pBot->pEdict);
            }
         }
      }
   }

	 //pBot->f_move_speed = pBot->f_max_speed;

   if (pBot->f_pause_time > gpGlobals->time)  // is the bot "paused"?
      pBot->f_move_speed = 0;  // don't move while pausing

   // make the body face the same way the bot is looking
   pEdict->v.angles.y = pEdict->v.v_angle.y;

   // save the previous speed (for checking if stuck)
   pBot->prev_speed = pBot->f_move_speed;

	 if(pBot->pEdict->v.movetype == MOVETYPE_FLY) {
		 pBot->pEdict->v.button |= IN_FORWARD;
	 }

	 //pBot->f_strafe_speed = pBot->f_max_speed; //strafe positive is right
	 if ( pBot->f_move_speed != 0.0 && pBot->f_strafe_speed != 0 ) {
		 Vector v_current = Vector(pBot->f_move_speed, pBot->f_strafe_speed, 0), v_unit, v_result;
		 Vector v_angle = UTIL_VecToAngles(v_current);
		 float newLen;
		 UTIL_MakeVectors(v_angle);
		 v_unit = gpGlobals->v_forward;
		 if (v_current.Length() > pBot->f_max_speed) {
			 newLen = pBot->f_max_speed;
		 } else {
			 newLen = v_current.Length();
		 }
		 v_result = v_unit*newLen;
		 pBot->f_move_speed = v_result.x;
		 pBot->f_strafe_speed = v_result.y;
	 }

	 if (pBot->crouchTime > gpGlobals->time) {
		 pBot->pEdict->v.button |= IN_DUCK;
	 }

	 pEdict->v.v_angle= pEdict->v.v_angle + pEdict->v.punchangle;
	 if (pBot->pEdict->v.v_angle.x > 180) pBot->pEdict->v.v_angle.x -= 360;
	 if (pBot->pEdict->v.v_angle.x < -180) pBot->pEdict->v.v_angle.x += 360;
	 if (pBot->pEdict->v.v_angle.x > 89.9) pBot->pEdict->v.v_angle.x = 89.9;
	 if (pBot->pEdict->v.v_angle.x < -89.9) pBot->pEdict->v.v_angle.x = -89.9;
	 pBot->pEdict->v.angles.x = pBot->pEdict->v.v_angle.x/-3.0;

   g_engfuncs.pfnRunPlayerMove( pEdict, pEdict->v.v_angle, pBot->f_move_speed,
                                pBot->f_strafe_speed, 0, pEdict->v.button, 0, pBot->msecval);

   return;
}

void HandleKeyValueData(edict_t * pent, KeyValueData *pkvd) {
	//char	*szClassName;	// in: entity classname
	//char	*szKeyName;		// in: name of key
	//char	*szValue;		// in: value of key
	int val=-100;
	if (pkvd->szClassName == NULL) return;
	if (strcmp(pkvd->szClassName, "info_tfgoal_timer") != 0)
	{
		if (strcmp(pkvd->szKeyName, "goal_result") == 0)
		{
			val = atoi(pkvd->szValue);
			if (val & 64)
			{
				tf_map.resetSentries = TRUE;
			}
		}
	}

	if (strcmp("info_tfdetect", pkvd->szClassName)==0) { //not a match
		//fp = fopen("bot.txt", "a"); fprintf(fp,"Key: %s Value: %s\n", pkvd->szKeyName, pkvd->szValue); fclose(fp);
		if (strcmp(pkvd->szKeyName, "maxammo_shells") == 0) {
			sscanf(pkvd->szValue, "%d", &val);
			tf_data[0].available_classes = val;
			return;
		}
		if (strcmp(pkvd->szKeyName, "maxammo_nails") == 0) {
			sscanf(pkvd->szValue, "%d", &val);
			tf_data[1].available_classes = val;
			//tf_available_classes[1] = val;
			return;
		}
		if (strcmp(pkvd->szKeyName, "maxammo_rockets") == 0) {
			sscanf(pkvd->szValue, "%d", &val);
			tf_data[2].available_classes = val;
			//tf_available_classes[2] = val;
			return;
		}
		if (strcmp(pkvd->szKeyName, "maxammo_cells") == 0) {
			sscanf(pkvd->szValue, "%d", &val);
			tf_data[3].available_classes = val;
			//tf_available_classes[3] = val;
			return;
		}
		if (strcmp(pkvd->szKeyName, "ammo_medikit") == 0) {
			sscanf(pkvd->szValue, "%d", &val);
			//tf_max_players[0] = val;
			tf_data[0].max_players = val;
			return;
		}
		if (strcmp(pkvd->szKeyName, "ammo_detpack") == 0) {
			sscanf(pkvd->szValue, "%d", &val);
			tf_data[1].max_players = val;
			//tf_max_players[1] = val;
			return;
		}
		if (strcmp(pkvd->szKeyName, "maxammo_medikit") == 0) {
			sscanf(pkvd->szValue, "%d", &val);
			tf_data[2].max_players = val;
			//tf_max_players[2] = val;
			return;
		}
		if (strcmp(pkvd->szKeyName, "maxammo_detpack") == 0) {
			sscanf(pkvd->szValue, "%d", &val);
			tf_data[3].max_players = val;
			//tf_max_players[3] = val;
			return;
		}
		if (strcmp(pkvd->szKeyName, "team1_allies") == 0) {
			sscanf(pkvd->szValue, "%d", &val);
			tf_data[0].allies = val;
			//tf_allies[0] = val;
			return;
		}
		if (strcmp(pkvd->szKeyName, "team2_allies") == 0) {
			sscanf(pkvd->szValue, "%d", &val);
			tf_data[1].allies = val;
			//tf_allies[1] = val;
			return;
		}
		if (strcmp(pkvd->szKeyName, "team3_allies") == 0) {
			sscanf(pkvd->szValue, "%d", &val);
			tf_data[2].allies = val;
			//tf_allies[2] = val;
			return;
		}
		if (strcmp(pkvd->szKeyName, "team4_allies") == 0) {
			sscanf(pkvd->szValue, "%d", &val);
			//tf_allies[3] = val;
			tf_data[3].allies = val;
			return;
		}
	} else if (strcmp("i_p_t", pkvd->szClassName)==0 || strcmp("info_player_teamspawn", pkvd->szClassName)==0) {
		if (strcmp(pkvd->szKeyName, "team_no") == 0) {
			//sscanf(pkvd->szValue, "%d", &val);
			val = atoi(pkvd->szValue);
			//tf_available_teams[val-1] = TRUE;
			tf_data[val-1].available_teams = TRUE;
			return;
		}
	} 
	else if (strcmp("info_tfgoal", pkvd->szClassName) == 0) 
	{
		if (strcmp(pkvd->szKeyName, "team_no") == 0) 
		{
			pent->v.team = atoi(pkvd->szValue);
		}
//		if (FStrEq("models/backpack.mdl", STRING(pent->v.model)))
//		{
			TF_BackPack *pack = GetBackPack(pent, TRUE);
			if (pack)
			{
				if (FStrEq(pkvd->szKeyName, "a_s") || FStrEq(pkvd->szKeyName, "ammo_shells"))
				{
					pack->shells = atoi(pkvd->szValue);
				}
				else if(FStrEq(pkvd->szKeyName, "a_n") || FStrEq(pkvd->szKeyName, "ammo_nails"))
				{
					pack->nails = atoi(pkvd->szValue);
				}
				else if(FStrEq(pkvd->szKeyName, "a_r")|| FStrEq(pkvd->szKeyName, "ammo_rockets"))
				{
					pack->rockets = atoi(pkvd->szValue);
				}
				else if(FStrEq(pkvd->szKeyName, "a_c") || FStrEq(pkvd->szKeyName, "ammo_cells"))
				{
					pack->cells = atoi(pkvd->szValue);
				}
				else if(FStrEq(pkvd->szKeyName, "ammo_detpack"))
				{
					pack->detpack = atoi(pkvd->szValue);
				}
				else if(strcmp(pkvd->szKeyName, "no_grenades_1") == 0)
				{
					pack->gren1 = atoi(pkvd->szValue);
				}
				else if(strcmp(pkvd->szKeyName, "no_grenades_2")==0)
				{
					pack->gren2 = atoi(pkvd->szValue);
				}
				else if (strcmp(pkvd->szKeyName, "health") == 0)
				{
					pack->health = atoi(pkvd->szValue);
				}
				else if (strcmp(pkvd->szKeyName, "armorvalue") == 0)
				{
					pack->armorvalue = atoi(pkvd->szValue);
				}
			//}
		}
	} else if (strcmp("item_tfgoal", pkvd->szClassName) == 0) {
		if (strcmp(pkvd->szKeyName, "team_no") == 0) {
			pent->v.team = atoi(pkvd->szValue);
		}
	} else if (strcmp("info_frontline", pkvd->szClassName) == 0 ) {
		if (strcmp(pkvd->szKeyName, "roundtime") == 0) {
			sscanf(pkvd->szValue, "%d", &val);
			flf_data.roundTime = val*60; //convert to secs
		} else if (strcmp(pkvd->szKeyName, "warmuptime") == 0) {
			sscanf(pkvd->szValue, "%d", &val);
			flf_data.warmupTime = val;
		} else if (strcmp(pkvd->szKeyName, "arespawntime") == 0) {
			sscanf(pkvd->szValue, "%d", &val);
			flf_data.aRespawnTime = val;
		} else if (strcmp(pkvd->szKeyName, "drespawntime") == 0) {
			sscanf(pkvd->szValue, "%d", &val);
			flf_data.dRespawnTime = val;
		} else if (strcmp(pkvd->szKeyName, "weather") == 0) {
			sscanf(pkvd->szValue, "%d", &val);
			flf_data.weather = val;
		}
	} else if (strcmp("tf_teamset", pkvd->szClassName) == 0) {
		tf_map.dontCheckTeams = TRUE;
	}
}

int TFC_GetAvailableClass(int team) {
	//int classes = tf_available_classes[team];
	int classes = tf_data[team].available_classes;
	//FILE *fp = fopen("bot.txt", "a"); fprintf(fp, "Get available class called.\n"); fclose(fp);
	if (tf_map.dontCheckTeams) return RANDOM_LONG(0,9);
	if (classes == 0) {
		//fp = fopen("bot.txt", "a"); fprintf(fp, "No class restrictions.\n"); fclose(fp);
		return RANDOM_LONG(TFC_CLASS_SCOUT, TFC_CLASS_ENGINEER);
	}
	if (classes == -1) {
		//fp = fopen("bot.txt", "a"); fprintf(fp, "Has to be civilian.\n"); fclose(fp);
		return TFC_CLASS_CIVILIAN;
	}
	//fp = fopen("bot.txt", "a"); fprintf(fp, "Restricted classes\n"); fclose(fp);
	while (TRUE) {
		int aClass = RANDOM_LONG(0, 9);
		if (classes & (1<<aClass)) continue;
		switch(aClass) {
			case 0: return TFC_CLASS_SCOUT;
			case 1: return TFC_CLASS_SNIPER;
			case 2: return TFC_CLASS_SOLDIER;
			case 3: return TFC_CLASS_DEMOMAN;
			case 4: return TFC_CLASS_MEDIC;
			case 5: return TFC_CLASS_HWGUY;
			case 6: return TFC_CLASS_PYRO;
			case 7: continue; //random pc
			case 8: return TFC_CLASS_SPY;
			case 9: return TFC_CLASS_ENGINEER;
		}
	}
}

int TFC_GetAvailableTeam(void) {
	int i, team;
	int used[4] = {0,0,0,0};
	if (tf_map.dontCheckTeams) return RANDOM_LONG(1,2);
	//FILE *fp = fopen("bot.txt", "a"); fprintf(fp, "Get team called.\n"); fclose(fp);
	for (i = 1; i <= gpGlobals->maxClients; i++) {
	  edict_t *pPlayer = INDEXENT(i);
	  // skip invalid players and skip self (i.e. this bot)
	  if ((pPlayer) && (!pPlayer->free)) {
			team = UTIL_GetTeam(pPlayer);
			if (team > -1 && team < 4)
				used[team]++;
		}
	}
	while (TRUE) {
		i = RANDOM_LONG(0,3);
		//fp = fopen("bot.txt", "a"); fprintf(fp, "Trying to join team %d\n", i); fclose(fp);
		if ((used[i] < tf_data[i].max_players || tf_data[i].max_players == 0) && tf_data[i].available_teams) {
			return i+1;
		}
		//fp = fopen("bot.txt", "a"); fprintf(fp, "Team %d is full, it has %d out of %d players. It's availability is: %d\n", i, used[i], tf_max_players[i], tf_available_teams[i]); fclose(fp);
	}
}

void ResetTFCData(void) {
  int i = 0;
	for (i = 0; i < 4; i++) {
		tf_data[i].available_classes=0;
		if (i < 2) {
			tf_data[i].available_teams = TRUE;
		} else {
			tf_data[i].available_teams = 0;
		}
		tf_data[i].max_players = 0;
		tf_data[i].allies = 0;
	}

	tf_map.dontCheckTeams = FALSE;
	tf_map.resetSentries= FALSE;
	tf_map.reverseCTF = FALSE;
	RemoveBackPacks();
}

bool IsValidTeam(int team) {
	if (mod_id == VALVE_DLL) return FALSE;
	if (mod_id == FLF_DLL || mod_id == SI_DLL) {
		if (team < 1 || team > 2) return FALSE;
	}
	if (mod_id == TFC_DLL) {
		if (team < 1 || team > 4) return FALSE;
		if (tf_map.dontCheckTeams) return TRUE;
		int i = team -1, index, t;
		int used[4] = {0,0,0,0};
		if (tf_data[i].available_teams == 0) {
			return FALSE;
		}

		//count the number of players on each team
		for (index = 1; index <= gpGlobals->maxClients; index++) {
		  edict_t *pPlayer = INDEXENT(index);
		  // skip invalid players and skip self (i.e. this bot)
		  if ((pPlayer) && (!pPlayer->free)) {
				t = UTIL_GetTeam(pPlayer);
				if (t > -1 && t < 4) used[t]++;
			}
		}

		if (tf_data[i].max_players) {
			if (used[i] >= tf_data[i].max_players) {
				return FALSE;
			}
		}
		if (used[i] == 1 && tf_data[i].available_classes == -1) {
			return FALSE;
		}
	}
	return TRUE;
}

bool IsValidClass(int bot_class, int team) {
	team--;
	if (mod_id == VALVE_DLL) return FALSE;
	if (mod_id == SI_DLL || mod_id == FLF_DLL) {
		if (bot_class < 1 || bot_class > 3) return FALSE;
	}
	if (mod_id == TFC_DLL) {
		int real_class = -1;
		if (tf_map.dontCheckTeams) return TRUE;
		if (tf_data[team].available_classes == -1) return -1; //for civilian
		switch (bot_class) {
			case TFC_CLASS_SCOUT: real_class = 0; break;
			case TFC_CLASS_SNIPER: real_class = 1; break;
			case TFC_CLASS_SOLDIER: real_class = 2; break;
			case TFC_CLASS_DEMOMAN: real_class = 3; break;
			case TFC_CLASS_MEDIC: real_class = 4; break;
			case TFC_CLASS_HWGUY: real_class = 5; break;
			case TFC_CLASS_PYRO: real_class = 6; break;
			case TFC_CLASS_SPY: real_class = 8; break;
			case TFC_CLASS_ENGINEER: real_class = 9; break;
		}
		if (real_class == -1) return FALSE;
		if (tf_data[team].available_classes & (1<<real_class) ) {
			return FALSE;
		} else {
			return TRUE;
		}
	}
	return TRUE;
}

//the max team you can play as
int GetMaxTeam(void) {
	if (mod_id == VALVE_DLL) {
		return 2;
	}
	if (mod_id == SI_DLL || mod_id == FLF_DLL) {
		return 2;
	}
	if (mod_id == TFC_DLL) {
		int i;
		if (tf_map.dontCheckTeams) return 2;
		for (i = 3; i >= 0; i--) {
			if (tf_data[i].available_teams) {
				return i+1;
			}
		}
		return 2;
	}
	return 2;
}

int GetBalancedTeam(edict_t * pEdict) {
	int players[4]= {0,0,0,0}; //players on each team
	int i, team, min = 100, minTeam = -1;
	edict_t * player;
	if (tf_map.dontCheckTeams) return RANDOM_LONG(1,2);
	if (mod_id == FLF_DLL || mod_id == SI_DLL || mod_id == TFC_DLL) {
		for (i = 1; i <= gpGlobals->maxClients; i++) {
			player = INDEXENT(i);
      if ((player) && (!player->free) && (player != pEdict)) {
				team = UTIL_GetTeam(player);
				if (team > -1 && team < 4) {
					players[team]++;
				}
			}
		}
		for (i = 0; i < 4; i++) {
			if (IsValidTeam(i+1)) {
				if (players[i] < min) {
					min = players[i];
					minTeam = i;
				}
			} else {
			}
		}
		if (minTeam >= 0) {
			return minTeam+1;
		}
	}
	return -1;
}

int GetAvailableTeam(edict_t *pEdict)
{
	bool available[4] = {FALSE, FALSE, FALSE, FALSE};
	int i;
	bool ok=FALSE;
	for (i = 0; i < 4; i++)
	{
		available[i] = IsValidTeam(i+1);
		if (!ok)
		{
			ok = available[i];
		}
	}
	if (!ok)
	{
		return -1;
	}
	while (TRUE)
	{
		i = RANDOM_LONG(0,3);
		if (available[i])
		{
			return (i+1);
		}
	}
}


/*
Blue is always named from the start
If Blue has allies
    They are named from the start, remaining teams named from the back;
Else if Yellow has allies
    Yellow and allies are named from the back.  If an odd team remains,
    it is named from the front.
Else
    Blue and Yellow are named from the front, Red and Green named from
    the back.

*/
int GetAllianceTeam(int team)
{
	if (mod_id == TFC_DLL)
	{
		if (team == -1) return team;
		int alliances = tf_data[team-1].allies;
		int i;
		for (i = 0; i < team; i++)
		{
			if (alliances & (1<<i))
			{
				return i+1;
			}
		}
		//see if the opposite team has alliances
		// ie 1 <-> 3 , 2<->4
		int ateam; //0 based
		if (team < 3)
		{
			ateam = team + 1;
		}
		else
		{
			ateam = team-3;
		}
		if (tf_data[ateam].allies & (i<<ateam))
		{   //our opposite has allies
			//choose from the opposite side
			if (team == 4)
			{
				return 3;
			}
			return team+1;
		}

		return team;
	}
	return team; //same for other mods
}

int GetLargestTeamBot(void)
{
	bool valid[4] = {FALSE,FALSE,FALSE,FALSE};
	int members[4] = {0,0,0,0};
	int i, team, maxMembers, highestTeam;
	edict_t *pPlayer;
	for (i = 0; i < 32; i++)
	{
		if (bots[i].is_used)
		{
			pPlayer = bots[i].pEdict;
			if (pPlayer)
			{
				team = UTIL_GetTeam(pPlayer);
				if (team > -1)
				{
					valid[team] = TRUE;
				}
			}
		}
	}

	for (i = 1; i <= gpGlobals->maxClients; i++)
	{
		pPlayer = INDEXENT(i);
		if (pPlayer)
		{
			team = UTIL_GetTeam(pPlayer);
			if (team > -1)
			{
				if (valid[team])
				{
					members[team]++;
				}
			}
		}
	}
	maxMembers = 0;
	highestTeam = -1;
	for (team = 0; team < 4; team++)
	{
		if(members[team] > maxMembers)
		{
			maxMembers = members[team];
			highestTeam = team;
		}
	}
	if (highestTeam == -1) return -1;
	for (i = 0; i < 32; i++)
	{
		if (bots[i].is_used)
		{
			pPlayer = bots[i].pEdict;
			if (pPlayer)
			{
				if (UTIL_GetTeam(pPlayer) == highestTeam)
				{
					return i;
				}
			}
		}
	}
	return -1;
}

