//
// HPB bot - botman's High Ping Bastard bot
//
// (http://planethalflife.com/botman/)
//
// bot_combat.cpp
//

#ifndef _WIN32
#include <string.h>
#endif

#include <extdll.h>
#include <dllapi.h>
#include <h_export.h>
#include <meta_api.h>

#include "bot.h"
#include "bot_func.h"
#include "bot_weapons.h"
#include "bot_communicate.h"
#include "my_navigate.h"
#include "waypoint.h"
#include "fuzzy.h"

//#define debug_weapons 0

float CombatChangeYaw(edict_t *pEdict, float ideal, float yawSpeed);
float CombatChangePitch(edict_t *pEdict, float ideal, float yawSpeed);
bool BotChooseWeapon(bot_t *pBot, Vector v_enemy, int pref, TargetType targetType);
int gren_usage = 25; //how often to use grenades

bool deathmatch = FALSE;
bool checked_deathmatch = FALSE;

extern int mod_id;
//extern int tf_allies[4]; //tf allies from bot.cpp
extern tf_team_data tf_data[4];

float reactionTimes[5][2] = {
	{0.08,0.15},
	{0.15,0.25},
	{0.25,0.4},
	{0.4,0.6},
	{0.0,1.0}
};

extern bot_weapon_t weapon_defs[MAX_WEAPONS];

typedef struct {
	int weaponID;
	char* weaponName;
	float minRange;
	float maxRange;
	float minPreferredRange;
	float maxPreferredRange;
	float chargeTime;
	float pauseTime; //pause after a burst
	bool isGrenade;
} WeaponInfo;

#define MAX_ENEMIES (32)

typedef struct
{
	float threat;
	edict_t *pEdict;
} EnemyInfo;

bool bot_shoot = TRUE;
bool observer = FALSE;

extern int taunt_used;
extern char bot_taunt[64][96];
extern int bot_chat_freq;

extern int UTIL_GetSpyTeam(edict_t *pPlayer);

#define VALVE_WEAPON_COUNT 11

WeaponInfo valve_weapons[VALVE_WEAPON_COUNT] = {
	{VALVE_WEAPON_CROWBAR,"weapon_crowbar",0,100,0,0,0,0, FALSE},
	{VALVE_WEAPON_HANDGRENADE,"weapon_handgrenade",200,600,300,550,2,0, TRUE},
	{VALVE_WEAPON_RPG,"weapon_rpg",250,9999,500,1000,0,0, FALSE},
	{VALVE_WEAPON_GAUSS,"weapon_gauss",200,9999,300,800,0,0, FALSE},
	{VALVE_WEAPON_EGON,"weapon_egon", 250,9999,300,800,0,0, FALSE},
	{VALVE_WEAPON_MP5,"weapon_mp5",100,9999,200,500,0,0, FALSE},
	{VALVE_WEAPON_PYTHON,"weapon_357",40,9999,300,600,0,0, FALSE},
	{VALVE_WEAPON_HORNETGUN,"weapon_hornetgun",100,9999,200,500,0,0, FALSE},
	{VALVE_WEAPON_SHOTGUN,"weapon_shotgun",40,9999,200,500,0,0, FALSE},
	{VALVE_WEAPON_CROSSBOW,"weapon_crossbow", 200,9999,300,800,0,0, FALSE},
	{VALVE_WEAPON_GLOCK,"weapon_glock",40,9999,200,500,0,0, FALSE}
};

#define TF_WEAPON_COUNT 17
WeaponInfo tf_weapons[TF_WEAPON_COUNT] = {
	{TF_WEAPON_MEDIKIT, "tf_weapon_medikit", 0,100,0,0,0,0, FALSE},
	{TF_WEAPON_SPANNER, "tf_weapon_spanner", 0,100,0,0,0,0, FALSE},
	{TF_WEAPON_AXE, "tf_weapon_axe", 0,100,0,0,0,0, FALSE},
	{TF_WEAPON_KNIFE, "tf_weapon_knife", 0,100,0,0,0,0, FALSE},
	{TF_WEAPON_AC,"tf_weapon_ac", 250,750,300,600,0,0, FALSE},
	{TF_WEAPON_SNIPERRIFLE,"tf_weapon_sniperrifle", 200,9999,500,1000,2,0, FALSE},
	{TF_WEAPON_AUTORIFLE,"tf_weapon_autorifle",100,9999,200,500,0,0, FALSE},
	{TF_WEAPON_FLAMETHROWER,"tf_weapon_flamethrower",100,600,150,300,0,0, FALSE},
	{TF_WEAPON_RPG,"tf_weapon_rpg",250,9999,300,600,0,0, FALSE},
	{TF_WEAPON_SUPERNAILGUN,"tf_weapon_superng",40,9999,200,400,0,0, FALSE},
	{TF_WEAPON_GL,"tf_weapon_gl",200,600,400,600,0.1,0.1, FALSE},
	{TF_WEAPON_IC,"tf_weapon_ic",250,800,400,600,0,0, FALSE},
	{TF_WEAPON_SUPERSHOTGUN,"tf_weapon_supershotgun",40,9999,200,400,0,0, FALSE},
	{TF_WEAPON_SHOTGUN,"tf_weapon_shotgun",40,9999,150,300,0,0, FALSE},
	{TF_WEAPON_NAILGUN,"tf_weapon_ng",40,9999,200,400,0,0, FALSE},
	{TF_WEAPON_TRANQ,"tf_weapon_tranq",40,9999,200,400,0,0, FALSE},
	{TF_WEAPON_RAILGUN,"tf_weapon_railgun",40,9999,200,400,0,0, FALSE}
};

#define SI_WEAPON_COUNT 10
WeaponInfo si_weapons[SI_WEAPON_COUNT] = {
	{SI_WEAPON_BRIEFCASE, "weapon_briefcase", 0, 100, 0,0,0,0, FALSE},
	{SI_WEAPON_VOMIT, "weapon_vomit", 0, 100,0,0,0,0, FALSE},
	{SI_WEAPON_357, "weapon_357",40,9999,400,600,0,0, FALSE},
	{SI_WEAPON_9MMAR,"weapon_9mmAR",100,9999,200,400,0,0, FALSE},
	{SI_WEAPON_CROSSBOW,"weapon_crossbow", 200,9999,400,600,0,0, FALSE},
	{SI_WEAPON_SHOTGUN,"weapon_shotgun",40,9999,200,400,0,0, FALSE},
	{SI_WEAPON_RPG,"weapon_rpg",250,9999,300,500,0,0, FALSE},
	{SI_WEAPON_GAUSS,"weapon_gauss",200,9999,300,600,0,0, FALSE},
	{SI_WEAPON_HORNETGUN,"weapon_hornetgun",100,9999,200,400,0,0, FALSE},
	{SI_WEAPON_HANDGRENADE,"weapon_handgrenade",200,600,400,600,0,2, TRUE}
};

#define FLF_WEAPON_COUNT 23
WeaponInfo flf_weapons[FLF_WEAPON_COUNT] = {
	{FLF_WEAPON_KNIFE, "weapon_knife", 0, 100, 0, 0, 0, 0, FALSE},
	{FLF_WEAPON_HK21, "weapon_hk21", 300, 9999, 400, 600, 1.5, 0.6, FALSE},
	{FLF_WEAPON_FAMAS, "weapon_famas", 300, 9999, 400,600, .9,0.3, FALSE},
	{FLF_WEAPON_AK5, "weapon_ak5", 300, 9999, 400, 600, 1.5, 0.3, FALSE},
	{FLF_WEAPON_M4, "weapon_m4", 300, 9999, 400, 600, 1.3, 0.3, FALSE},
	{FLF_WEAPON_SPAS12, "weapon_spas12", 50, 600, 200,400,0, 0, FALSE},
	{FLF_WEAPON_RS202M2, "weapon_rs202m2", 50, 600, 200, 400, 0, 0, FALSE},
	{FLF_WEAPON_FLASHBANG, "weapon_flashbang", 200, 600, 400, 600, 0.3, 0.3, TRUE},
	{FLF_WEAPON_HEGRENADE, "weapon_hegrenade", 200, 600, 400, 600, 0.3, 0.3, TRUE},
	{FLF_WEAPON_MP5A2, "weapon_mp5a2", 100, 500, 200,500, 3, 0.3, FALSE},
	{FLF_WEAPON_MP5A2, "weapon_mp5sd", 100, 500, 200,500, 3, 0.3, FALSE},
	{FLF_WEAPON_MAC10, "weapon_mac10", 100, 500, 300,500, 2, 0.3, FALSE},
	{FLF_WEAPON_UMP45, "weapon_ump45", 100, 500, 300,500, 2, 0.3, FALSE},
	{FLF_WEAPON_BERETTA, "weapon_beretta", 50, 500, 100,200,0,0, FALSE},
	{FLF_WEAPON_MK23, "weapon_mk23", 50, 5000, 100, 200, 0,0, FALSE},
	{FLF_WEAPON_SAKO, "weapon_sako", 200, 9999, 500, 1000, 0, 0, FALSE},
	{FLF_WEAPON_MSG90, "weapon_msg90", 200, 9999, 500,  1000,0,0, FALSE},
	{FLF_WEAPON_MP5A2, "weapon_mp5a2", 100, 9999, 200,500, 3, 0.3, FALSE},
	{FLF_WEAPON_MP5A2, "weapon_mp5sd", 100, 9999, 200,500, 3, 0.3, FALSE},
	{FLF_WEAPON_MAC10, "weapon_mac10", 100, 9999, 300,500, 2, 0.3, FALSE},
	{FLF_WEAPON_UMP45, "weapon_ump45", 100, 9999, 300,500, 2, 0.3, FALSE},
	{FLF_WEAPON_BERETTA, "weapon_beretta", 50, 9999, 100,200,0,0, FALSE},
	{FLF_WEAPON_MK23, "weapon_mk23", 50, 9999, 100, 200, 0,0, FALSE}
};

inline float BotGetTargetValue(bot_t *pBot, edict_t * pEnemy, float max_dist)
{
	float dist = (pBot->pEdict->v.origin- pEnemy->v.origin).Length();
	float val;
	if (dist > max_dist)
	{
		return 0.0; //no good
	}
	val = max_dist/dist;
	if (pEnemy->v.button |= IN_ATTACK)
	{
		val *= 2.0; //ahhh, this bastard is shooting
	}
	return val;
}


edict_t * BotTestGrenade(const Vector &origin, float * closest, edict_t * pEnt, edict_t *pAvoid, edict_t *pEdict)
{
	bool use = FALSE;
	Vector to = pEnt->v.origin - origin;
	float dist = to.Length();
	TraceResult tr;

	if (dist < *closest)
	{
		if (pEnt->v.owner)
		{
			if (UTIL_GetTeam(pEdict) == UTIL_GetTeam(pEnt->v.owner))
			{
				return pAvoid;
			}
		}
		UTIL_TraceLine(origin, pEnt->v.origin, ignore_monsters, pEdict, &tr);
		if (tr.flFraction >= 1.0)
		{
			//is it heading away from us
			if (pEnt->v.velocity.Length() < 50.0)
			{
				use = TRUE;
			}

			if (use)
			{
				*closest = dist;
				pAvoid = pEnt;
			}
		}
	}
	return  pAvoid;
}


edict_t *BotGetAvoidEntity(bot_t *pBot)
{
	return NULL;
	edict_t *pEdict = pBot->pEdict,
		*pAvoid=NULL, *pEnt = NULL;
	Vector origin = pEdict->v.origin, to;
	float closest = 250.0;
	TraceResult tr;

	if (mod_id == TFC_DLL)
	{
		while ((pEnt = UTIL_FindEntityByClassname(pEnt, "tf_weapon_normalgrenade")) != NULL)
		{
			pAvoid = BotTestGrenade(origin, &closest, pEnt, pAvoid, pEdict);
		}
		while ((pEnt = UTIL_FindEntityByClassname(pEnt, "tf_weapon_mirvbomblet")) != NULL)
		{
			pAvoid = BotTestGrenade(origin, &closest, pEnt, pAvoid, pEdict);
		}
		while ((pEnt = UTIL_FindEntityByClassname(pEnt, "tf_weapon_nailgrenade")) != NULL)
		{
			pAvoid = BotTestGrenade(origin, &closest, pEnt, pAvoid, pEdict);
		}
		while ((pEnt = UTIL_FindEntityByClassname(pEnt, "tf_weapon_napalmgrenade")) != NULL)
		{
			pAvoid = BotTestGrenade(origin, &closest, pEnt, pAvoid, pEdict);
		}
		while ((pEnt = UTIL_FindEntityByClassname(pEnt, "tf_weapon_mirvgrenade")) != NULL)
		{
			pAvoid = BotTestGrenade(origin, &closest, pEnt, pAvoid, pEdict);
		}
		while ((pEnt = UTIL_FindEntityByClassname(pEnt, "tf_gl_pipebomb")) != NULL)
		{
			pAvoid = BotTestGrenade(origin, &closest, pEnt, pAvoid, pEdict);
		}
		while ((pEnt = UTIL_FindEntityByClassname(pEnt, "tf_gl_grenade")) != NULL)
		{
			pAvoid = BotTestGrenade(origin, &closest, pEnt, pAvoid, pEdict);
		}
	}
	else if (mod_id == FLF_DLL)
	{
		while ((pEnt = UTIL_FindEntityByClassname(pEnt, "grenade")) != NULL)
		{
			pAvoid = BotTestGrenade(origin, &closest, pEnt, pAvoid, pEdict);
		}
	}

	return pAvoid;
}

void BotMoveAvoidEntity(bot_t * pBot, edict_t * pAvoid)
{
	//for now, just adjust move_speed and strafe_speed to avoid
	Vector to = pBot->pEdict->v.origin - pAvoid->v.origin,
		angles = UTIL_VecToAngles(to);
	angles = angles - pBot->pEdict->v.v_angle;

	UTIL_MakeVectors(angles);
	//to = to.Normalize() * pBot->f_max_speed;
	pBot->f_move_speed = (gpGlobals->v_forward).Length() * -pBot->f_max_speed;
	pBot->f_strafe_speed = (gpGlobals->v_right).Length() * -pBot->f_max_speed;
}
//void CombatMove(bot_t *pBot, Vector, WeaponInfo *weapons, int);
bool NewBotFireWeapon(bot_t *pBot, Vector toTarget)
{
	pBot->weapon_status = pBot->weapons[pBot->current_weapon.iId]->Fire(toTarget);
	return (pBot->weapon_status == BOT_WEAPON_FIRED || pBot->weapon_status == BOT_WEAPON_FIRING);
}

bool BotChooseWeapon(bot_t *pBot, Vector toTarget, int pref, TargetType targetType)
{
	if (mod_id != TFC_DLL && mod_id != FLF_DLL)
	{
		return TRUE; //these mods select their weapons elsewhere...
	};
	int i = 0;
	float bestFitness = 0.0;
	float fitness, distance = toTarget.Length();
	int bestWeapon = -1;

	if (pBot->f_change_weapon_time > gpGlobals->time 
		&& pBot->weapon_status != BOT_WEAPON_CANT_SHOOT)
	{
		return TRUE;
	}
	pBot->f_change_weapon_time = gpGlobals->time + 0.5;

	if (pBot->weapon_status != BOT_WEAPON_FIRING) {
		for (i = 0; i < 31; i++)
		{
			if (pBot->bot_weapons & (1<<i))
			{
				fitness = pBot->weapons[i]->Fitness(toTarget, distance, targetType);
				if (fitness > bestFitness)
				{
					bestFitness = fitness;
					bestWeapon = i;
				}
			}
		}
		if (bestWeapon == -1)
		{
			return FALSE;
		}
	}
	else
	{
		bestWeapon = pBot->current_weapon.iId;
	}

	if (pBot->current_weapon.iId != pBot->weapons[bestWeapon]->iId)
	{
		FakeClientCommand(pBot->pEdict, weapon_defs[bestWeapon].szClassname);
	}

	return (pBot->current_weapon.iId == pBot->weapons[bestWeapon]->iId);
	//return TRUE;
}




bool BotFireWeapon( Vector v_enemy, bot_t *pBot, int pref) {
	int i=-1, choice=-1; bool firstTime = FALSE, attack = FALSE;
	TraceResult tr;
	float distance = v_enemy.Length();
	WeaponInfo *weapons;
	int weaponCount;
	if (mod_id == TFC_DLL) {
		weapons = tf_weapons;
		weaponCount = TF_WEAPON_COUNT;
		return NewBotFireWeapon(pBot, v_enemy);
	} else if (mod_id == SI_DLL) {
		weapons = si_weapons;
		weaponCount = SI_WEAPON_COUNT;
	} else if (mod_id == FLF_DLL) {
		weapons = flf_weapons;
		weaponCount = FLF_WEAPON_COUNT;
		return NewBotFireWeapon(pBot, v_enemy);
		//return TRUE;
	} else {
		weapons = valve_weapons;
		weaponCount = VALVE_WEAPON_COUNT;
	}

	if (pBot->reactionTime > gpGlobals ->time) {
		return TRUE;
	}

	if (mod_id == TFC_DLL)
	{
		if (pBot->bot_class == TFC_CLASS_SPY)
		{
			if (UTIL_GetTeam(pBot->pEdict) != UTIL_GetSpyTeam(pBot->pEdict))
			{
				if (v_enemy.Length() < 100) {
					int angles = abs(pBot->pEdict->v.angles.y - pBot->pBotEnemy->v.angles.y);
					if (pBot->current_weapon.iId != TF_WEAPON_KNIFE)
					{
						FakeClientCommand(pBot->pEdict, "tf_weapon_knife");
					}
					pBot->pEdict->v.button |= IN_ATTACK;
				}
				else if (v_enemy.Length() > 300)
				{
					pBot->pBotEnemy = NULL;
					pBot->f_see_enemy_time = 0.0;
				}
				return TRUE;
			}
		}
	}

	if (pBot->weaponChargeTime > gpGlobals->time) {
		int i;
		for (i = 0; i <weaponCount; i++) {
			if (weapons[i].weaponID == pBot->current_weapon.iId) {
				break;
			}
		}
		if (i < weaponCount) {
			if (!(weapons[i].isGrenade)) {
				if (pBot->current_weapon.iClip == 0) {
					if (pBot->current_weapon.iAmmo1 == 0) {
						pBot->weaponChargeTime = 0; // get a new weapon next time
					} else {
          	pBot->pEdict->v.button |= IN_RELOAD;
					}
					return FALSE; //take cover
				}
			}
		}
		pBot->pEdict->v.button |= IN_ATTACK;
		return TRUE; //charging
	}

	if (pBot->weaponChargeTime < gpGlobals->time && pBot->weaponChargeTime != 0) {
		int i;
		for (i = 0; i <weaponCount; i++) {
			if (weapons[i].weaponID == pBot->current_weapon.iId) {
		    pBot->reactionTime = gpGlobals->time + weapons[i].pauseTime;
				break;
			}
		}
		pBot->weaponChargeTime = 0;
		return TRUE; //let the button off
	}

	if (pref != -1) {
#ifdef debug_weapons
    FILE *fp = fopen("botweapon.txt", "a"); fprintf(fp, "pref is : %d \n", pref); fclose(fp);
#endif
		for (i = 0; i <weaponCount; i++) {
			if (weapons[i].weaponID == pref) {
#ifdef debug_weapons
				FILE *fp = fopen("botweapon.txt", "a"); fprintf(fp, "Choice is: %s \n", weapons[i].weaponName); fclose(fp);
#endif
				choice = i;
				firstTime = TRUE;
				break;
			}
		}
	} else {
		firstTime = FALSE;
	}

	for (i=0; i < weaponCount || firstTime; i++) {
		if (i >= weaponCount) {
			firstTime = FALSE;
			i = 0;
			continue;
		}

		if (firstTime && i != choice) continue;

		if (0==(pBot->pEdict->v.weapons & (1<<(weapons[i].weaponID)))) { //not carrying
			continue;
		}

		if (weapons[i].isGrenade) {
			if (pBot->grenadeTime > gpGlobals->time) { //not time for another grenade yet
				continue;
			}
		}
		if (distance < weapons[i].minRange) {
#ifdef debug_weapons
		FILE *fp = fopen("botweapon.txt", "a"); fprintf(fp, "Too close for a %s, distance is: %f \n", weapons[i].weaponName, distance); fclose(fp);
#endif
			continue;
		}
		if (distance > weapons[i].maxRange && weapons[i].maxRange !=9999) {
#ifdef debug_weapons
			if (debug_weapons) {FILE *fp = fopen("botweapon.txt", "a"); fprintf(fp, "Too far for a %s, distance is: %f \n", weapons[i].weaponName, distance); fclose(fp);}
#endif
			continue;
		}


		if (weapon_defs[weapons[i].weaponID].iAmmo1Max!=-1 && pBot->m_rgAmmo[weapon_defs[weapons[i].weaponID].iAmmo1] < 1) {
			//if (debug_weapons) {FILE *fp = fopen("botweapon.txt", "a"); fprintf(fp, "No ammo for the %s\n", weapons[i].weaponName, distance); fclose(fp);}
			continue;
		}


		if (mod_id == TFC_DLL) {
			if (weapons[i].weaponID == TF_WEAPON_FLAMETHROWER || weapons[i].weaponID == TF_WEAPON_IC) {
				if (pBot->pBotEnemy != NULL && pBot->pBotEnemy->v.playerclass == TFC_CLASS_PYRO) {
					continue;
				}
			}
		}

		if (pBot->current_weapon.iId != weapons[i].weaponID) {
			if (mod_id == TFC_DLL) {
				FakeClientCommand(pBot->pEdict, weapons[i].weaponName);
			} else {
				FakeClientCommand(pBot->pEdict, "use %s", weapons[i].weaponName);
			}
		}
		if (pBot->current_weapon.iId != weapons[i].weaponID) {
			continue; //can't select it for some reason
#ifdef debug_weapons
			if (debug_weapons) {FILE *fp = fopen("botweapon.txt", "a"); fprintf(fp, "The %s, didn't select\n", weapons[i].weaponName, distance); fclose(fp);}
#endif
		}

		if (weapons[i].isGrenade) {
			if (v_enemy.z > 50) {
				continue; //only throw at level and below
			}
		}

		if (pBot->current_weapon.iClip == 0) {
			if (pBot->current_weapon.iAmmo1 == 0) {
				continue; // no ammo
			} else {
				pBot->pEdict->v.button |= IN_RELOAD;
				return FALSE; //take cover
			}
		}


		if (pBot->fov == 0) {
			if (mod_id == FLF_DLL) {
				if (pBot->current_weapon.iId == FLF_WEAPON_MSG90 || pBot->current_weapon.iId == FLF_WEAPON_SAKO) {
#ifdef debug_weapons
					FILE *fp = fopen("botweapon.txt", "a"); fprintf(fp, "Zooming in.. on the %s\n", weapons[i].weaponName, distance); fclose(fp);
#endif
					pBot->pEdict->v.button |= IN_ATTACK2;
					return TRUE; //zooming in
				}
			}
		}


#ifdef debug_weapons
		if (debug_weapons) {FILE *fp = fopen("botweapon.txt", "a"); fprintf(fp, "Firing the %s, distance is %f \n", weapons[i].weaponName, distance); fclose(fp);}
#endif

/*
	UTIL_TraceLine(GetGunPosition(pBot->pEdict), GetGunPosition(pBot->pEdict) + v_enemy, ignore_monsters, ignore_glass, pBot->pEdict, &tr);
  	if (tr.flFraction < 1.0) {
			if (taunt_used > -1) {
				if (RANDOM_LONG(0,300) < bot_chat_freq) {
					if (strcmp(STRING(pBot->pBotEnemy->v.classname), "player") == 0) {
						char buffer[128];
						sprintf(buffer, bot_taunt[RANDOM_LONG(0, taunt_used)], STRING(pBot->pBotEnemy->v.netname));
						UTIL_SayText(buffer, pBot->pEdict, FALSE);
					}
				}
			}
  		pBot->pBotEnemy = NULL;
  		return TRUE;
  	}
*/

		if (weapons[i].chargeTime != 0) {
			float time=1;
			switch (pBot->bot_skill-1) {
				case 0: time = .1; break;
				case 1: time = .2; break;
				case 2: time = .5; break;
				case 3: time = 1; break;
				case 4: time = 1.5; break;
			}
			time = RANDOM_FLOAT(weapons[i].chargeTime-time, weapons[i].chargeTime+time); //random time
	  	if (time <= 0) time = 0.1;
	  	pBot->weaponChargeTime = gpGlobals->time + time;
	  } else {
	  	pBot->weaponChargeTime = 0;
	  }
		if (weapons[i].isGrenade) {pBot->grenadeTime = gpGlobals->time + 5;}
		pBot->pEdict->v.button |= IN_ATTACK;
		return TRUE;
	}

#ifdef debug_weapons
  if (debug_weapons) 		{FILE *fp = fopen("botweapon.txt", "a"); fprintf(fp, "Returning false!!! \n", weapons[i].weaponName, distance); fclose(fp);}
#endif

	return FALSE;
}

void CombatMove(bot_t *pBot) { //, Vector v_enemy) { //, WeaponInfo *weapons, int weaponCount) {
	Vector v_enemy = pBot->pBotEnemy->v.origin - pBot->pEdict->v.origin;
	Vector enemy_origin = pBot->pBotEnemy->v.origin;
	Vector enemy_angles = pBot->pBotEnemy->v.angles;
	float distance = v_enemy.Length();
	WeaponInfo *weapons;
	int weaponCount;
	bool strafe = FALSE; int i = 0;
	if (mod_id == TFC_DLL) {
		weapons = tf_weapons;
		weaponCount = TF_WEAPON_COUNT;
	} else if (mod_id == SI_DLL) {
		weapons = si_weapons;
		weaponCount = SI_WEAPON_COUNT;
	} else if (mod_id == FLF_DLL) {
		weapons = flf_weapons;
		weaponCount = FLF_WEAPON_COUNT;
	} else {
		weapons = valve_weapons;
		weaponCount = VALVE_WEAPON_COUNT;
	}

	if (pBot->bot_class == TFC_CLASS_SPY)
	{
		if (UTIL_GetTeam(pBot->pEdict) != UTIL_GetSpyTeam(pBot->pEdict))
		{
			float angle = abs(pBot->pEdict->v.angles.y - enemy_angles.y);
			if (angle < 30 || angle > 150)
			{
				pBot->f_move_speed = pBot->f_max_speed;
			}
			else
			{
				pBot->f_move_speed = pBot->f_max_speed/2;
			}
			pBot->f_strafe_speed = 0;
			return;
		}
	}



	for (i=0; i < weaponCount; i++) {
		if (weapons[i].weaponID == pBot->current_weapon.iId) { //BotCurrentWeapon
			break;
		}
	}
	if (i >= weaponCount) return;
	if (distance > weapons[i].maxPreferredRange) {
		pBot->f_move_speed = pBot->f_max_speed;
	} else if (distance < weapons[i].minPreferredRange) {
		pBot->f_move_speed = -pBot->f_max_speed;
	} else {
		strafe = TRUE;
		pBot->f_move_speed = 0; //pBot->f_max_speed * RANDOM_FLOAT(0.3,0.7);
	}

	//pBot->f_move_speed = GetSpeedRatio(distance, weapons[i].minPreferredRange) * pBot->f_max_speed;

	if (pBot->f_move_speed > 0) {
		if (NavIsDirectionReachable(pBot->pEdict,0, enemy_origin)) { //float angle, Vector sight)FrontClear(pBot->pEdict)) {
			//it's cool
		} else {
			pBot->f_move_speed = 0;
			strafe = TRUE;
		}
	} else if (pBot->f_move_speed < 0) {
		if (NavIsDirectionReachable(pBot->pEdict,180, enemy_origin)) {
			// is cool
		} else {
			pBot->f_move_speed = 0;
			strafe = TRUE;
		}
	}
	if (strafe) {
		bool rightClear = NavIsDirectionReachable(pBot->pEdict,-90, enemy_origin);
		bool leftClear = NavIsDirectionReachable(pBot->pEdict,90, enemy_origin);

		if (pBot->last_strafe_speed == 0) { //start strafing if we aren't
			pBot->f_strafe_speed = RANDOM_FLOAT(pBot->f_max_speed/2, pBot->f_max_speed);
			if (RANDOM_LONG(0,100) < 50) {
				pBot->f_strafe_speed *= -1; // go the other way sometimes
			}
		} else {
			pBot->f_strafe_speed = pBot->last_strafe_speed;
			if (RANDOM_LONG(0,1000) < 2) { //change direction
				pBot->f_strafe_speed *= -1; // go the other way sometimes
			}
			pBot->f_strafe_speed *= RANDOM_FLOAT(0.8,1.2); //change speed
		}
		if (pBot->f_strafe_speed > 0) {
			if (!(rightClear)) {
				if (leftClear) {
					pBot->f_strafe_speed *= -1;
				} else {
					pBot->f_strafe_speed = 0;
				}
			}
		} else if (pBot->f_strafe_speed < 0) { // going left
			if (!(leftClear)) {
				if (rightClear) {
					pBot->f_strafe_speed *= -1;
				} else {
					pBot->f_strafe_speed = 0;
				}
			}
		}
	}
	return;
}


bool onSameTeam(edict_t *player1, edict_t *player2) {
	char *infobuffer1, *infobuffer2, *model_name1, *model_name2;

	infobuffer1 = GET_INFOKEYBUFFER( player1 );
	model_name1 = INFOKEY_VALUE(infobuffer1, "model");

	infobuffer2 = GET_INFOKEYBUFFER( player2 );
	model_name2 = INFOKEY_VALUE(infobuffer2, "model");

	return (strcmp(model_name1, model_name2)==0);
}


edict_t *BotFindEnemy( bot_t *pBot )
{
	int i;
	float nearestDistance = 5000;  // max distance of enemy
	static float is_team_play;
	bool spying = FALSE;
	bool underwater;
	float angle;
	float max_threat = 0;
	float threat;
	Vector vecEnd;
	edict_t *pNewEnemy = NULL;
	edict_t *pSentry = NULL;
	edict_t *pOwner = NULL;
	edict_t *pEdict = pBot->pEdict;

	int bot_team = UTIL_GetTeam(pEdict);
	edict_t *enemies[MAX_ENEMIES];
	int enemies_used = 0;

	if (bot_shoot == FALSE) {
		return NULL;
	}

	underwater = (pEdict->v.waterlevel == 3);

	//special cases for snipers
	if (mod_id == TFC_DLL)
	{
		spying = (pBot->bot_class == TFC_CLASS_SPY) && (UTIL_GetSpyTeam(pEdict) != UTIL_GetTeam(pEdict));
		if (pBot->bot_weapons & (1<<TF_WEAPON_SNIPERRIFLE))
		{
			nearestDistance = 11550;
		}
		if (pBot->bot_class == TFC_CLASS_CIVILIAN) 
		{
			nearestDistance = 100;
		}
		if (spying)
		{
			nearestDistance = 200;
		}
	} 
	else if (mod_id == VALVE_DLL)
	{
		if (pBot->bot_weapons & (1<<VALVE_WEAPON_CROSSBOW)) 
		{
			nearestDistance = 11550;
		}
		else if (pBot->bot_weapons & (1<<VALVE_WEAPON_PYTHON))
		{
			nearestDistance = 11550;
		}
	}
	else if (mod_id == FLF_DLL)
	{
		if (pBot->current_weapon.iId == FLF_WEAPON_MSG90 || pBot->current_weapon.iId == FLF_WEAPON_SAKO) 
		{
			nearestDistance = 11550;
		}
	}
	

	
	// is this TFC or Counter-Strike?
	if ((mod_id == TFC_DLL) || (mod_id == CSTRIKE_DLL) || (mod_id == FLF_DLL) || (mod_id == SI_DLL) ) {
		is_team_play = 1.0;
	} else {
		is_team_play = CVAR_GET_FLOAT("mp_teamplay");  // teamplay enabled?
	}
	
	 // search the world for players...
	for (i = 1; i <= gpGlobals->maxClients; i++)
	{
		edict_t *pPlayer = INDEXENT(i);

		// skip invalid players and skip self (i.e. this bot)
		// skip this player if not alive (i.e. dead or dying)
		if (!pPlayer || pPlayer->free || pPlayer == pEdict || !IsAlive(pPlayer))
		{
			continue;
		}
		
		if (observer && (pPlayer->v.flags & FL_FAKECLIENT) == 0)
		{
			continue; // only shoot other bots in observer
		}

		// is team play enabled?
        if (is_team_play > 0.0)
        {
			if (mod_id == VALVE_DLL) {
				if (onSameTeam(pPlayer, pEdict)) {
					continue;
				}
			}	else {
				int player_team = UTIL_GetTeam(pPlayer);

				if (mod_id == TFC_DLL && pPlayer->v.playerclass == TFC_CLASS_SPY && player_team != bot_team) {
					player_team = UTIL_GetSpyTeam(pPlayer);
				}

				// don't target your teammates...
				if (bot_team == player_team || player_team == -1)  continue;
					if ( (1<<player_team) & (tf_data[bot_team].allies) ) continue;
			}
		}
	
		if (!underwater && pPlayer->v.waterlevel == 3)
		{ //if they are under and we aren't
			continue;
		}
		else if (underwater && pPlayer->v.waterlevel != 3)
		{
			continue;
		}

		vecEnd = pPlayer->v.origin + pPlayer->v.view_ofs;

		angle = abs(pEdict->v.angles.y - pPlayer->v.angles.y);
		if ( ( (FInViewCone(&vecEnd,pEdict) && !spying)
			|| (angle < 90 && spying) )
			&& FVisible(vecEnd, pEdict))
		 {
			/*
			whew, after all that we can see and target them, so a bit of threat analysis
			is the way to go here
			*/
			if (enemies_used < 32)
			{
				enemies[enemies_used++] = pPlayer;
			}
			else
			{
				//break ???
			}
		}
	}


	if (mod_id == TFC_DLL)
	{
		// lets get us some sentries for dinner ;)
		while ((pSentry = UTIL_FindEntityByClassname(pSentry, "building_sentrygun")) != NULL)
		{
			if (pSentry->v.effects & EF_NODRAW) continue;
			vecEnd = pSentry->v.origin + pSentry->v.view_ofs;
			int player_team = pSentry->v.colormap;
			switch(player_team)
			{
			case 0xA096: player_team = 0; break;
			case 0x04FA: player_team = 1; break;
			case 0x372D: player_team = 2; break;
			case 0x6E64: player_team = 3; break;
			default: player_team = -1; break; //arrrggghhhh
			}
			
			// don't target your teammates...
			if (bot_team == player_team || player_team == -1) continue;
			if ((1<<player_team) & tf_data[bot_team].allies) continue;

			// see if bot can see the player...
			if (FInViewCone( &vecEnd, pEdict ) && FVisible( vecEnd, pEdict ))
			{
				if (enemies_used < 32)
				{
					enemies[enemies_used++] = pSentry;
				}
				else
				{
					//break ???
				}
			}
		}
	}

	//threat analysis time !!, let's rock ;)
	pNewEnemy = NULL;
	for (i = 0; i < enemies_used; i++)
	{
		threat = BotGetTargetValue(pBot, enemies[i], nearestDistance);
		if (threat > max_threat)
		{
			pNewEnemy = enemies[i];
			max_threat = threat;
		}
	}

	if (pNewEnemy != NULL)
	{
		// face the enemy
		Vector v_enemy = pNewEnemy->v.origin - pEdict->v.origin;
		Vector bot_angles = UTIL_VecToAngles( v_enemy );
		pEdict->v.ideal_yaw = bot_angles.y;
		
		//erase the waypoint info
		pBot->currentPoint=-1;

		BotFixIdealYaw(pEdict);
		if (pNewEnemy != pBot->pBotEnemy)
		{
			pBot->reactionTime = gpGlobals->time + RANDOM_FLOAT(reactionTimes[pBot->bot_skill-1][0],reactionTimes[pBot->bot_skill-1][1]);
		}
   }

   return (pNewEnemy);
}


Vector BotBodyTarget( edict_t *pBotEnemy, bot_t *pBot )
{
   Vector target;
   float f_distance;
   float f_scale;
	 float f_velocity;
	 float f_target_velocity;
	 float angle;
   int d_x, d_y, d_z;

	 int aimSkill=pBot->bot_skill-1;

	 Vector targetVelocity = pBotEnemy->v.velocity;

	 bool sniping = FALSE;

   edict_t *pEdict = pBot->pEdict;

	 angle = UTIL_VecToAngles(targetVelocity).y + pBot->pEdict->v.v_angle.y;

     f_distance = (pBotEnemy->v.origin - pEdict->v.origin).Length();
	 f_velocity = (pBot->pEdict->v.velocity).Length();
	 f_target_velocity = targetVelocity.Length();

	 angle = abs(sin(angle * 0.017453292519943295769236907684886));
	 f_target_velocity += f_target_velocity *angle;
	 f_target_velocity /=2.0;

   if (f_distance > 1000)
      f_scale = 1.0;
   else if (f_distance > 100)
      f_scale = f_distance / 1000.0;
   else
      f_scale = 0.1;

	 if (mod_id == TFC_DLL) {
	 	 sniping = (pBot->current_weapon.iId == TF_WEAPON_SNIPERRIFLE);
	 } else if (mod_id == VALVE_DLL) {
	 	 if ((pBot->current_weapon.iId == VALVE_WEAPON_CROSSBOW) ||(pBot->current_weapon.iId == VALVE_WEAPON_PYTHON))  {
			 sniping = TRUE;
		 }
	 } else if (mod_id == FLF_DLL) {
	 	 sniping = (pBot->current_weapon.iId == FLF_WEAPON_MSG90 || pBot->current_weapon.iId == FLF_WEAPON_SAKO);
	 }

	 if (sniping) {
		 if (f_target_velocity < 50.0) {
			 aimSkill = 0;
		 } else if (f_target_velocity < 100) {
			 aimSkill = 1;
		 } else if (f_target_velocity < 200) {
			 aimSkill = 2;
		 } else if (f_target_velocity < 300) {
			 aimSkill = 3;
		 } else {
			 aimSkill = 4;
		 }
	 }

	 if (aimSkill < pBot->bot_skill -1) {
		 aimSkill = pBot->bot_skill -1;
	 }

   // randomly select the aiming style...
   switch (aimSkill)
   {
      case 0:
         // VERY GOOD, same as from CBasePlayer::BodyTarget (in player.h)
         target = pBotEnemy->v.origin + pBotEnemy->v.view_ofs * RANDOM_FLOAT( 0.5, 1.1 );
         d_x = 0;  // no offset
         d_y = 0;
         d_z = 0;
         break;
      case 1:
         // GOOD, offset a little for x, y, and z
         target = pBotEnemy->v.origin + pBotEnemy->v.view_ofs;  // aim for the head (if you can find it)
         d_x = RANDOM_FLOAT(-5, 5) * f_scale;
         d_y = RANDOM_FLOAT(-5, 5) * f_scale;
         d_z = RANDOM_FLOAT(-10, 10) * f_scale;
         break;
      case 2:
         // FAIR, offset somewhat for x, y, and z
         target = pBotEnemy->v.origin;  // aim for the body
         d_x = RANDOM_FLOAT(-10, 10) * f_scale;
         d_y = RANDOM_FLOAT(-10, 10) * f_scale;
         d_z = RANDOM_FLOAT(-18, 18) * f_scale;
         break;
      case 3:
         // POOR, offset for x, y, and z
         target = pBotEnemy->v.origin;  // aim for the body
         d_x = RANDOM_FLOAT(-20, 20) * f_scale;
         d_y = RANDOM_FLOAT(-20, 20) * f_scale;
         d_z = RANDOM_FLOAT(-32, 32) * f_scale;
         break;
      case 4:
         // BAD, offset lots for x, y, and z
         target = pBotEnemy->v.origin;  // aim for the body
         d_x = RANDOM_FLOAT(-35, 35) * f_scale;
         d_y = RANDOM_FLOAT(-35, 35) * f_scale;
         d_z = RANDOM_FLOAT(-50, 50) * f_scale;
         break;
   }
   target = target + Vector(d_x, d_y, d_z);

   return target;
}



bool BotShootAtEnemy( bot_t *pBot )
{
	int pref=-1;
	edict_t *pEdict = pBot->pEdict;
	TraceResult tr;
	Vector v_angle;
	Vector v_enemy = pBot->pBotEnemy->v.origin + pBot->pBotEnemy->v.view_ofs;
	const char * targetName = STRING(pBot->pBotEnemy->v.classname);
	TargetType targetType;

	if (FStrEq(targetName, "player"))
	{
		targetType = TargetType_player;
	}
	else if (FStrEq(targetName, "building_sentrygun"))
	{
		targetType = TargetType_sentry;
	}
	else
	{
		targetType = TargetType_player;
	}

   // aim for the head and/or body
	Vector v_start = pEdict->v.origin + pEdict->v.view_ofs; //pBot->weapons[pBot->current_weapon.iId]->GetBarrelOffset();
	UTIL_TraceLine(v_start, v_enemy, ignore_monsters, ignore_glass, pEdict, &tr);

	if (tr.flFraction < 1.0)
	{
		if (pBot->f_see_enemy_time < gpGlobals->time)
		{
			if (taunt_used > -1) 
			{
				if (RANDOM_LONG(0, 300) < bot_chat_freq) 
				{
					if (strcmp(STRING(pBot->pBotEnemy->v.classname), "player") == 0) 
					{
						char buffer[128];
						sprintf(buffer, bot_taunt[RANDOM_LONG(0, taunt_used)], STRING(pBot->pBotEnemy->v.netname));
						 BotSayText(pBot, buffer, RANDOM_FLOAT(1.5,5), FALSE, FALSE);
						//UTIL_SayText(buffer, pBot->pEdict, FALSE);
					}
				}
			}
	  		pBot->pBotEnemy = NULL;
			pBot->f_see_enemy_time = 0;
  			return TRUE;	
		}
		else
		{
			return TRUE;
		}
  	}
	else
	{
		pBot->f_see_enemy_time = gpGlobals->time + 3.0;
		pBot->lastEnemyOrigin = v_enemy;
	}

	v_enemy = v_enemy - v_start;

	 //Vector v_enemy = pBot->pBotEnemy->v.origin - pEdict->v.origin;

   // select the best weapon to use at this distance and fire...

	if (pBot->state == STATE_SNIPING && pBot->stateTime > gpGlobals->time && pBot->stateTime != 0 && v_enemy.Length() > 250.0) 
	{
		if (mod_id == FLF_DLL) 
		{
			if (pBot->pEdict->v.weapons & FLF_WEAPON_MSG90) 
			{
				pref = FLF_WEAPON_MSG90;
			}
			else if (pBot->pEdict->v.weapons & FLF_WEAPON_SAKO) 
			{
				pref = FLF_WEAPON_SAKO;
			}
		}
		else if (mod_id == TFC_DLL) 
		{
			pref = TF_WEAPON_SNIPERRIFLE;
		}
		else if (mod_id == VALVE_DLL) 
		{
			pref = VALVE_WEAPON_CROSSBOW;
		} 
		else if (mod_id == SI_DLL) 
		{
			pref = SI_WEAPON_CROSSBOW;
		}
	}

	if (!BotChooseWeapon(pBot, v_enemy, pref, targetType))
	{
		return FALSE;
	}


	if (mod_id == TFC_DLL || mod_id == FLF_DLL)
	{
		v_enemy = pBot->weapons[pBot->current_weapon.iId]->GetTargetVector(pEdict->v.origin, pBot->pBotEnemy->v.origin, pBot->pBotEnemy);
	}
	else
	{
		v_enemy = BotBodyTarget( pBot->pBotEnemy, pBot ) - pEdict->v.origin - pEdict->v.view_ofs;
	}

	 /*
	 if (mod_id == FLF_DLL) {
		 if (pBot->current_weapon.iId == FLF_WEAPON_HK21 || pBot->current_weapon.iId == FLF_WEAPON_SPAS12) {
			 v_enemy = BotBodyTarget(pBot->pBotEnemy, pBot) - pEdict->v.origin;
		 }
	 } else {
		 v_enemy = BotBodyTarget( pBot->pBotEnemy, pBot ) - GetGunPosition(pEdict);
	 }
	 */

	/*
	 if (INDEXENT(1) != NULL) {
	 		WaypointDrawBeam( INDEXENT(1), GetGunPosition(pBot->pEdict), GetGunPosition(pBot->pEdict)+v_enemy, 10, 2, 250, 250, 250, 200, 10);
	 }
	*/

	if (mod_id == TFC_DLL || mod_id == FLF_DLL) //confuse the bot some
	{
		v_angle = UTIL_VecToAngles(v_enemy);
		pBot->to_pitch = abs(pEdict->v.v_angle.x - v_angle.x);
		pBot->to_yaw = abs(pEdict->v.v_angle.y - v_angle.y);
		if (pBot->to_yaw > 180)
		{
			pBot->to_yaw = 360 - pBot->to_yaw;
		}
		if (pBot->to_pitch >180)
		{
			pBot->to_pitch = 360 - pBot->to_pitch;
		}
		v_enemy = pBot->weapons[pBot->current_weapon.iId]->FuzzAiming(v_enemy);
	}


	v_angle = UTIL_VecToAngles( v_enemy );
	if (v_angle.y > 180)
	 	 v_angle.y -=360;
   // Paulo-La-Frite - START bot aiming bug fix
   if (v_angle.x > 180)
      v_angle.x -=360;


	if (mod_id == TFC_DLL || mod_id == FLF_DLL)//rotate and aim
	{
	    pBot->last_pitch = CombatChangePitch(pEdict, -v_angle.x, 15.0);
		pBot->last_yaw = CombatChangeYaw(pEdict, v_angle.y, 20.0);
	}
	else //just shoot the bastard
	{
		pEdict->v.v_angle.y = v_angle.y;
		pEdict->v.v_angle.x = -v_angle.x;
	}
	//pEdict->v.v_angle.y = v_angle.y;
	//pEdict->v.v_angle.x = -v_angle.x;




   /*
   if (BotChangeYaw(pBot, 20) == 0 || pBot->weapon_status == BOT_WEAPON_FIRING) 
   {
	   answer = BotFireWeapon( v_enemy, pBot, pref );
   }
   else
   {
	   answer = TRUE; //moving;
   }
   */
   /*
   v_angle.x *= -1.0;
   pEdict->v.v_angle = v_angle;
   */

   // set the body angles to point the gun correctly
   pEdict->v.angles.x = pEdict->v.v_angle.x / -3.0;
   pEdict->v.angles.y = pEdict->v.v_angle.y;
   pEdict->v.angles.z = 0;


   // adjust the view angle pitch to aim correctly (MUST be after body v.angles stuff)
   //pEdict->v.v_angle.x = -pEdict->v.v_angle.x;
   // Paulo-La-Frite - END

   //pEdict->v.ideal_yaw = pEdict->v.v_angle.y;

    pEdict->v.ideal_yaw = v_angle.y;
    pEdict->v.idealpitch = v_angle.x;

	BotFixIdealYaw(pEdict);
	BotFixIdealPitch(pEdict);

	return BotFireWeapon(v_enemy, pBot, pref); // answer;

}


void TakeCover(bot_t *pBot) {
	edict_t *pEnemy = pBot->pBotEnemy;
	edict_t *pEdict = pBot->pEdict;
	Vector v_enemy = GetGunPosition(pEnemy);
	Vector origin = GetGunPosition(pEdict);
	Vector v_right=pBot->pEdict->v.angles, v_forward=v_right;
	Vector v_current; int direction = 1, d =0; bool crouch = FALSE;
	float length;
	TraceResult tr;
	UTIL_MakeVectors(v_forward);
	v_right = gpGlobals->v_right;
	v_forward = gpGlobals->v_forward;
	if (pBot->pEdict->v.flags & FL_DUCKING) {
		origin.z += 18;
	}
	for (length = 0; length <= 300; length +=30) {
		for (direction = 0 ; direction < 4; direction++) {
			if (direction == 0) {
				v_current = origin + v_forward*length;
			} else if (direction == 1) {
				v_current = origin + v_right*length;
			} else if (direction == 2) {
				v_current = origin - v_right*length;
			} else if (direction == 3) {
				v_current = origin - v_forward*length;
			}
			UTIL_TraceLine(origin, v_current, ignore_monsters, pEdict, &tr);
			if (tr.flFraction < 1.0) {
				continue; //can't get there;
			}
			UTIL_TraceLine(v_current, v_enemy, ignore_monsters, ignore_glass, pEdict, &tr);
			if (tr.flFraction < 1.0) {
				goto outer;
			} else {
				v_current.z-=18;
				UTIL_TraceLine(v_current, v_enemy, ignore_monsters, ignore_glass, pEdict, &tr);
				if (tr.flFraction < 1.0) {
					crouch = TRUE;
					goto outer;
				}
			}
		}
	}
	outer:
	if (length <= 300) {
  //WaypointDrawBeam(INDEXENT(1), v_current, origin, 30, 0, 255, 50, 50, 250, 5);
		if (length != 0) {
			switch (direction) {
				case 0:  pBot->f_move_speed = pBot->f_max_speed; pBot->f_strafe_speed = 0; break;
				case 1:  pBot->f_strafe_speed = pBot->f_max_speed; pBot->f_move_speed = 0; break;
				case 2:  pBot->f_strafe_speed = -pBot->f_max_speed; pBot->f_move_speed = 0; break;
				case 3:  pBot->f_move_speed = -pBot->f_max_speed; pBot->f_strafe_speed = 0; break;
			}
		} else {
			pBot->f_move_speed = 0;
			pBot->f_strafe_speed = 0;
		}
	}
	if (crouch) pBot->crouchTime = gpGlobals->time + 0.5;
}

void BotThrowGrenade(bot_t *pBot) {
	bool gren1 = TRUE, gren2 = TRUE;
	int num;
	Vector v_enemy = pBot->pBotEnemy->v.origin - pBot->pEdict->v.origin;
	TraceResult tr;
	if (pBot->grenadeTime != 0) return ;
	if (v_enemy.z > 25) return ; //dont throw above you
	if (v_enemy.Length() > 400) return ;
	if (RANDOM_LONG(0,100) > gren_usage) {
		pBot->grenadeTime = gpGlobals->time + RANDOM_FLOAT(3,8);
		return ;
	}
	UTIL_TraceLine(pBot->pBotEnemy->v.origin, pBot->pEdict->v.origin, ignore_monsters, pBot->pEdict, &tr);
	if (tr.flFraction < 1.0) return ;
	switch(pBot->bot_class) {
		case 1: gren1 = FALSE; break;
	}
	if (pBot->tfc_grenades[0] == 0) {
		gren1 = FALSE;
	}
	if (pBot->tfc_grenades[1] == 0) {
		gren2 = FALSE;
	}
	num = RANDOM_LONG(1,2);
	if (!gren1 && num == 1) {
	  num = 2;
	} else if (!gren2 && num == 2) {
		num = 1;
	}
	if (!gren1 && num == 1) {
	  return;
	} else if (!gren2 && num == 2) {
		return;
	}
	float factor = 1.0;
	switch (pBot->bot_skill) {
		case 3: factor = 1.1; break;
		case 4: factor = 1.5; break;
		case 5: factor = 4; break;
	}

	if (num == 1) {
		FakeClientCommand(pBot->pEdict, "+gren1 102");
	} else {
		FakeClientCommand(pBot->pEdict, "+gren2 103");
	}
	pBot->grenadeTime = gpGlobals->time + RANDOM_FLOAT(0.5,1.0)*factor;
	pBot->grenadeNum = num;
}

float CombatChangeYaw(edict_t *pEdict, float ideal, float yawSpeed)
{
	float difference, current, turned = yawSpeed;
	current = pEdict->v.v_angle.y;
	difference = abs(current - ideal);
	if (difference > 180.0)
	{
		difference = 360.0 - difference;
	}

	if (difference < yawSpeed)
	{
		current = ideal;
		turned = difference;
	}
	else if (current > -90.0 && current < 90.0)
	{
		if (current - ideal > 0.0)
		{
			current -= yawSpeed;
		}
		else
		{
			current += yawSpeed;
		}
	}
	else if ((current < 0.0 && ideal < 0.0) || (current > 0.0  && ideal > 0.0))
	{
		if (current < ideal)
		{
			current += yawSpeed;
		}
		else
		{
			current -= yawSpeed;
		}
	}
	else // if (current < -90) || current > 90.0
	{
		if (current - ideal > 0.0)
		{
			current -= yawSpeed;
		}
		else
		{
			current += yawSpeed;
		}
	}
	if (current > 180.0)
	{
		current -= 360;
	}
	else if (current < -180.0)
	{
		current += 360.0;
	}
	pEdict->v.v_angle.y = current;
	return turned;
}

float CombatChangePitch(edict_t *pEdict, float ideal, float yawSpeed)
{
	float difference, current, turned = yawSpeed;
	current = pEdict->v.v_angle.x;
	difference = abs(current - ideal);
	if (difference > 180.0)
	{
		difference = 360.0 - difference;
	}

	if (difference < yawSpeed)
	{
		current = ideal;
		turned = difference;
	}
	else if (current > -90.0 && current < 90.0)
	{
		if (current - ideal > 0.0)
		{
			current -= yawSpeed;
		}
		else
		{
			current += yawSpeed;
		}
	}
	else if ((current < 0.0 && ideal < 0.0) || (current > 0.0  && ideal > 0.0))
	{
		if (current < ideal)
		{
			current += yawSpeed;
		}
		else
		{
			current -= yawSpeed;
		}
	}
	else // if (current < -90) || current > 90.0
	{
		if (current - ideal > 0.0)
		{
			current -= yawSpeed;
		}
		else
		{
			current += yawSpeed;
		}
	}
	if (current > 180.0)
	{
		current -= 360.0;
	}
	else if (current < -180.0)
	{
		current += 360.0;
	}
	pEdict->v.v_angle.x = current;
	return turned;
}
