//
// HPB bot - botman's High Ping Bastard bot
//
// (http://planethalflife.com/botman/)
//
// bot_navigate.cpp
//

#ifndef _WIN32
#include <string.h>
#endif

#include <extdll.h>
#include <dllapi.h>
#include <h_export.h>
#include <meta_api.h>

#include "bot.h"
#include "bot_func.h"
#include "waypoint.h"
#include "bot_weapons.h"
#include "logging.h"

bool alreadyVisited(bot_t *pBot, int num);
bool isReachable(bot_t *pBot, int num);

extern int mod_id;
extern int num_waypoints;
extern WAYPOINT waypoints[MAX_WAYPOINTS];
//extern int tf_allies[4];
extern tf_team_data tf_data[4];

struct CLASS_STAT {
	int maxHealth;
	int maxArmor;
};


extern tf_map_data_t tf_map;

struct CLASS_STAT tfc_stats[10] = {
	{100,100}, //TFC_CLASS_CIVILIAN
	{75,50}, //TFC_CLASS_SCOUT
	{90,50}, //TFC_CLASS_SNIPER
	{100,200}, //TFC_CLASS_SOLDIER
	{90,120}, //TFC_CLASS_DEMOMAN
	{90,100}, //TFC_CLASS_MEDIC
	{100,300}, //TFC_CLASS_HWGUY
	{100,150},  //TFC_CLASS_PYRO
	{90,100},	//TFC_CLASS_SPY
	{80,50}	//TFC_CLASS_ENGINEER
};

void BotFixIdealPitch(edict_t *pEdict)
{
   // check for wrap around of angle...
   if (pEdict->v.idealpitch > 180)
      pEdict->v.idealpitch -= 360;

   if (pEdict->v.idealpitch < -180)
      pEdict->v.idealpitch += 360;
}


float BotChangePitch( bot_t *pBot, float speed )
{
   edict_t *pEdict = pBot->pEdict;
   float ideal;
   float current;
   float current_180;  // current +/- 180 degrees
   float diff;

   // turn from the current v_angle pitch to the idealpitch by selecting
   // the quickest way to turn to face that direction

   current = pEdict->v.v_angle.x;

   ideal = pEdict->v.idealpitch;

   // find the difference in the current and ideal angle
   diff = abs(current - ideal);

   // check if the bot is already facing the idealpitch direction...
   if (diff <= 1)
      return diff;  // return number of degrees turned

   // check if difference is less than the max degrees per turn
   if (diff < speed)
      speed = diff;  // just need to turn a little bit (less than max)

   // here we have four cases, both angle positive, one positive and
   // the other negative, one negative and the other positive, or
   // both negative.  handle each case separately...

   if ((current >= 0) && (ideal >= 0))  // both positive
   {
      if (current > ideal)
         current -= speed;
      else
         current += speed;
   }
   else if ((current >= 0) && (ideal < 0))
   {
      current_180 = current - 180;

      if (current_180 > ideal)
         current += speed;
      else
         current -= speed;
   }
   else if ((current < 0) && (ideal >= 0))
   {
      current_180 = current + 180;
      if (current_180 > ideal)
         current += speed;
      else
         current -= speed;
   }
   else  // (current < 0) && (ideal < 0)  both negative
   {
      if (current > ideal)
         current -= speed;
      else
         current += speed;
   }

   // check for wrap around of angle...
   if (current > 180)
      current -= 360;
   if (current < -180)
      current += 360;

   pEdict->v.v_angle.x = current;

   return speed;  // return number of degrees turned
}


void BotFixIdealYaw(edict_t *pEdict)
{
   // check for wrap around of angle...
   if (pEdict->v.ideal_yaw > 180)
      pEdict->v.ideal_yaw -= 360;

   if (pEdict->v.ideal_yaw < -180)
      pEdict->v.ideal_yaw += 360;
}


float BotChangeYaw( bot_t *pBot, float speed )
{
   edict_t *pEdict = pBot->pEdict;
   float ideal;
   float current;
   float current_180;  // current +/- 180 degrees
   float diff;

   // turn from the current v_angle yaw to the ideal_yaw by selecting
   // the quickest way to turn to face that direction

   current = pEdict->v.v_angle.y;

   ideal = pEdict->v.ideal_yaw;

   // find the difference in the current and ideal angle
   diff = abs(current - ideal);

   // check if the bot is already facing the ideal_yaw direction...
   if (diff <= 1)
   {
	   pEdict->v.v_angle.y = pEdict->v.ideal_yaw;
       return diff;  // return number of degrees turned
   }

   // check if difference is less than the max degrees per turn
   if (diff < speed)
      speed = diff;  // just need to turn a little bit (less than max)

   // here we have four cases, both angle positive, one positive and
   // the other negative, one negative and the other positive, or
   // both negative.  handle each case separately...

   if ((current >= 0) && (ideal >= 0))  // both positive
   {
      if (current > ideal)
         current -= speed;
      else
         current += speed;
   }
   else if ((current >= 0) && (ideal < 0))
   {
      current_180 = current - 180;

      if (current_180 > ideal)
         current += speed;
      else
         current -= speed;
   }
   else if ((current < 0) && (ideal >= 0))
   {
      current_180 = current + 180;
      if (current_180 > ideal)
         current += speed;
      else
         current -= speed;
   }
   else  // (current < 0) && (ideal < 0)  both negative
   {
      if (current > ideal)
         current -= speed;
      else
         current += speed;
   }

   // check for wrap around of angle...
   if (current > 180)
      current -= 360;
   if (current < -180)
      current += 360;

   pEdict->v.v_angle.y = current;

   return speed;  // return number of degrees turned
}


bool isReachable(Vector v_src, Vector v_dest, edict_t *pEntity) {
	Vector theDifference = v_dest-v_src;
	TraceResult tr;
	if (theDifference.Length() > REACHABLE_RANGE) return FALSE;
  UTIL_TraceLine( v_src, v_dest, ignore_monsters, pEntity->v.pContainingEntity, &tr );
	if (tr.flFraction >=1.0) {
		return TRUE;
	}
	return FALSE;
}

bool BotFindNextWaypoint(bot_t *pBot) {
	return FALSE;
}

bool BotFindWaypoint( bot_t *pBot, int team ) {
	pBot->currentPoint = WaypointFindNearest(pBot->pEdict, REACHABLE_RANGE, team);
	return (pBot->currentPoint!=-1);
}


bool BotHeadTowardWaypoint( bot_t *pBot ) {
	// Do whatever you want here to get the bot to head towards the current
  // waypoint.  Remember to handle movement on land, underwater, on ladders,
  // and in the air (jetpacks) if necessary.  Return TRUE if the bot can
  // still get to the next waypoint, or FALSE if the next waypoint is now
  // unreachable for some reason.
	//UTIL_ClientPrintAll( HUD_PRINTCENTER, "BotHeadTowardWaypoint called\n"); //, param1, param2, param3, param4 );
	int current=-1;
	float range = 45.0;
	float distance = -1.0;
	int waypoint_position = POSITION_UNKNOWN;
	bool move = TRUE;

	if (pBot->pickingup)
	{
		pBot->pickupItemTime = 0; //can pick up items again
		pBot->pickingup = FALSE;
	}


	if (pBot->currentPoint > -1 && (pBot->checkTime < gpGlobals->time || pBot->checkPath == TRUE)) 
	{
		if (WaypointReachable(pBot->pEdict->v.origin, waypoints[pBot->currentPoint].origin, pBot->pEdict))
		{
			pBot->checkPath = FALSE;
			pBot->checkTime = gpGlobals->time+15.0;
		}
		else 
		{
			pBot->currentPoint = -1; // can't get to it, so select a new one
			pBot->destination =-1;
			pBot->waypoints_upto = -1;
			pBot->lastpoint = -1;
		}
	}

	if (pBot->currentPoint < 0)
	{
		BotFindWaypoint(pBot, Waypoint_GetTeam(pBot));
		pBot->checkTime = gpGlobals->time+3.0;
		pBot->waypoints_upto = -1;
		pBot->f_last_distance = -1;
	}

	if (pBot->destination < 0) 
	{
		BotNewDestination(pBot);
		pBot->waypoints_upto = -1;
	}

	if ( (pBot->currentPoint > -1) && (waypoints[pBot->currentPoint].flags & W_FL_LADDER) && (pBot->pEdict->v.movetype == MOVETYPE_FLY) ) 
	{
		range = 10.0;
	}

	if (pBot->currentPoint > -1 && waypoints[pBot->currentPoint].flags & W_FL_DOOR) {
		range = 20.0;
	}

	if (pBot->currentPoint > -1)
	{
		//all 3d now
		distance = (pBot->pEdict->v.origin-waypoints[pBot->currentPoint].origin).Length();
		/*
		if ( (waypoints[pBot->currentPoint].flags & (W_FL_LADDER | W_FL_LIFT) ) || POINT_CONTENTS(waypoints[pBot->currentPoint].origin) == CONTENTS_WATER) 
		{
			distance = (pBot->pEdict->v.origin-waypoints[pBot->currentPoint].origin).Length();
		}
		else 
		{
			Vector2D v_bot, v_point;
			v_bot = Vector2D(pBot->pEdict->v.origin.x, pBot->pEdict->v.origin.y);
			v_point = Vector2D(waypoints[pBot->currentPoint].origin.x, waypoints[pBot->currentPoint].origin.y);
			distance = (v_point-v_bot).Length();
		}
		*/
	}


	if ( (pBot->currentPoint != -1 && distance < range) ) 
	{
		/*
		if (pBot->currentPoint != pBot->last_point) {
			LogBotMove(Waypoint_GetTeam(pBot), pBot->currentPoint);
		}
		*/
		pBot->f_last_distance = -1;
		pBot->last_point = pBot->currentPoint;
		if (waypoints[pBot->currentPoint].flags & W_FL_JUMP)
		{
			float angle = abs(abs(pBot->pEdict->v.angles.y) - abs(waypoints[pBot->currentPoint].angle));
			if (angle > 180) angle = angle - 360;
			if (angle < 25)
			{
				pBot->pEdict->v.button |= IN_JUMP;
				pBot->crouchTime = gpGlobals->time + 1.5;
			}
		}
		if (pBot->currentPoint == pBot->destination) 
		{
			if (pBot->state == STATE_SNIPING) 
			{
				pBot->pEdict->v.ideal_yaw = waypoints[pBot->currentPoint].angle;
				BotFixIdealYaw(pBot->pEdict);
				pBot->stateTime = gpGlobals->time + RANDOM_FLOAT(30,60);
				pBot->destination = -1; // no more destination
				pBot->waypoints_upto = -1;
				pBot->waypoint_position = POSITION_UNKNOWN;
				return TRUE;
			}
			if (pBot->state == STATE_BUILDING_SENTRY || pBot->state == STATE_BUILDING_DISPENSER) 
			{
				pBot->pEdict->v.ideal_yaw = waypoints[pBot->currentPoint].angle;
				BotFixIdealYaw(pBot->pEdict);
				pBot->stateTime = gpGlobals->time + 12; //10 secs to build a sentry
				pBot->destination = -1; // no more destination
				pBot->waypoints_upto = -1;
				pBot->waypoint_position = POSITION_UNKNOWN;
				return TRUE;
			}
			if (pBot->state == STATE_DETPACKING) 
			{
				pBot->stateTime = gpGlobals->time + 3;
				pBot->destination = -1; // no more destination
				pBot->waypoints_upto = -1;
				pBot->waypoint_position = POSITION_UNKNOWN;
				return TRUE;
			}
			pBot->destination = -1;
		}
		//current = getNextWaypoint(pBot->currentPoint, pBot->destination, pBot->pEdict);
		current = getNextWaypoint(pBot);
		if (current < 0) {
			BotNewDestination(pBot);
			//pBot->currentPoint = getNextWaypoint(pBot->currentPoint, pBot->destination, pBot->pEdict);
			pBot->currentPoint= getNextWaypoint(pBot);
		} 
		else 
		{
			pBot->lastpoint = pBot->currentPoint;
			pBot->currentPoint = current;
			pBot->checkTime = gpGlobals->time+3.0;
		}
	} 


	if (pBot->currentPoint > -1) 
	{
		//fp = fopen("botlog.txt", "a"); fprintf(fp, "I'm headed towards %d\n", pBot->currentPoint); fclose(fp);
		Vector toWaypoint = (waypoints[pBot->currentPoint].origin)-(pBot->pEdict->v.origin);
		Vector waypointAngles = UTIL_VecToAngles(toWaypoint);

		if (toWaypoint.Length2D() > 5.0)
		{
			pBot->pEdict->v.ideal_yaw = waypointAngles.y;
			BotFixIdealYaw(pBot->pEdict);
		}
		pBot->f_move_speed = pBot->f_max_speed;

		pBot->view_target = waypoints[pBot->currentPoint].origin;
		if (pBot->pEdict->v.movetype==MOVETYPE_FLY) 
		{
			pBot->pEdict->v.idealpitch = pBot->pEdict->v.v_angle.x = -waypointAngles.x;
			pBot->pEdict->v.button |= IN_FORWARD;
			if ((waypoints[pBot->currentPoint].flags & W_FL_LADDER) == 0 && toWaypoint.z <= 0)
			{
				pBot->pEdict->v.button |= IN_JUMP;
				//pBot->pEdict->v.button |= IN_DUCK;
				//pBot->crouchTime = gpGlobals->time + 1.5;
			}
		}
		else if (POINT_CONTENTS(waypoints[pBot->currentPoint].origin) == CONTENTS_WATER || pBot->pEdict->v.waterlevel == 3 ) 
		{
			pBot->pEdict->v.v_angle.x = -waypointAngles.x;
		}
		else
		{
			pBot->pEdict->v.v_angle.x = 0;
		}
		if(waypoints[pBot->currentPoint].flags & W_FL_LADDER) 
		{
			if (pBot->pEdict->v.movetype!=MOVETYPE_FLY && toWaypoint.Length() < 45.0) 
			{ //not at the ladder yet
				pBot->f_move_speed = pBot->f_move_speed / 4; // slow down
			}
		}
		if(waypoints[pBot->currentPoint].flags & W_FL_DOOR && toWaypoint.Length() < 45.0) 
		{
			pBot->f_move_speed = pBot->f_move_speed / 2; // slow down
		}

		if (waypoints[pBot->currentPoint].flags & W_FL_CROUCH) 
		{
			pBot->pEdict->v.button |= IN_DUCK;
		}

		if (waypoints[pBot->currentPoint].flags & W_FL_LIFT)
		{
			if ( pBot->last_point > -1 && ((waypoints[pBot->last_point].flags & W_FL_LIFT) == 0) ) 
			{
				move = BotCanMoveTowardsLift(pBot);
			}
		}

		if (move) 
		{
			float current_yaw;
			float a,d;
			current_yaw = pBot->pEdict->v.v_angle.y;
			/* not needed
			if (current_yaw > 180.0)
			{
				current_yaw -= 360;
			}
			*/
			a = abs(pBot->pEdict->v.ideal_yaw - current_yaw);
			if (a > 180.0)
			{
				a = 360.0-a;
			}
			d = toWaypoint.Length();
			float t = a; //(DEGREES_PER_SECOND + a);
			t = MIN(t, 180);
			t *= 3.14159/180.0;
			float slop = atan(range/d); //range calculated above
			if (t > slop)
			{
				float v = (3.14159 - t) * toWaypoint.Length2D();
				v /= sin(t);
				v = MAX(v, 0);
				v = MIN(v, pBot->f_move_speed);
				if (v == 0.0)
				{
					pBot->stopped = TRUE;
				}
				pBot->f_move_speed = pBot->f_ideal_speed = v;
			}
		} 
		/*
		if (move) 
		{
			//pBot->f_move_speed = pBot->f_max_speed;
			float t = abs(pBot->pEdict->v.ideal_yaw - pBot->pEdict->v.angles.y);
			if (t != 0) 
			{
				float v = (DEGREES_PER_SECOND - t) * toWaypoint.Length()* 3.14159 / 180.0;
				v /= sin(t);
				v = MAX(v, 0);
				v = MIN(v, pBot->f_move_speed);
				pBot->f_move_speed = pBot->f_ideal_speed = v;
			}
			/*
			if (distance < range * 3.0) 
			{
				pBot->f_move_speed = pBot->f_move_speed/3.0;
			}
		}
		*/
		else 
		{
			pBot->f_move_speed = pBot->f_ideal_speed = 0; //stop
			pBot->stopped = TRUE;
		}

		pBot->waypoint_position = waypoint_position;
		return TRUE;
	}
	else 
	{
		pBot->waypoint_position = POSITION_UNKNOWN;
		return FALSE;  // couldn't get to next waypoint
	}
}

void BotNewDestination(bot_t *pBot)
{
	int choice = -1, current = pBot->currentPoint;
	bool reachable[MAX_WAYPOINTS];
	int oldState = pBot->state;
	float oldStateTime = pBot->stateTime;

	pBot->state = STATE_NONE;
	pBot->stateTime = 0.0;

	GetReachableWaypoints(pBot, reachable);
	int possibles_used = 0;
	if (pBot->gotFlag)
	{
		choice = FindRandomReachableWaypoint(reachable, W_FL_FLAG_GOAL);
	}
	if (mod_id == TFC_DLL)
	{
		if (pBot->bot_class == TFC_CLASS_CIVILIAN) 
		{
			choice = FindRandomReachableWaypoint(reachable, W_FL_FLAG_GOAL);
			if (choice == -1)
			{
				choice = FindRandomReachableWaypoint(reachable, W_FL_FLAG);
			}
			else
			{
				UTIL_SayText("Heading For Garage", pBot->pEdict, TRUE);
			}
		}
	} /* tfc */
	if (mod_id != FLF_DLL && choice == -1)
	{
		if (pBot->pEdict->v.health < BotMaxHealth(pBot)/2)
		{
			choice = FindNearestReachableWaypoint(pBot, reachable, W_FL_HEALTH);
		}
		if (choice == -1 && pBot->pEdict->v.armorvalue < BotMaxArmor(pBot)/3)
		{
			choice = FindNearestReachableWaypoint(pBot, reachable, W_FL_ARMOR);
		}
		if (choice == -1 && BotNeedAmmo(pBot))
		{
			choice = FindNearestReachableWaypoint(pBot, reachable, W_FL_AMMO);
		}
	} /* not flf */
	if (mod_id == TFC_DLL && choice  == -1)
	{
		if (choice == -1 && (pBot->behaviour == BEHAVE_GUARD || pBot->bot_class == TFC_CLASS_ENGINEER))
		{
			if (pBot->bot_class == TFC_CLASS_ENGINEER)
			{
				if (BotCanBuildSentry(pBot)) 
				{
					choice = FindRandomReachableWaypoint(reachable, W_FL_SENTRY);
					if (choice > -1) 
					{
						pBot->state = STATE_BUILDING_SENTRY;
					}
				}
				if (choice == -1) 
				{
					int sentry = RepairSentry(pBot);
					if (sentry == -1 || (reachable[sentry] == FALSE)) choice = -1;
					else if (sentry == pBot->currentPoint) choice = -1;
					else choice = sentry;
				}
				if (choice == -1 && BotCanBuildDispenser(pBot))
				{
					choice = FindRandomReachableWaypoint(reachable, W_FL_DISPENSER);
					if (choice > -1) 
					{
						edict_t * pDisp = NULL;
						while ((pDisp = UTIL_FindEntityInSphere(pDisp, waypoints[choice].origin, 150)) != NULL)
						{
							if (strcmp(STRING(pDisp->v.classname), "building_dispenser") == 0)
							{
								choice = -1;
								break;
							}
						}
						if (choice > -1)
						{
							pBot->state = STATE_BUILDING_DISPENSER;
						}
					}
					if (choice == -1 && pBot->pDispenser && pBot->dispenser_health < 100)
					{
						choice = WaypointFindNearest(pBot->pDispenser, 150, Waypoint_GetTeam(pBot));
						if (choice == -1 || reachable[choice] == FALSE) choice = -1;
					}
				}
			} /* engineer specific */
			if (choice == -1)
			{
				choice = FindRandomReachableWaypoint(reachable, W_FL_GUARD);
				if (pBot->behaviour == BEHAVE_GUARD)
				{
					if (choice == -1)
					{
						UTIL_SayText("Cannot Guard", pBot->pEdict, TRUE);
						//pBot->behaviour = BEHAVE_NONE;
					}
					else if (RANDOM_LONG(0, 100) < 20)
					{
						UTIL_SayText("Guarding", pBot->pEdict, TRUE);
					}
				}
			}
		} /*guard or engineer */
		if (pBot->behaviour == BEHAVE_ATTACK && choice == -1)
		{
			if (tf_map.reverseCTF && (RANDOM_LONG(0,100) < 95))
			{
				choice = FindRandomReachableWaypoint(reachable, W_FL_FLAG_GOAL);
			}
			else
			{
				choice = FindRandomReachableWaypoint(reachable, W_FL_FLAG);
			}
			if (choice == -1)
			{
				UTIL_SayText("Cannot Attack", pBot->pEdict, TRUE);
			}
			else if (RANDOM_LONG(0,100) < 20)
			{
				UTIL_SayText("Attacking", pBot->pEdict, TRUE);
			}
		}
		if (choice == -1 && BotCanSnipe(pBot)) 
		{
			choice = FindRandomSniperPoint(reachable);
			if (choice > -1) 
			{
				pBot->state = STATE_SNIPING;
			}
		}
		if (choice == -1 && BotCanDetpack(pBot)) 
		{
			choice = FindRandomReachableWaypoint(reachable, W_FL_DETPACK);
			if (choice > -1) 
			{
				pBot->state = STATE_DETPACKING;
			}
		}

	} /* end tfc */
	if (mod_id == FLF_DLL && choice == -1)
	{
		if (pBot->flf_attacking) 
		{
			choice = FindRandomUncapturedPoint(pBot, reachable);
		}
		else 
		{
			if (BotCanSnipe(pBot))
			{
				choice = FindRandomSniperPoint(reachable);
				if (choice != -1) pBot->state = STATE_SNIPING;
			}
			if (choice == -1)
			{
				choice = FindRandomDefendPoint(pBot, reachable);
			}
		}
		if (choice == -1)
		{
			choice = FindRandomReachableWaypoint(reachable, W_FL_FLAG);
		}
	} /* end flf */
	if (choice == -1 && BotCanGuard(pBot) && RANDOM_LONG(0,100) < 50)
	{
		choice = FindRandomReachableWaypoint(reachable, W_FL_GUARD);
	}
	if (choice == -1 && RANDOM_LONG(0,100) < 50)
	{
		choice = FindRandomReachableWaypoint(reachable, W_FL_VISIT);
	}
	if (choice == -1)
	{
		if (tf_map.reverseCTF && (RANDOM_LONG(0, 100) < 95) )
		{
			choice = FindRandomReachableWaypoint(reachable, W_FL_FLAG_GOAL);
		}
		else
		{
			choice = FindRandomReachableWaypoint(reachable, W_FL_FLAG);
		}
	}
	if (choice == -1)
	{
		choice = FindRandomReachableWaypoint(reachable, W_FL_GUARD);
	}
	if (choice == -1)
	{
		choice = RANDOM_LONG(0, num_waypoints); //FindRandomReachableWaypoint(reachable, W_FL_VISIT);
	}
	pBot->waypoints_upto = -1;
	pBot->destination = choice;
}




void OldBotNewDestination(bot_t *pBot) 
{
	int choice = -1;
	VNode visited[MAX_WAYPOINTS];
	int oldState = pBot->state;
	float oldStateTime = pBot->stateTime;
	///FILE *fp = fopen("botlog.txt", "a"); fprintf(fp, "Getting a new destination.\n"); fclose(fp);

	pBot->state = STATE_NONE;
	pBot->stateTime = 0;
	doPath(pBot->currentPoint, Waypoint_GetTeam(pBot), visited, pBot->pEdict, RandomValue);

	if (choice == -1 && pBot->gotFlag) 
	{
		choice = FindRandomWaypoint(pBot->currentPoint, W_FL_FLAG_GOAL, FALSE, visited);
	}
	if (mod_id == TFC_DLL) {
		if (pBot->bot_class == TFC_CLASS_CIVILIAN) {
			UTIL_SayText("I'm a civilian, shoot me!", pBot->pEdict, FALSE);
			if (choice == -1 && oldState == STATE_DOORS_OPEN) {
				choice = FindRandomWaypoint(pBot->currentPoint, W_FL_FLAG_GOAL, FALSE, visited);
				pBot->stateTime = oldStateTime;
				UTIL_SayText("The doors are open and i'm goin in", pBot->pEdict, TRUE);
			}
			if (choice == -1) {
				choice = FindRandomWaypoint(pBot->currentPoint, W_FL_FLAG, FALSE, visited);
			}
		}
	}
	if (choice == -1 && pBot->pEdict->v.health < BotMaxHealth(pBot)/2) {
		if (mod_id == TFC_DLL && pBot->bot_class == TFC_CLASS_CIVILIAN) {} else {
			choice = FindNearestWaypoint(pBot->currentPoint, W_FL_HEALTH, TRUE, visited);
		}
	}
	if (choice == -1 && pBot->bot_armor < BotMaxArmor(pBot)/3 || BotNeedArmor(pBot) ) {
		if (mod_id == TFC_DLL && pBot->bot_class == TFC_CLASS_CIVILIAN) {} else {
			if (RANDOM_LONG(0,100) < 25) {
				choice = FindNearestWaypoint(pBot->currentPoint, W_FL_ARMOR, TRUE, visited);
			}
		}
	}
	if (choice == -1 && BotNeedAmmo(pBot)) {
		if (mod_id == TFC_DLL && pBot->bot_class == TFC_CLASS_CIVILIAN) {} else {
			choice = FindNearestWaypoint(pBot->currentPoint, W_FL_AMMO, TRUE, visited);
		}
	}
	if (choice == -1 && pBot->behaviour == BEHAVE_GUARD) {
		if (mod_id == TFC_DLL) {
			if (pBot->bot_class == TFC_CLASS_ENGINEER) {
				if (BotCanBuildSentry(pBot)) {
					choice = FindRandomWaypoint(pBot->currentPoint, W_FL_SENTRY, TRUE, visited);
					if (choice > -1) {
						pBot->state = STATE_BUILDING_SENTRY;
					}
				}
				if (choice == -1 && BotCanBuildDispenser(pBot) && RANDOM_LONG(0,100) < 25) {
					choice = FindRandomWaypoint(pBot->currentPoint, W_FL_DISPENSER, TRUE, visited);
					if (choice > -1) {
						pBot->state = STATE_BUILDING_DISPENSER;
					}
				}
				if (choice == -1) {
					int sentry = RepairSentry(pBot);
					int engineer = WaypointFindNearest(pBot->pEdict, 150, UTIL_GetTeam(pBot->pEdict) );
					if (sentry == -1) choice = -1;
					else if (sentry == engineer) choice = -1;
					else choice = sentry;
				}
			}
			if (choice == -1) {
				choice = FindRandomWaypoint(pBot->currentPoint, W_FL_GUARD, TRUE, visited);
			}
			if (choice > -1) {
				if (pBot->commander != NULL && RANDOM_LONG(0,100) < 10)
						UTIL_SayText("Roger that, Guarding", pBot->pEdict, FALSE);
			} else {
				if (pBot->commander != NULL)
					UTIL_SayText("Negative, I cannot guard", pBot->pEdict, FALSE);
				pBot->behaviour = BEHAVE_NONE;
			}
		}
	}
	if (choice == -1 && pBot->behaviour == BEHAVE_ATTACK) {
		if (mod_id == FLF_DLL) {
			choice = FLF_FindUncapturedPoint(pBot, pBot->currentPoint, visited);
		} else {
			choice = FindRandomWaypoint(pBot->currentPoint, W_FL_FLAG, TRUE, visited);
		}
		if (choice > -1) {
			if (pBot->commander != NULL)
				UTIL_SayText("Roger that, Attacking", pBot->pEdict, FALSE);
		} else {
			if (pBot->commander != NULL)
				UTIL_SayText("Negative, I cannot attack", pBot->pEdict, FALSE);
			pBot->behaviour = BEHAVE_NONE;
		}
	}
	if (choice == -1 && (oldState == STATE_GUARDING || (BotCanGuard(pBot) && RANDOM_LONG(0,100) < 25))) {
		choice = FindRandomWaypoint(pBot->currentPoint, W_FL_GUARD, TRUE, visited);
		if (choice > -1) {
			pBot->state = STATE_GUARDING;
			if (oldState == STATE_GUARDING) {
				pBot->stateTime = oldStateTime;
			} else {
				pBot->stateTime = gpGlobals->time + RANDOM_FLOAT(60,300);
			}
		}
	}
	if (choice == -1 && BotCanSnipe(pBot)) {
		//choice = FindRandomWaypoint(pBot->currentPoint, W_FL_SNIPER, TRUE, visited);
		choice = FindSniperPoint(pBot, visited);
		if (choice > -1) {
			pBot->state = STATE_SNIPING;
		}
	}
	if (choice == -1 && BotCanBuildSentry(pBot)) {
		choice = FindRandomWaypoint(pBot->currentPoint, W_FL_SENTRY, TRUE, visited);
		if (choice > -1) {
			pBot->state = STATE_BUILDING_SENTRY;
		}
	}
	if (choice == -1 && BotCanBuildDispenser(pBot)) {
		choice = FindRandomWaypoint(pBot->currentPoint, W_FL_DISPENSER, TRUE, visited);
		if (choice > -1) {
			pBot->state = STATE_BUILDING_DISPENSER;
		}
	}
	if (choice == -1) {
		int sentry = RepairSentry(pBot);
		int engineer = WaypointFindNearest(pBot->pEdict, 150, UTIL_GetTeam(pBot->pEdict) );
		if (sentry == -1) choice = -1;
		else if (sentry == engineer) choice = -1;
		else choice = sentry;
	}
	if (choice == -1 && BotCanDetpack(pBot)) {
		choice = FindUndetonatedPoint(pBot, pBot->currentPoint, visited);
		if (choice > -1) {
			pBot->state = STATE_DETPACKING;
		}
	}
	if ( (choice == -1) && (RANDOM_LONG(0,100) < 90) ) {
		if (mod_id == FLF_DLL) {
			if (pBot->flf_attacking)
			{
				choice = FLF_FindUncapturedPoint(pBot, pBot->currentPoint, visited);
			} else {
				choice = FLF_FindDefendPoint(pBot, pBot->currentPoint, visited);
			}
		} else {
			choice = FindRandomWaypoint(pBot->currentPoint, W_FL_FLAG, TRUE, visited);
		}
	} else if (choice == -1) {
		choice = FindRandomWaypoint(pBot->currentPoint, W_FL_VISIT, TRUE, visited);
	}
	//try again to go for the flag
	if (choice == -1) {
		if (mod_id == FLF_DLL) {
			choice = FLF_FindUncapturedPoint(pBot, pBot->currentPoint, visited);
		}
		else
		{
			choice = FindRandomWaypoint(pBot->currentPoint, W_FL_FLAG, TRUE, visited);
		}
	}

	if (choice  > -1) {
		pBot->destination=choice;
		BotSetMoveType(pBot);
	} else {
  	//fp = fopen("botlog.txt", "a"); fprintf(fp, "The choice is -1, getting a random one.\n"); fclose(fp);
		pBot->destination=RANDOM_LONG(0,num_waypoints);
	}
	pBot->waypoints_upto = -1;
	//fp = fopen("botlog.txt", "a"); fprintf(fp, "My new destination is: %d.\n", pBot->destination); fclose(fp);

}

bool BotFindInteresting(bot_t *pBot) {
	edict_t *pent=NULL;
	float radius = 150;
	char itemName[64];
	bool foundEnt=FALSE;
	TraceResult tr;
	Vector v_ent;
	float pickupTime = 5.0;
	if (!pBot->pickingup && pBot->ignoreItemTime > gpGlobals->time) return FALSE;
	while ((pent = UTIL_FindEntityInSphere( pent, pBot->pEdict->v.origin, radius )) != NULL && !foundEnt) {
		//sprintf(buffer, "Renderamount: %d\n",pent->v.renderamt);
		//UTIL_ClientPrintAll( HUD_PRINTNOTIFY, buffer);
		if (pent->v.effects & EF_NODRAW) continue;
		v_ent = pent->v.origin;

		strcpy(itemName, STRING(pent->v.classname));
		if (strcmp(itemName,"item_healthkit") == 0) {
			if (pBot->pEdict->v.health < BotMaxHealth(pBot)) { //do we need a medikit
				if (BotEntityIsVisible(pBot, v_ent, NULL)) {
					foundEnt=TRUE;
					break;
				}
			}
			continue;
		}
		if ((mod_id == TFC_DLL) && (strcmp(itemName, "player") == 0) && (pent->v.deadflag == DEAD_NO) ) {
			int bot_team = UTIL_GetTeam(pBot->pEdict); //see if they called for a medic
			if (!(BotEntityIsVisible(pBot, v_ent, NULL))) continue;
			int player_team = UTIL_GetTeam(pent);
			int player_max_health=10000;
			int player_max_armor;
			if (pent == pBot->pEdict) continue; //skip self
			if (bot_team != player_team && (((1<<player_team) & tf_data[bot_team].allies)==0) ) continue; //ignore those pricks
			if (pBot->bot_class != TFC_CLASS_MEDIC && pBot->bot_class != TFC_CLASS_ENGINEER) continue;
			player_max_health = tfc_stats[pent->v.playerclass].maxHealth;
			player_max_armor = tfc_stats[pent->v.playerclass].maxArmor;
			if (player_max_health > pent->v.health && pBot->bot_class == TFC_CLASS_MEDIC) {
				if (pBot->current_weapon.iId != TF_WEAPON_MEDIKIT) {
					FakeClientCommand(pBot->pEdict, "tf_weapon_medikit");
					pickupTime = 10.0;
				}
				if (pBot->current_weapon.iId == TF_WEAPON_MEDIKIT) {
					pBot->pEdict->v.button |= IN_ATTACK;
				}
				foundEnt = TRUE;
				break;
			}
			if (player_max_armor > pent->v.armorvalue && pBot->bot_class == TFC_CLASS_ENGINEER) {
				if (pBot->current_weapon.iId != TF_WEAPON_SPANNER) {
					FakeClientCommand(pBot->pEdict, "tf_weapon_spanner");
					pickupTime = 10.0;
				}
				if (pBot->current_weapon.iId == TF_WEAPON_SPANNER) {
					pBot->pEdict->v.button |= IN_ATTACK;
				}
				foundEnt = TRUE;
				break;
			}
			continue;
		}
		if (pent == pBot->pSentry) 
		{
			if (!(BotEntityIsVisible(pBot, v_ent, NULL))) continue;
			if (!RepairSentry(pBot)) continue;
			if (pBot->current_weapon.iId != TF_WEAPON_SPANNER)
			{
				FakeClientCommand(pBot->pEdict, "tf_weapon_spanner");
			}
			if (pBot->current_weapon.iId == TF_WEAPON_SPANNER) 
			{
				pBot->pEdict->v.button |= IN_ATTACK;
			}
			if (pBot->ignoreItemTime < gpGlobals->time) 
			{
				pBot->ignoreItemTime = gpGlobals->time + 6.0;
			}
			if (pBot->ignoreItemTime -3  > gpGlobals->time) 
			{
				pickupTime = 3.0;
				foundEnt = TRUE;
				break;
			}
		}
		if (mod_id == TFC_DLL && pent == pBot->pDispenser && pBot->dispenser_health < 100) {
			if (!(BotEntityIsVisible(pBot, v_ent, NULL))) continue;
			if (pBot->current_weapon.iId != TF_WEAPON_SPANNER) {
				FakeClientCommand(pBot->pEdict, "tf_weapon_spanner");
			}
			if (pBot->current_weapon.iId == TF_WEAPON_SPANNER) {
				pBot->pEdict->v.button |= IN_ATTACK;
			}
			if (pBot->ignoreItemTime < gpGlobals->time) {
				pBot->ignoreItemTime = gpGlobals->time + 5.0;
			}
			if (pBot->ignoreItemTime -3  > gpGlobals->time) {
				pickupTime = 2.0;
				foundEnt = TRUE;
				pBot->pEdict->v.v_angle.x = - UTIL_VecToAngles(v_ent - GetGunPosition(pBot->pEdict)).x;
				break;
			}
		}
		if (mod_id == TFC_DLL && strcmp(itemName, "building_dispenser") == 0) {
			if (!(BotEntityIsVisible(pBot, v_ent, NULL))) continue;
			if (pBot->ignoreItemTime < gpGlobals->time) {
				pBot->ignoreItemTime = gpGlobals->time + 5.0;
			}
			if (pBot->ignoreItemTime -4  > gpGlobals->time) {
				pickupTime = 1.0;
				foundEnt = TRUE;
				break;
			}
		}
		if (mod_id == SI_DLL && pBot->gotFlag == FALSE && strcmp(itemName, "monster_scientist") == 0) {
			if (!(BotEntityIsVisible(pBot, v_ent, NULL))) continue;
			if (UTIL_GetTeam(pBot->pEdict) != UTIL_GetTeam(pent)) {
	  		if (pBot->current_weapon.iId != SI_WEAPON_BRIEFCASE) {
						FakeClientCommand(pBot->pEdict, "use weapon_briefcase");
						pickupTime = 10.0;
				}
				if (pBot->current_weapon.iId == SI_WEAPON_BRIEFCASE) {
					pBot->pEdict->v.button |= IN_ATTACK;
				}
				foundEnt = TRUE;
				break;
			} else {
				continue;
			}
		}
		if (strcmp(itemName,"item_battery") == 0 || strncmp("item_armor", itemName,10) == 0) {
			if (!(BotEntityIsVisible(pBot, v_ent, NULL))) continue;
			if (pBot->pEdict->v.armorvalue < BotMaxArmor(pBot) || BotNeedArmor(pBot))
			{ //do we a battery ?
				foundEnt=TRUE;
				break;
			}
			continue;
		}
		if (strcmp(itemName,"func_healthcharger") == 0) {
			if (pBot->pEdict->v.health < 100) { //do we need health?
				if (pent->v.frame == 0) { //is it on?
					v_ent = VecBModelOrigin(pent);
					if (!(BotEntityIsVisible(pBot, v_ent, pent))) continue;
					UTIL_TraceLine(pBot->pEdict->v.origin, v_ent, ignore_monsters, pBot->pEdict, &tr);
					if (tr.pHit == pent) {
						pBot->stopped = TRUE;
						pickupTime = 15.0;
						pBot->pEdict->v.v_angle.x=0; // look straight ahead
						pBot->pEdict->v.button |= IN_USE; // charge it up
						foundEnt=TRUE;
						break;
					}
				}
			}
			continue;
		}
		if (strcmp(itemName,"func_recharge") == 0) {
			if (pBot->bot_armor < 100) { //do we need armor?
				if (pent->v.frame == 0) { //is it on?
					v_ent = VecBModelOrigin(pent);
					if (!(BotEntityIsVisible(pBot, v_ent, pent))) continue;
					UTIL_TraceLine(pBot->pEdict->v.origin, v_ent, ignore_monsters, pBot->pEdict, &tr);
					if (tr.pHit == pent) {
						pickupTime = 15.0;
						pBot->stopped = TRUE;
						pBot->pEdict->v.v_angle.x=0; // look straight ahead
						pBot->pEdict->v.button |= IN_USE; // charge it up
						foundEnt=TRUE;
						break;
					}
				}
			}
			continue;
		}
		if (strcmp(itemName,"func_button") == 0) {
			if (pent->v.frame == 0) { //is it on?
				v_ent = VecBModelOrigin(pent);
				if (!(BotEntityIsVisible(pBot, v_ent, pent))) continue;
				if ((v_ent -pBot->pEdict->v.origin ).z > 30) continue;
				UTIL_TraceLine(pBot->pEdict->v.origin, v_ent, ignore_monsters, pBot->pEdict, &tr);
				if (tr.pHit == pent) {
					float dist = (pBot->pEdict->v.origin -v_ent).Length() * tr.flFraction;
					if (dist < 50) {
						pBot->stopped = TRUE;
						pBot->pEdict->v.v_angle.x=0; // look straight ahead
						if (RANDOM_LONG(0,100) < 50)
							pBot->pEdict->v.button |= IN_USE; // press dat button
					}
					foundEnt=TRUE;
					break;
				}
			}
			continue;
		}
		if (mod_id == FLF_DLL && pBot->flf_attacking && strcmp(itemName,"capture_point") == 0) 
		{
			if (pBot->pEdict->v.sequence >= 167 && pBot->pEdict->v.sequence <= 169)
			{
				pBot->f_captureTime = gpGlobals->time + 0.5; /* keep timer alive */
			} 
			else if (pBot->f_captureTime == 0.0 || (pBot->f_captureTime + 5.0 < gpGlobals->time))
			{
				pBot->f_captureTime = gpGlobals->time+3;
			} 
			if (pBot->f_captureTime < gpGlobals->time) continue;

			if (!(BotEntityIsVisible(pBot, v_ent, NULL))) continue;
			if (pent->v.skin != UTIL_GetTeam(pBot->pEdict) )
			{ //is it on?
			//if (pent->v.skin == 1) { //UTIL_GetTeam(pBot->pEdict) && BotEntityIsVisible(pBot, v_ent) ) { //is it on?
			  float dist = (pBot->pEdict->v.origin -v_ent).Length(); //* tr.flFraction;
				switch (pBot->bot_class) 
				{
					case FLF_CLASS_RECON: pickupTime = 13; break;
					case FLF_CLASS_ASSAULT: pickupTime = 20; break;
					case FLF_CLASS_SUPPORT: pickupTime = 30; break;
				}
				if (dist <= 60) {
					pBot->stopped = TRUE;
					pBot->pEdict->v.v_angle.x=-(UTIL_VecToAngles(v_ent - pBot->pEdict->v.origin)).x; // look at it
					//if ((v_ent - pBot->pEdict->v.origin).z < -30) pBot->pEdict->v.button |= IN_DUCK;
					if (pBot->cantCaptureTime < gpGlobals->time) {
						pBot->pEdict->v.button |= IN_USE; // press dat button
					}
					pBot->f_move_speed = 0;
					pBot->f_strafe_speed = 0;
				}
				foundEnt=TRUE;
				break;
			}
			continue;
		}
		if (mod_id != FLF_DLL && strncmp("weapon", itemName,6) == 0) { //it's a weapon //weaponboxes too
			if (BotEntityIsVisible(pBot, v_ent, NULL)) {
				foundEnt=TRUE;
				break;
			}
			continue;
		}
		if (strncmp("ammo_", itemName, 5) == 0) { //it's ammo
			if (BotEntityIsVisible(pBot, v_ent, NULL)) {
				foundEnt=TRUE;
				break;
			}
			continue;
		}
		if (strcmp(itemName, "info_tfgoal") == 0) {
			if (BotEntityIsVisible(pBot, v_ent, NULL)) {
				if (strcmp(STRING(pent->v.model), "") == 0) continue;
				if (strcmp(STRING(pent->v.model), "models/backpack.mdl") == 0) {
					int team = UTIL_GetTeam(pent);
					if (team == -1 || team == UTIL_GetTeam(pBot->pEdict))
					{
						TF_BackPack * pack = GetBackPack(pent, FALSE);
						if (pack)
						{
							if (BotNeedBackPack(pBot, pack))
							{
								pBot->ignoreItemTime = gpGlobals->time + 5.0;
								foundEnt=TRUE;
								break;
							}
						}
					}
				}
			}
			continue;
		}
		if (strcmp(itemName, "item_tfgoal") == 0) {
			if (!BotEntityIsVisible(pBot, v_ent, NULL)) continue;
			if (pent->v.owner != NULL) continue;
				if (pBot->gotFlag) continue;
				if (pBot->ignoreItemTime < gpGlobals->time) {
					pBot->ignoreItemTime = gpGlobals->time + 5.0;
				}
				if (pBot->ignoreItemTime - 2  > gpGlobals->time) {
					int team = UTIL_GetTeam(pent);
					if (team == -1 || team == UTIL_GetTeam(pBot->pEdict)) {
						pickupTime = 2.0;
						foundEnt = TRUE;
						break;
					}
				}
			continue;
		}

	} // while

	if (foundEnt==TRUE) {
		//head towards it
		//UTIL_ClientPrintAll( HUD_PRINTNOTIFY, "Found something interesting!\n");
		Vector v_item = v_ent - pBot->pEdict->v.origin;
		Vector bot_angles = UTIL_VecToAngles( v_item );
		if (!pBot->pickingup)
		{
			pBot->pickupItemTime = gpGlobals->time + pickupTime;
			pBot->pickingup = TRUE;
		}
	  	if (pBot->pickingup)
	  	{
	  		if (pBot->pickupItemTime < gpGlobals->time) pBot->ignoreItemTime = gpGlobals->time + pickupTime;
	  	}
		pBot->pEdict->v.ideal_yaw = bot_angles.y;
		if (pBot->pEdict->v.waterlevel == 3) {
			pBot->pEdict->v.v_angle.x = -bot_angles.x;
		}
		BotFixIdealYaw(pBot->pEdict);
		float t = abs(pBot->pEdict->v.ideal_yaw - pBot->pEdict->v.angles.y);
		if (t > 180) t = 360 - t;
		t *= 3.14159/180.0;
		if (t != 0)
		{
			float v = (3.14159 - t) * v_item.Length2D();
			v /= sin(t);
			v = MAX(v, 0);
			v = MIN(v, pBot->f_move_speed);
			if (v == 0.0)
			{
				pBot->stopped = TRUE;
			}
			pBot->f_move_speed = pBot->f_ideal_speed = v;
		}
		pBot->checkPath=TRUE;
		return TRUE;
	}
	return FALSE;
}

bool BotCanSnipe(bot_t * pBot) {
	if (mod_id == VALVE_DLL) {
		if (pBot->bot_weapons & (1<<VALVE_WEAPON_PYTHON)) return TRUE;
		if (pBot->bot_weapons & (1<<VALVE_WEAPON_CROSSBOW)) return TRUE;
	} else if (mod_id == TFC_DLL) {
		if (pBot->bot_weapons & (1<<TF_WEAPON_SNIPERRIFLE)) return TRUE;
	} else if (mod_id == SI_DLL) {
		if ( (pBot->bot_weapons & (1<<SI_WEAPON_CROSSBOW) )&& (RANDOM_LONG(0,100) < 10) ) return TRUE;
	} else if (mod_id == FLF_DLL) {
		if (pBot->flf_attacking) return false; //attackers don't snipe;
		if ( (pBot->bot_weapons & (1<<FLF_WEAPON_MSG90)) ) return TRUE;
	}
	return FALSE;
}

bool BotCanBuildSentry(bot_t *pBot) 
{
	if (mod_id == TFC_DLL) {
		if (pBot->pSentry != NULL) return FALSE; //can't build another
		if (pBot->bot_class == TFC_CLASS_ENGINEER && pBot->m_rgAmmo[2] > 129) return TRUE;
	}
	return FALSE;
}

bool BotCanBuildDispenser(bot_t *pBot)
{
	if (mod_id == TFC_DLL) {
		if (pBot->bot_class == TFC_CLASS_ENGINEER && pBot->m_rgAmmo[2] > 99) return TRUE;
	}
	return FALSE;
}

bool BotCanDetpack(bot_t *pBot) 
{
	if (mod_id == TFC_DLL) {
		if (pBot->bot_class == TFC_CLASS_DEMOMAN && pBot->detpack) return TRUE;
	}
	return FALSE;
}

bool BotCanGuard(bot_t *pBot) 
{ //is this bot a guard?
  if (mod_id == TFC_DLL) {
		if (pBot->bot_class == TFC_CLASS_DEMOMAN || pBot->bot_class == TFC_CLASS_SOLDIER || pBot->bot_class == TFC_CLASS_HWGUY || pBot->bot_class == TFC_CLASS_PYRO) 
		{
			return TRUE;
		}
	}
	if (mod_id == SI_DLL)
	{
		return TRUE;
	}
	return FALSE;
}

int BotMaxHealth(bot_t *pBot) 
{
	if (mod_id == TFC_DLL)
	{
		if (pBot->bot_class != TFC_CLASS_CIVILIAN)
			return tfc_stats[pBot->bot_class].maxHealth;
		return 0;
	} 
	else
	{
		return 100;
	}
}

int BotMaxArmor(bot_t *pBot) 
{
	if (mod_id == TFC_DLL)
	{
		if (pBot->bot_class != TFC_CLASS_CIVILIAN)
			return tfc_stats[pBot->bot_class].maxArmor;
		return 0;
	} 
	else 
	{
		return 100;
	}
}

bool BotNeedArmor(bot_t *pBot) 
{
	if (mod_id == TFC_DLL) 
	{
		/*
		if (pBot->bot_class == TFC_CLASS_ENGINEER) 
		{
			if (pBot->m_rgAmmo[2] < 150) return TRUE;
		}
		*/
		if (pBot->bot_class != TFC_CLASS_CIVILIAN)
			return (pBot->pEdict->v.armorvalue < tfc_stats[pBot->bot_class].maxArmor/2);
	}
	return FALSE;
}

bool BotCanMoveTowardsLift(bot_t *pBot) {
	TraceResult tr;
	Vector from, to;
	char name[64];
	bool reachable = FALSE;
	from = waypoints[pBot->currentPoint].origin;
	to = from;
	to.z -= 100;
	UTIL_TraceLine(from, to, ignore_monsters, pBot->pEdict, &tr);
	if (tr.pHit != NULL)
	{
		strcpy(name, STRING(tr.pHit->v.classname));
		if (FStrEq(name, "func_door"))
		{
			reachable = TRUE;
		}
		else if (FStrEq(name, "func_plat"))
		{
			Vector dimensions = tr.pHit->v.absmax - tr.pHit->v.absmin;
			if (dimensions.z > 50 && dimensions.z < 250.0)
			{
				Vector center = VecBModelOrigin(tr.pHit);
				reachable = (center.z + 30 > waypoints[pBot->currentPoint].origin.z);
			}
			else
			{
				reachable = TRUE;
			}
		}
	}
	return reachable;
}
