
//
// HPB bot - botman's High Ping Bastard bot
//
// (http://planethalflife.com/botman/)
//
// dll.cpp
//

#ifndef _WIN32
#include <string.h>
#endif

#include <extdll.h>
#include <dllapi.h>
#include <h_export.h>
#include <meta_api.h>

#include "bot.h"
#include "bot_func.h"
#include "bot_communicate.h"
#include "waypoint.h"
#include "my_navigate.h"
#include "engine.h"
#include "logging.h"
#include "bot_weapons.h"
#include "server.h"
#include "parser.h"
#include "scripting.h"

extern enginefuncs_t g_engfuncs;
extern int debug_engine;
extern globalvars_t  *gpGlobals;
char g_argv[1024];
extern bool g_waypoint_on;
extern bool g_auto_waypoint;
extern bool g_path_waypoint;
extern int num_waypoints;  // number of waypoints currently in use
extern WAYPOINT waypoints[MAX_WAYPOINTS];
extern float wp_display_time[MAX_WAYPOINTS];
extern bot_t bots[32];

extern float f_path_time;

extern bool checked_deathmatch;
int IsMyBot[32];

extern bool bot_shoot;
extern bool observer;
extern bool check_teams;

static FILE *fp;

const Vector g_vecZero = Vector(0,0,0);

int mod_id = 0;
int m_spriteTexture = 0;
bool isFakeClientCommand = 0;
int isFakeSayText = 0;
int fake_arg_count;
float bot_check_time = 10.0;
int min_bots = -1;
int max_bots = -1;
bool g_GameRules = FALSE;
edict_t *clients[32];
float welcome_time = 0.0;
int welcome_index = -1;
bool welcome_sent = FALSE;

float respawn_time = 0.0;
bool spawn_time_reset = FALSE;

cvar_t sv_bot = {"bot",""};
cvar_t sv_balance = {"bot_balance", "0"};
cvar_t sv_random_names = {"bot_random_names", "0"};
cvar_t sv_bot_exec_default = {"bot_exec_default", "0"};
cvar_t sv_strict_max_bots = {"strict_max_bots", "0"};
cvar_t sv_bot_script = {"bot_script", "1"};
cvar_t sv_bot_message_debug = {"bot_message_debug", "0"};

char welcome_msg[] = "This server is running the ODD Bot\n";
int current_skill = 2;

char bot_names[128][35];
char bot_victory[64][96];
char bot_loss[64][96];
int names_used = -1;
int victory_used = -1;
int loss_used = -1;
char bot_taunt[64][96];
int taunt_used=-1;

extern int bot_names_first;
extern int bot_names_last;


int bot_chat_freq = 50;

float bot_cfg_pause_time = 0;
int prev_num_bots = 0;
int num_bots = 0;

static float pause_time = 0;

float f_bot_think_time = 0;

void UpdateClientData(const struct edict_s *ent, int sendweapons, struct clientdata_s *cd);
bool BotServerCommand(char * cmd_line, BOOL pause);
void ExecuteCFGFile(FILE * cfg_fp);
void LoadTextFiles(void);
extern void welcome_init(void);

extern void UTIL_BuildFileName(char *filename, char *arg1, char *arg2);

DLL_FUNCTIONS gFunctionTable;


// START of Metamod stuff

enginefuncs_t meta_engfuncs;
gamedll_funcs_t *gpGamedllFuncs;
mutil_funcs_t *gpMetaUtilFuncs;
meta_globals_t *gpMetaGlobals;

META_FUNCTIONS gMetaFunctionTable =
{
   NULL, // pfnGetEntityAPI()
   NULL, // pfnGetEntityAPI_Post()
   GetEntityAPI2, // pfnGetEntityAPI2()
   NULL, // pfnGetEntityAPI2_Post()
   NULL, // pfnGetNewDLLFunctions()
   NULL, // pfnGetNewDLLFunctions_Post()
   GetEngineFunctions, // pfnGetEngineFunctions()
   NULL, // pfnGetEngineFunctions_Post()
};

plugin_info_t Plugin_info = {
   META_INTERFACE_VERSION, // interface version
   "ODD bot", // plugin name
   "1.8mm", // plugin version
   "06/12/2004", // date of creation
   "Bots United", // plugin author
   "http://forums.bots-united.com/", // plugin URL
   "ODD_BOT", // plugin logtag
   PT_STARTUP, // when loadable
   PT_ANYTIME, // when unloadable
};


C_DLLEXPORT int Meta_Query (char *ifvers, plugin_info_t **pPlugInfo, mutil_funcs_t *pMetaUtilFuncs)
{
   // this function is the first function ever called by metamod in the plugin DLL. Its purpose
   // is for metamod to retrieve basic information about the plugin, such as its meta-interface
   // version, for ensuring compatibility with the current version of the running metamod.

   // keep track of the pointers to metamod function tables metamod gives us
   gpMetaUtilFuncs = pMetaUtilFuncs;
   *pPlugInfo = &Plugin_info;

   // check for interface version compatibility
   if (strcmp (ifvers, Plugin_info.ifvers) != 0)
   {
      int mmajor = 0, mminor = 0, pmajor = 0, pminor = 0;

      LOG_CONSOLE (PLID, "%s: meta-interface version mismatch (metamod: %s, %s: %s)", Plugin_info.name, ifvers, Plugin_info.name, Plugin_info.ifvers);
      LOG_MESSAGE (PLID, "%s: meta-interface version mismatch (metamod: %s, %s: %s)", Plugin_info.name, ifvers, Plugin_info.name, Plugin_info.ifvers);

      // if plugin has later interface version, it's incompatible (update metamod)
      sscanf (ifvers, "%d:%d", &mmajor, &mminor);
      sscanf (META_INTERFACE_VERSION, "%d:%d", &pmajor, &pminor);

      if ((pmajor > mmajor) || ((pmajor == mmajor) && (pminor > mminor)))
      {
         LOG_CONSOLE (PLID, "metamod version is too old for this plugin; update metamod");
         LOG_ERROR (PLID, "metamod version is too old for this plugin; update metamod");
         return (FALSE);
      }

      // if plugin has older major interface version, it's incompatible (update plugin)
      else if (pmajor < mmajor)
      {
         LOG_CONSOLE (PLID, "metamod version is incompatible with this plugin; please find a newer version of this plugin");
         LOG_ERROR (PLID, "metamod version is incompatible with this plugin; please find a newer version of this plugin");
         return (FALSE);
      }
   }

   return (TRUE); // tell metamod this plugin looks safe
}


C_DLLEXPORT int Meta_Attach (PLUG_LOADTIME now, META_FUNCTIONS *pFunctionTable, meta_globals_t *pMGlobals, gamedll_funcs_t *pGamedllFuncs)
{
   // this function is called when metamod attempts to load the plugin. Since it's the place
   // where we can tell if the plugin will be allowed to run or not, we wait until here to make
   // our initialization stuff, like registering CVARs and dedicated server commands.

   // are we allowed to load this plugin now ?
   if (now > Plugin_info.loadable)
   {
      LOG_CONSOLE (PLID, "%s: plugin NOT attaching (can't load plugin right now)", Plugin_info.name);
      LOG_ERROR (PLID, "%s: plugin NOT attaching (can't load plugin right now)", Plugin_info.name);
      return (FALSE); // returning FALSE prevents metamod from attaching this plugin
   }

   // keep track of the pointers to engine function tables metamod gives us
   gpMetaGlobals = pMGlobals;
   memcpy (pFunctionTable, &gMetaFunctionTable, sizeof (META_FUNCTIONS));
   gpGamedllFuncs = pGamedllFuncs;

   // print a message to notify about plugin attaching
   LOG_CONSOLE (PLID, "%s: plugin attaching", Plugin_info.name);
   LOG_MESSAGE (PLID, "%s: plugin attaching", Plugin_info.name);

   // ask the engine to register the server commands this plugin uses
   CVAR_REGISTER (&sv_bot);
   CVAR_REGISTER (&sv_balance);
   CVAR_REGISTER (&sv_random_names);
   CVAR_REGISTER (&sv_bot_exec_default);
   CVAR_REGISTER (&sv_strict_max_bots);
   CVAR_REGISTER (&sv_bot_script);
   CVAR_REGISTER (&sv_bot_message_debug);

   REG_SVR_COMMAND ("addbot", ServerAddBot);
   REG_SVR_COMMAND ("bot_chat", ServerBotChat);
   REG_SVR_COMMAND ("bot_command", ServerBotCommand);
   REG_SVR_COMMAND ("max_bots", ServerMaxBots);
   REG_SVR_COMMAND ("min_bots", ServerMinBots);

   return (TRUE); // returning TRUE enables metamod to attach this plugin
}


C_DLLEXPORT int Meta_Detach (PLUG_LOADTIME now, PL_UNLOAD_REASON reason)
{
   // this function is called when metamod unloads the plugin. A basic check is made in order
   // to prevent unloading the plugin if its processing should not be interrupted.

   // is metamod allowed to unload the plugin ?
   if ((now > Plugin_info.unloadable) && (reason != PNL_CMD_FORCED))
   {
      LOG_CONSOLE (PLID, "%s: plugin NOT detaching (can't unload plugin right now)", Plugin_info.name);
      LOG_ERROR (PLID, "%s: plugin NOT detaching (can't unload plugin right now)", Plugin_info.name);
      return (FALSE); // returning FALSE prevents metamod from unloading this plugin
   }

   return (TRUE); // returning TRUE enables metamod to unload this plugin
}

// END of Metamod stuff



void GameDLLInit( void )
{
   for (int i=0; i<32; i++)
      clients[i] = NULL;

   RETURN_META (MRES_IGNORED);
}

int Spawn( edict_t *pent )
{
   if (gpGlobals->deathmatch)
   {
      char *pClassname = (char *)STRING(pent->v.classname);

      if (debug_engine)
      {
         fp=fopen("bot.txt","a");
         fprintf(fp, "DispatchSpawn: %s\n",pClassname);
         if (pent->v.model != 0)
            fprintf(fp, " model=%s\n",STRING(pent->v.model));
         fclose(fp);
      }

      if (strcmp(pClassname, "worldspawn") == 0)
      {
         // do level initialization stuff here...

         WaypointInit();
         WaypointLoad(NULL);
		 LoadScript();
		 ResetTFCData();
		 checked_deathmatch = FALSE;
		 ScriptOnStart();

         PRECACHE_SOUND("weapons/xbow_hit1.wav");      // waypoint add
         PRECACHE_SOUND("weapons/mine_activate.wav");  // waypoint delete
         PRECACHE_SOUND("common/wpn_hudoff.wav");      // path add/delete start
         PRECACHE_SOUND("common/wpn_hudon.wav");       // path add/delete done
         PRECACHE_SOUND("common/wpn_moveselect.wav");  // path add/delete cancel
         PRECACHE_SOUND("common/wpn_denyselect.wav");  // path add/delete error

         m_spriteTexture = PRECACHE_MODEL( "sprites/lgtning.spr");

				 bot_cfg_pause_time = 0.0;
				 respawn_time = 0.0;
				 spawn_time_reset = FALSE;

				 prev_num_bots = num_bots;
				 num_bots = 0;


         g_GameRules = TRUE;
      }
   }

   RETURN_META_VALUE (MRES_IGNORED, 0);
}

void KeyValue( edict_t *pentKeyvalue, KeyValueData *pkvd )
{
   HandleKeyValueData(pentKeyvalue, pkvd);
   RETURN_META (MRES_IGNORED);
}

void ClientPutInServer( edict_t *pEntity )
{
   if (debug_engine) { fp=fopen("bot.txt","a"); fprintf(fp, "ClientPutInServer: %x\n",pEntity); fclose(fp); }

   int i = 0;

   while ((i < 32) && (clients[i] != NULL))
      i++;

   if (i < 32)
      clients[i] = pEntity;  // store this clients edict in the clients array

   RETURN_META (MRES_IGNORED);
}

BOOL ClientConnect( edict_t *pEntity, const char *pszName, const char *pszAddress, char szRejectReason[ 128 ]  )
{
   if (gpGlobals->deathmatch)
   {
      int count = 0,i;
			for ( i = 0; i < 32; i++) {
				if (clients[i] == pEntity) break;
			}

			if (i == 32) {
				i = -1;
			}

      if (debug_engine) { fp=fopen("bot.txt","a"); fprintf(fp, "ClientConnect: pent=%x name=%s\n",pEntity,pszName); fclose(fp); }

      if (strcmp(pszAddress, "127.0.0.1") != 0)
      {
         if (welcome_index == -1)
            welcome_index = i;

         // don't try to add bots for 30 seconds, give client time to get added
         bot_check_time = gpGlobals->time + 30.0;

         for (i=0; i < 32; i++)
         {
            if (bots[i].is_used)  // count the number of bots in use
               count++;
         }

         // if there are currently more than the minimum number of bots running
         // then kick one of the bots off the server...
         if ((count > min_bots) && (min_bots != -1))
         {
			 i = GetLargestTeamBot();
			 if (i != -1)
			 {
				char cmd[80];
				sprintf(cmd, "kick \"%s\"\n", bots[i].name);
				SERVER_COMMAND(cmd);  // kick the bot using (kick "name")
			 }
			/*
            for (i=0; i < 32; i++)
            {
               if (bots[i].is_used)  // is this slot used?
               {
                  char cmd[80];

                  sprintf(cmd, "kick \"%s\"\n", bots[i].name);

                  SERVER_COMMAND(cmd);  // kick the bot using (kick "name")

                  break;
               }
            }
			*/
         }
      }
   }

   RETURN_META_VALUE (MRES_IGNORED, 0);
}

void ClientDisconnect( edict_t *pEntity )
{
   if (gpGlobals->deathmatch)
   {
      int i, index;

      if (debug_engine) { fp=fopen("bot.txt","a"); fprintf(fp, "ClientDisconnect: %x\n",pEntity); fclose(fp); }

      i = 0;
      while ((i < 32) && (clients[i] != pEntity))
         i++;

      if (i < 32)
         clients[i] = NULL;

      index = -1;

      for (i=0; i < 32; i++)
      {
         if (bots[i].pEdict == pEntity)
         {
            index = i;
            break;
         }
      }

      if (index != -1)
      {
    		 FakeClientCommand(bots[index].pEdict, "spectate");
         // someone kicked this bot off of the server...

         bots[index].is_used = FALSE;  // this slot is now free to use
				 bots[index].kick_time = gpGlobals->time;
				 IsMyBot[index] = FALSE;
      }
   }

   RETURN_META (MRES_IGNORED);
}


void ClientCommand( edict_t *pEntity )
{
   // these client commands aren't allow in single player mode or
   // on dedicated servers

   if ((gpGlobals->deathmatch) && (!IS_DEDICATED_SERVER()) && pEntity == INDEXENT(1))
   {
      const char *pcmd = CMD_ARGV(0);
      const char *arg1 = CMD_ARGV(1);
      const char *arg2 = CMD_ARGV(2);
      const char *arg3 = CMD_ARGV(3);
      const char *arg4 = CMD_ARGV(4);
      char msg[80];

      if (debug_engine) { fp=fopen("bot.txt","a"); fprintf(fp,"ClientCommand: %s %s %s\n",pcmd, arg1, arg2); fclose(fp); }

/*	if (FStrEq(pcmd, "addbot"))
	{
		BotCreate( pEntity, arg1, arg2, arg3, arg4 );
      RETURN_META (MRES_IGNORED);
	}
      else
	  */
	  if (FStrEq(pcmd, "debug_engine"))
      {
         debug_engine = 1;

         ClientPrint( VARS(pEntity), HUD_PRINTNOTIFY, "debug_engine enabled!\n");

         RETURN_META (MRES_IGNORED);
      }

      /*
	  else if (FStrEq(pcmd, "bot_chat"))
      {
				char buffer[80];

				if (*arg1 != '\0') {
					int newFreq = -1;
					newFreq = atoi(arg1);
					if (newFreq < 0) newFreq = 0;
					if (newFreq > 100) newFreq = 100;
					bot_chat_freq = newFreq;
				}

				sprintf(buffer, "bot_chat is now: %d \n", bot_chat_freq);
        ClientPrint( VARS(pEntity), HUD_PRINTNOTIFY, buffer);

         RETURN_META (MRES_IGNORED);
      }
      else if (FStrEq(pcmd, "bot_command"))
      {
		  if (arg1 != NULL && *arg1 != '\0' && arg2 != NULL && *arg2 != '\0')
		  {
			  int state = -1;
			  if (FStrEq(arg2, "normal"))
			  {
				  state = BEHAVE_NONE;
			  }
			  else if (FStrEq(arg2, "guard"))
			  {
				  state = BEHAVE_GUARD;
			  }
			  else if (FStrEq(arg2, "attack"))
			  {
				  state = BEHAVE_ATTACK;
			  }
			  if (state != -1) {
				  int i;
				  edict_t *pPlayer;
				  for (i = 1; i <= gpGlobals->maxClients; i++) {
					  pPlayer = INDEXENT(i);
					  if (!pPlayer) continue;
					  if (FStrEq(arg1, STRING(pPlayer->v.netname)))
					  {
						  int bot_index = UTIL_GetBotIndex(pPlayer);
						  if (bot_index != -1) {
							  bots[bot_index].behaviour = state;
							  bots[bot_index].destination = -1;
							  bots[bot_index].currentPoint = -1;
							  return;
						  }
						  ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, "That player is not a bot!\n");
                     RETURN_META (MRES_IGNORED);
					  }
				  }
				  ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, "That name is unknown\n");
               RETURN_META (MRES_IGNORED);
			  }
			  ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, "That is not a valid command\nValid commands are: attack, guard and normal\n");
            RETURN_META (MRES_IGNORED);
		}
		ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, "Usage: bot_command <bot name> <command> \n");
      RETURN_META (MRES_IGNORED);
	}
	*/
	else if (FStrEq(pcmd, "find"))
	{
		edict_t *pEnt= NULL;
		char buffer[80];
		while((pEnt = UTIL_FindEntityInSphere(pEnt, pEntity->v.origin, 150)) != NULL)
		{
			ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, STRING(pEnt->v.classname));
			ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, "\n");
			sprintf(buffer, "%d\n", pEnt->v.health);
			ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, buffer);
		}
      RETURN_META (MRES_IGNORED);
	}
#ifdef _DEBUG
	else if (FStrEq(pcmd, "bot_debug"))
	{
		int i;
		if(arg1 == 0 || *arg1 == '\0') RETURN_META (MRES_IGNORED);
		for (i = 0; i < 32; i++)
		{
			if (bots[i].pEdict && FStrEq(STRING(bots[i].pEdict->v.netname), arg1))
			{
				bots[i].debug = TRUE;
			}
		}
	}
#endif
	else if (FStrEq(pcmd, "botkill"))
	{
		int i;
		if(arg1 == 0 || *arg1 == '\0') RETURN_META (MRES_IGNORED);
		for (i = 0; i < 32; i++)
		{
			if (bots[i].pEdict && FStrEq(STRING(bots[i].pEdict->v.netname), arg1))
			{
				MDLL_ClientKill(bots[i].pEdict);
			}
		}
      RETURN_META (MRES_IGNORED);
	}


/*
	else if (FStrEq(pcmd, "back"))
	{
		edict_t *pEnt = NULL;
		while ((pEnt = UTIL_FindEntityByClassname(pEnt, "info_tfgoal")) != NULL)
		{
			if (GetBackPack(pEnt, FALSE))
			{
				ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, "Found\n");
			}
		}
	}
	else if (FStrEq(pcmd, "mysequence"))
	{
		char buffer[100];
		sprintf(buffer, "Sequence: %d \n", pEntity->v.sequence);
		ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, buffer);
	}
	else if (FStrEq(pcmd, "lifttest"))
	{
		TraceResult tr;
		Vector from, to;
		const char * name;
		from = pEntity->v.origin;
		to = from - Vector(0,0,100);
		UTIL_TraceLine(from, to, ignore_monsters, pEntity, &tr);
		if (tr.pHit != NULL)
		{
			name = STRING(tr.pHit->v.classname);
			if (FStrEq(name, "func_plat"))
			{
				char buffer[100];
				sprintf(buffer, "The velocity is: %f", tr.pHit->v.velocity);
				ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, buffer);
			}
		}
	}
	*/
			/*
			else if (FStrEq(pcmd, "myedict"))
			{
				char buffer[80];
				sprintf(buffer, "Your edict is %x \n", pEntity);
				ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, buffer);
            RETURN_META (MRES_IGNORED);
			}
			else if (FStrEq(pcmd, "logging")) {
				if (FStrEq(arg1, "stat")) {
					PrintLogData(pEntity);
               RETURN_META (MRES_IGNORED);
				} else if (FStrEq(arg1, "point")) {
					PrintPointData(pEntity);
               RETURN_META (MRES_IGNORED);
				} else if (FStrEq(arg1, "total")) {
					PrintTotalData(pEntity);
               RETURN_META (MRES_IGNORED);
				}
			} else if (FStrEq(pcmd, "dumpvars")) {
				FILE * fp = fopen("bot.txt","a");
				fprintf(fp, "Vars dump: \n");
				fprintf(fp, "Deadflags: %d \n", pEntity->v.deadflag);
				fprintf(fp, "Origin.z: %f \n", pEntity->v.origin.z);
				fprintf(fp, "Flags: %d \n ", pEntity->v.flags);
				fprintf(fp, "View offset: %d \n", pEntity->v.view_ofs.z);
				fclose(fp);
            RETURN_META (MRES_IGNORED);
			}
			*/
#ifdef _DEBUG
			else if (FStrEq(pcmd, "sentrytest"))
			{
				edict_t *pent=NULL;
				while ( (pent = UTIL_FindEntityInSphere(pent, pEntity->v.origin, 150)) != NULL) {
					if (mod_id == TFC_DLL && (strcmp(STRING(pent->v.classname),"building_sentrygun") == 0) ) {
						char buffer[80];
						sprintf(buffer, "The colormap: %x \n", pent->v.colormap);
						ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, buffer);
                  RETURN_META (MRES_IGNORED);
					}
				}
            RETURN_META (MRES_IGNORED);
			}
			else if (FStrEq(pcmd, "bagtest"))
			{
				edict_t *pEnt= NULL;
				while((pEnt = UTIL_FindEntityInSphere(pEnt, pEntity->v.origin, 150)) != NULL) {
					if (strcmp(STRING(pEnt->v.classname), "info_tfgoal") == 0)  {
						char buffer[100];
						sprintf(buffer, "%d \n", UTIL_GetTeam(pEnt));
						ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, buffer);
						ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, STRING(pEnt->v.model));
						ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, "\n");
					}
				}
            RETURN_META (MRES_IGNORED);
			}
			else if (FStrEq(pcmd, "captest"))
			{
				edict_t *pent=NULL;
				while ( (pent = UTIL_FindEntityInSphere(pent, pEntity->v.origin, 150)) != NULL) {
					if (mod_id == FLF_DLL && (strcmp(STRING(pent->v.classname),"capture_point") == 0) ) {
						Vector v_ent = pent->v.origin; //VecBModelOrigin(pent);
						//TraceResult tr;
						//UTIL_TraceLine(pEntity->v.origin, v_ent, ignore_monsters, pEntity, &tr);
						//if (tr.pHit == pent) {
							char buffer[80];
							float dist = (pEntity->v.origin -v_ent).Length();  // * tr.flFraction;
							sprintf(buffer, "The skin: %d \n", pent->v.skin);
							ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, buffer);
                     RETURN_META (MRES_IGNORED);
						//}
					}
				}
            RETURN_META (MRES_IGNORED);
			}
			else if (FStrEq(pcmd, "checkfront"))
			{
				if (NavIsFrontClear(pEntity)) {
					ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, "Front is clear\n");
				} else {
					ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, "Front is not clear.\n");
				}
            RETURN_META (MRES_IGNORED);
			}
			else if (FStrEq(pcmd, "myteam"))
			{
				char team[30];
				sprintf(team, "Your Team is: %d\n", UTIL_GetTeam(pEntity));
				ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, team);
            RETURN_META (MRES_IGNORED);
			}
			else if (FStrEq(pcmd, "angletest")) {
				char buffer[80];
				Vector angles = pEntity->v.angles;
				sprintf(buffer, "The angles are: %f %f %f\n", angles.x, angles.y, angles.z);
				ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, buffer);
				angles = pEntity->v.v_angle;
				sprintf(buffer, "The v_angles are: %f %f %f\n", angles.x, angles.y, angles.z);
				ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, buffer);
            RETURN_META (MRES_IGNORED);
			} else if (FStrEq(pcmd, "origintest")) {
				char buffer[80];
				Vector angles = pEntity->v.origin;
				sprintf(buffer, "The origin are: %f %f %f\n", angles.x, angles.y, angles.z);
				ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, buffer);
            RETURN_META (MRES_IGNORED);
			} else if (FStrEq(pcmd, "heighttest")) {
				char buffer[80];
				TraceResult tr;
				UTIL_TraceLine(pEntity->v.origin, pEntity->v.origin-Vector(0,0,1000), ignore_monsters, pEntity, &tr);
				sprintf(buffer, "The height is %f \n", 1000*tr.flFraction);
				ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, buffer);
            RETURN_META (MRES_IGNORED);
			}
#endif

      else if (FStrEq(pcmd, "waypoint"))
      {
         if (FStrEq(arg1, "on"))
         {
            g_waypoint_on = TRUE;

            ClientPrint( VARS(pEntity), HUD_PRINTNOTIFY, "waypoints are ON\n");
         }
         else if (FStrEq(arg1, "off"))
         {
            g_waypoint_on = FALSE;

            ClientPrint( VARS(pEntity), HUD_PRINTNOTIFY, "waypoints are OFF\n");
         }
         else if (FStrEq(arg1, "add"))
         {
            if (!g_waypoint_on)
               g_waypoint_on = TRUE;  // turn waypoints on if off

            WaypointAdd(pEntity);
         }
         else if (FStrEq(arg1, "delete"))
         {
            if (!g_waypoint_on)
               g_waypoint_on = TRUE;  // turn waypoints on if off

            WaypointDelete(pEntity);
         }
         else if (FStrEq(arg1, "save"))
         {
            WaypointSave();

            ClientPrint( VARS(pEntity), HUD_PRINTNOTIFY, "waypoints saved\n");
         }
         else if (FStrEq(arg1, "load"))
         {
            if (WaypointLoad(pEntity))
               ClientPrint( VARS(pEntity), HUD_PRINTNOTIFY, "waypoints loaded\n");
         }
         else if ((FStrEq(arg1, "stat")) || (FStrEq(arg1, "stats")))
         {
            WaypointPrintStat(pEntity);
         }
         else if (FStrEq(arg1, "menu"))
         {
            WaypointShowMenu(pEntity);
         }
         else if (FStrEq(arg1, "setangle"))
         {
            WaypointSetAngle(pEntity);
         }
		 else if (FStrEq(arg1, "update"))
		 {
			 int i;
			 for (i = 0; i < num_waypoints; i++)
			 {
				 WaypointAddFlags(i, pEntity);
			 }
		 }
         else
         {
            if (g_waypoint_on)
               ClientPrint( VARS(pEntity), HUD_PRINTNOTIFY, "waypoints are ON\n");
            else
               ClientPrint( VARS(pEntity), HUD_PRINTNOTIFY, "waypoints are OFF\n");
         }

         RETURN_META (MRES_IGNORED);
      }
			else if (FStrEq(pcmd, "menuselect")) {
				int num=-1;
				sscanf(arg1, "%d", &num);
				if (num > -1) {
					if (WaypointMenuSelect(pEntity, num)) RETURN_META (MRES_IGNORED);
				}
			}
      else if (FStrEq(pcmd, "autowaypoint"))
      {
         if (FStrEq(arg1, "on"))
         {
            g_auto_waypoint = TRUE;
            g_waypoint_on = TRUE;  // turn this on just in case
         }
         else if (FStrEq(arg1, "off"))
         {
            g_auto_waypoint = FALSE;
         }

         if (g_auto_waypoint)
            sprintf(msg, "autowaypoint is ON\n");
         else
            sprintf(msg, "autowaypoint is OFF\n");

         ClientPrint( VARS(pEntity), HUD_PRINTNOTIFY, msg);

         RETURN_META (MRES_IGNORED);
      }
      else if (FStrEq(pcmd, "pathwaypoint"))
      {
         if (FStrEq(arg1, "on"))
         {
            g_path_waypoint = TRUE;
            g_waypoint_on = TRUE;  // turn this on just in case

            ClientPrint( VARS(pEntity), HUD_PRINTNOTIFY, "pathwaypoint is ON\n");
         }
         else if (FStrEq(arg1, "off"))
         {
            g_path_waypoint = FALSE;

            ClientPrint( VARS(pEntity), HUD_PRINTNOTIFY, "pathwaypoint is OFF\n");
         }
         else if (FStrEq(arg1, "create1"))
         {
            WaypointCreatePath(pEntity, 1);
         }
         else if (FStrEq(arg1, "create2"))
         {
            WaypointCreatePath(pEntity, 2);
         }
         else if (FStrEq(arg1, "remove1"))
         {
            WaypointRemovePath(pEntity, 1);
         }
         else if (FStrEq(arg1, "remove2"))
         {
            WaypointRemovePath(pEntity, 2);
         }
         RETURN_META (MRES_IGNORED);
 	    } else if (FStrEq(pcmd, "bot_shoot")) {
		    if (FStrEq(arg1, "on") || FStrEq(arg1, "1")) {
	    		bot_shoot = TRUE;
	      } else if (FStrEq(arg1, "off")  || FStrEq(arg1, "0")) {
	      	bot_shoot = FALSE;
	      }
				if (observer) {
        			ClientPrint( VARS(pEntity), HUD_PRINTNOTIFY, "bot_shoot is ON\n");
				} else {
					ClientPrint( VARS(pEntity), HUD_PRINTNOTIFY, "bot_shoot is OFF\n");
				}
            RETURN_META (MRES_IGNORED);
 	    } else if (FStrEq(pcmd, "bot_observer")) {
		    if (FStrEq(arg1, "on") || FStrEq(arg1, "1")) {
	    		observer = TRUE;
	      } else if (FStrEq(arg1, "off")  || FStrEq(arg1, "0")) {
	      	observer = FALSE;
	      }
				if (observer) {
        	ClientPrint( VARS(pEntity), HUD_PRINTNOTIFY, "bot_observer is ON\n");
				} else {
					ClientPrint( VARS(pEntity), HUD_PRINTNOTIFY, "bot_observer is OFF\n");
				}
            RETURN_META (MRES_IGNORED);
	   } else if (FStrEq(pcmd, "botskill")) {
			 char buffer[80];
			 if (FStrEq(arg1, "1")) {
				 current_skill = 1;
			 } else if (FStrEq(arg1, "2")) {
				 current_skill = 2;
			 } else if (FStrEq(arg1, "3")) {
				 current_skill = 3;
			 } else if (FStrEq(arg1, "4")) {
				 current_skill = 4;
			 } else if (FStrEq(arg1, "5")) {
				 current_skill = 5;
			 }
			 sprintf(buffer, "botskill is %d\n", current_skill);
			 ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, buffer);
          RETURN_META (MRES_IGNORED);
	   }
   }

   RETURN_META (MRES_IGNORED);
}

void ServerActivate( edict_t *pEdictList, int edictCount, int clientMax )
{

	//reset the bot names, as StartFrame does not work from the shell
	int i;
	for ( i = 0; i < 32; i++)
	{
		if (bots[i].is_used)
		{
			break;
		}
	}
	if (i == 32)
	{
		bot_names_first = 0;
		bot_names_last = -1;
	}
	
   RETURN_META (MRES_IGNORED);
}

void StartFrame( void )
{
   if (gpGlobals->deathmatch)
   {
      edict_t *pPlayer;
      static float check_server_cmd = 0.0;
      static int i, index, player_index, bot_index;
      static float previous_time = -1.0;
      static bool file_opened = FALSE;
		static bool text_files_loaded = FALSE;
      static int file_index, length;
      static FILE *bot_cfg_fp;
	   static FILE *map_cfg_fp;
      static int ch;
      static char cmd_line[80];
      static char server_cmd[80];
      char msg[256];
		int count;

/*
		edict_t *pEnt = NULL;
		while ((pEnt = UTIL_FindEntityByClassname(pEnt, "tf_gl_grenade")) != NULL)
		{
			FILE * lfp = fopen("gl_log.txt", "a");
			if (pEnt) fprintf(lfp, "Height: %f \n", pEnt->v.origin.z);
			fclose(lfp);
		}
*/

      // if a new map has started then...
      if ((gpGlobals->time + 0.1) < previous_time)
      {
         char filename[256];
         char mapname[64];


         // check if mapname_bot.cfg file exists...
         strcpy(mapname, STRING(gpGlobals->mapname));

			CVAR_SET_STRING("bot", "");
			welcome_index = -1;
			check_server_cmd = gpGlobals->time + 5.0;
			f_path_time = gpGlobals->time + 1.0;

			if (bot_cfg_fp) {
				fclose(bot_cfg_fp);
				bot_cfg_fp = NULL;
			}
			if (map_cfg_fp) {
				fclose(map_cfg_fp);
				map_cfg_fp = NULL;
			}

         strcat(mapname, "_odd.cfg");
         UTIL_BuildFileName(filename, "maps", mapname);

         map_cfg_fp = fopen(filename, "r");
         if (map_cfg_fp == NULL && CVAR_GET_FLOAT("bot_exec_default")) {
			 UTIL_BuildFileName(filename, "maps", "odd_default.cfg");
			 map_cfg_fp = fopen(filename, "r");
		 }

		 if (map_cfg_fp) {
            sprintf(msg, "Executing %s\n", filename);
            ALERT( at_console, msg );

	         bot_names_first = 0;
		     bot_names_last = -1;
        
			 for (index = 0; index < 32; index++) {
               bots[index].is_used = FALSE;
               bots[index].respawn_state = 0;
               bots[index].kick_time = 0.0;
            }

            if (IS_DEDICATED_SERVER())
               pause_time = gpGlobals->time + 5.0;
            else
               pause_time = gpGlobals->time + 20.0;
         } else {
            count = 0;

            // mark the bots as needing to be respawned...
            for (index = 0; index < 32; index++)
            {
               if (count >= prev_num_bots)
               {
                  bots[index].is_used = FALSE;
                  bots[index].respawn_state = 0;
                  bots[index].kick_time = 0.0;
               }

               if (bots[index].is_used)  // is this slot used?
               {
                  bots[index].respawn_state = RESPAWN_NEED_TO_RESPAWN;
                  count++;
               }

               // check for any bots that were very recently kicked...
               if ((bots[index].kick_time + 5.0) > previous_time)
               {
                  bots[index].respawn_state = RESPAWN_NEED_TO_RESPAWN;
                  count++;
               }
               else
                  bots[index].kick_time = 0.0;  // reset to prevent false spawns later
            }

            // set the respawn time
            if (IS_DEDICATED_SERVER())
               respawn_time = gpGlobals->time + 5.0;
            else
               respawn_time = gpGlobals->time + 20.0;
         }

         bot_check_time = gpGlobals->time + 30.0;
      }

      if (!IS_DEDICATED_SERVER()) {
         if ((welcome_index != -1) && (welcome_sent == FALSE) &&
             (welcome_time < 1.0))
         {
            // are they out of observer mode yet?
            if (IsAlive(clients[welcome_index]))
               welcome_time = gpGlobals->time + 5.0;  // welcome in 5 seconds
         }

         if ((welcome_time  > 0.0) && (welcome_time < gpGlobals->time) &&
             (welcome_sent == FALSE))
         {
            // let's send a welcome message to this client...
            ClientPrint(VARS(clients[welcome_index]), HUD_PRINTTALK, welcome_msg) ;

            welcome_sent = TRUE;  // clear this so we only do it once
         }
      }


		count = 0;
      for (bot_index = 0; bot_index < gpGlobals->maxClients; bot_index++)
      {
         if (bots[bot_index].is_used)  // is this slot used?
         {
			 bots[bot_index].pEdict->v.flags |= FL_FAKECLIENT;
			 //if (f_bot_think_time < gpGlobals->time)
			BotThink(&bots[bot_index]);
			 count++;
         }
      }

	  PrintServerMessages();
	  /*
	  if (f_bot_think_time < gpGlobals->time)
	  {
		  f_bot_think_time = gpGlobals->time + 0.3;
	  }
	  */

      for (player_index = 1; player_index <= gpGlobals->maxClients; player_index++)
      {
         pPlayer = INDEXENT(player_index);

         if (pPlayer && !pPlayer->free)
         {
            if ((g_waypoint_on) && FBitSet(pPlayer->v.flags, FL_CLIENT))
            {
                  WaypointThink(pPlayer);
            }
         }
      }

		if (count > num_bots) num_bots = count;



      // are we currently respawning bots and is it time to spawn one yet?
      if ((respawn_time > 1.0) && (respawn_time <= gpGlobals->time)) {
			int index = 0;

         // set the time to check for automatically adding bots to dedicated servers
         bot_check_time = gpGlobals->time + 5.0;

         // find bot needing to be respawned...
         while ((index < 32) &&
                (bots[index].respawn_state != RESPAWN_NEED_TO_RESPAWN))
            index++;

         if (index < 32) {
            bots[index].respawn_state = RESPAWN_IS_RESPAWNING;
            bots[index].is_used = FALSE;      // free up this slot

            // respawn 1 bot then wait a while (otherwise engine crashes)
            if ((mod_id == VALVE_DLL) || (mod_id == GEARBOX_DLL))
            {
               BotCreate(NULL, bots[index].skin, bots[index].name, NULL, NULL);
            }
            else
            {
               char c_team[2];
               char c_class[3];

               sprintf(c_team, "%d", bots[index].bot_team);
               sprintf(c_class, "%d", bots[index].bot_class);

               BotCreate(NULL, c_team, c_class, NULL, NULL); //, bots[index].name, NULL);
            }

            respawn_time = gpGlobals->time + 1.0;  // set next respawn time
         }
         else
         {
            respawn_time = 0.0;
         }
      }

      if (g_GameRules) {
			if (!text_files_loaded) {
				LoadTextFiles();
				LoadWeaponData(); //load the weapon data here too
				text_files_loaded = TRUE;
			}
         if (!file_opened)  // have we open bot.cfg file yet?
         {
            char bot_cfg_filename[256];
				UTIL_BuildFileName(bot_cfg_filename, "odd_bot.cfg", "");
            sprintf(msg, "Executing %s\n", bot_cfg_filename);
            ALERT( at_console, msg );

            bot_cfg_fp = fopen(bot_cfg_filename, "r");

            file_opened = TRUE;

            if (bot_cfg_fp == NULL)
               ALERT( at_console, "odd_bot.cfg file not found\n" );

            pause_time = gpGlobals->time;

            file_index = 0;
            cmd_line[file_index] = 0;  // null out command line
         }

         // if the bot.cfg file is still open and time to execute command...

			if (bot_cfg_fp) {
	         while ((bot_cfg_fp != NULL) && !feof(bot_cfg_fp) && (pause_time <= gpGlobals->time)) {
					ExecuteCFGFile(bot_cfg_fp);
				}

	         // if bot.cfg file is open and reached end of file, then close and free it
	         if ((bot_cfg_fp != NULL) && feof(bot_cfg_fp)) {
	            fclose(bot_cfg_fp);
	            bot_cfg_fp = NULL;
	         }
	      } else if (map_cfg_fp) {
	         while ((map_cfg_fp != NULL) && !feof(map_cfg_fp) && (pause_time <= gpGlobals->time)) {
					ExecuteCFGFile(map_cfg_fp);
				}

	         // if bot.cfg file is open and reached end of file, then close and free it
	         if ((map_cfg_fp != NULL) && feof(map_cfg_fp)) {
	            fclose(map_cfg_fp);
	            map_cfg_fp = NULL;
	         }
			}
		} // if (g_GameRules)


      // if time to check for server commands then do so...
      if (check_server_cmd <= gpGlobals->time)
      {
         check_server_cmd = gpGlobals->time + 1.0;

         char *cvar_bot = (char *)CVAR_GET_STRING( "bot" );
			CVAR_SET_STRING("bot", "");

         if ( cvar_bot && *cvar_bot ) {
				BotServerCommand(cvar_bot, FALSE);
			}
		}

      // check if time to see if a bot needs to be created...
      if (bot_check_time < gpGlobals->time)
      {
         int count = 0;

         bot_check_time = gpGlobals->time + 5.0;

         for (i = 0; i < 32; i++)
         {
            if (clients[i] != NULL)
               count++;
         }
		 /*
		 for (i = 0; i < 32; i++)
		 {
			 if (bots[i].is_used)
				 count++;
		 }
		 */

         // if there are currently less than the maximum number of "players"
         // then add another bot using the default skill level...
         if ((count < max_bots) && (max_bots != -1))
         {
            BotCreate( NULL, NULL, NULL, NULL, NULL );
         }
      }

      previous_time = gpGlobals->time;
   }

   RETURN_META (MRES_IGNORED);
}


void FakeClientCommand (edict_t *pFakeClient, const char *fmt, ...)
{
   // the purpose of this function is to provide fakeclients (bots) with the same client
   // command-scripting advantages (putting multiple commands in one line between semicolons)
   // as real players. It is an improved version of botman's FakeClientCommand, in which you
   // supply directly the whole string as if you were typing it in the bot's "console". It
   // is supposed to work exactly like the pfnClientCommand (server-sided client command).

   va_list argptr;
   static char command[256];
   int length, fieldstart, fieldstop, i, index, stringindex = 0;

   if (FNullEnt (pFakeClient))
      return; // reliability check

   // concatenate all the arguments in one string
   va_start (argptr, fmt);
   vsnprintf (command, 256, fmt, argptr);
   va_end (argptr);

   if ((command == NULL) || (*command == 0))
      return; // if nothing in the command buffer, return

   isFakeClientCommand = TRUE; // set the "fakeclient command" flag
   length = strlen (command); // get the total length of the command string

   // process all individual commands (separated by a semicolon) one each a time
   while (stringindex < length)
   {
      fieldstart = stringindex; // save field start position (first character)
      while ((stringindex < length) && (command[stringindex] != ';'))
         stringindex++; // reach end of field
      if (command[stringindex - 1] == '\n')
         fieldstop = stringindex - 2; // discard any trailing '\n' if needed
      else
         fieldstop = stringindex - 1; // save field stop position (last character before semicolon or end)
      for (i = fieldstart; i <= fieldstop; i++)
         g_argv[i - fieldstart] = command[i]; // store the field value in the g_argv global string
      g_argv[i - fieldstart] = 0; // terminate the string
      stringindex++; // move the overall string index one step further to bypass the semicolon

      index = 0;
      fake_arg_count = 0; // let's now parse that command and count the different arguments

      // count the number of arguments
      while (index < i - fieldstart)
      {
         while ((index < i - fieldstart) && (g_argv[index] == ' '))
            index++; // ignore spaces

         // is this field a group of words between quotes or a single word ?
         if (g_argv[index] == '"')
         {
            index++; // move one step further to bypass the quote
            while ((index < i - fieldstart) && (g_argv[index] != '"'))
               index++; // reach end of field
            index++; // move one step further to bypass the quote
         }
         else
            while ((index < i - fieldstart) && (g_argv[index] != ' '))
               index++; // this is a single word, so reach the end of field

         fake_arg_count++; // we have processed one argument more
      }

      MDLL_ClientCommand (pFakeClient); // tell now the MOD DLL to execute this ClientCommand...
   }

   g_argv[0] = 0; // when it's done, reset the g_argv field
   isFakeClientCommand = FALSE; // reset the "fakeclient command" flag
   fake_arg_count = 0; // and the argument count
}


const char *GetField (const char *string, int field_number)
{
   // This function gets and returns a particuliar field in a string where several fields are
   // concatenated. Fields can be words, or groups of words between quotes ; separators may be
   // white space or tabs. A purpose of this function is to provide bots with the same Cmd_Argv
   // convenience the engine provides to real clients. This way the handling of real client
   // commands and bot client commands is exactly the same, just have a look in engine.cpp
   // for the hooking of pfnCmd_Argc, pfnCmd_Args and pfnCmd_Argv, which redirects the call
   // either to the actual engine functions (when the caller is a real client), either on
   // our function here, which does the same thing, when the caller is a bot.

   static char field[256];
   int length, i, index = 0, field_count = 0, fieldstart, fieldstop;

   field[0] = 0; // reset field
   length = strlen (string); // get length of string

   while ((length > 0) && ((string[length - 1] == '\n') || (string[length - 1] == '\r')))
      length--; // discard trailing newlines

   // while we have not reached end of line
   while ((index < length) && (field_count <= field_number))
   {
      while ((index < length) && ((string[index] == ' ') || (string[index] == '\t')))
         index++; // ignore spaces or tabs

      // is this field multi-word between quotes or single word ?
      if (string[index] == '"')
      {
         index++; // move one step further to bypass the quote
         fieldstart = index; // save field start position
         while ((index < length) && (string[index] != '"'))
            index++; // reach end of field
         fieldstop = index - 1; // save field stop position
         index++; // move one step further to bypass the quote
      }
      else
      {
         fieldstart = index; // save field start position
         while ((index < length) && ((string[index] != ' ') && (string[index] != '\t')))
            index++; // reach end of field
         fieldstop = index - 1; // save field stop position
      }

      // is this field we just processed the wanted one ?
      if (field_count == field_number)
      {
         for (i = fieldstart; i <= fieldstop; i++)
            field[i - fieldstart] = string[i]; // store the field value in a string
         field[i - fieldstart] = 0; // terminate the string
         break; // and stop parsing
      }

      field_count++; // we have parsed one field more
   }

   return (&field[0]); // returns the wanted field
}


void ExecuteCFGFile(FILE *cfg_fp) {
	char ch, cmd_line[256], server_cmd[80], msg[80];
	int file_index = 0;
	ch = fgetc(cfg_fp);

	// skip any leading blanks
	while (ch == ' ' || ch == '\t')
		ch = fgetc(cfg_fp);

	while ((ch != EOF) && (ch != '\r') && (ch != '\n')) {
		if (ch == '\t') ch = ' '; // convert tabs to spaces

	   cmd_line[file_index] = ch;

	   ch = fgetc(cfg_fp);

	   // skip multiple spaces in input file
	   while ((cmd_line[file_index] == ' ') && (ch == ' ')) ch = fgetc(cfg_fp);

		file_index++;
	}

	// is it a carriage return?
	if (ch == '\r') {
		ch = fgetc(cfg_fp);  // skip the linefeed
	}

	cmd_line[file_index] = 0;  // terminate the command line

	if (*cmd_line == '#') return; //skip this line
	if (*cmd_line == '\0') return; // a blank line

	// copy the command line to a server command buffer...
	strcpy(server_cmd, cmd_line);
	strcat(server_cmd, "\n");

	if (!BotServerCommand(cmd_line, TRUE)) {
		sprintf(msg, "executing server command: %s\n", server_cmd);
		ALERT( at_console, msg );
      if (IS_DEDICATED_SERVER()) printf(msg);
		SERVER_COMMAND(server_cmd);
	}
}

bool BotServerCommand(char * cmd_line, BOOL pause) {
	int file_index = 0;
	char * cmd = cmd_line;
	char * arg1, *arg2,*arg3,*arg4;
	arg1= arg2 = arg3 = arg4 = NULL;
	char buffer[80];

	// skip to blank or end of string...
	while ((cmd_line[file_index] != ' ') && (cmd_line[file_index] != 0)) file_index++;

	if (cmd_line[file_index] == ' ') {
		cmd_line[file_index++] = 0;
		arg1 = &cmd_line[file_index];

		// skip to blank or end of string...
		while ((cmd_line[file_index] != ' ') && (cmd_line[file_index] != 0)) file_index++;

		if (cmd_line[file_index] == ' ') {
			cmd_line[file_index++] = 0;
			arg2 = &cmd_line[file_index];

			// skip to blank or end of string...
			while ((cmd_line[file_index] != ' ') && (cmd_line[file_index] != 0)) file_index++;

			if (cmd_line[file_index] == ' ') {
				cmd_line[file_index++] = 0;
				arg3 = &cmd_line[file_index];

				// skip to blank or end of string...
				while ((cmd_line[file_index] != ' ') && (cmd_line[file_index] != 0)) file_index++;

				if (cmd_line[file_index] == ' ') {
					cmd_line[file_index++] = 0;
					arg4 = &cmd_line[file_index];
				}
			}
		}
	}

	if (strcmp(cmd, "addbot") == 0) {
		BotCreate( NULL, arg1, arg2, arg3, arg4 );
		// have to delay here or engine gives "Tried to write to
		// uninitialized sizebuf_t" error and crashes...

		if (pause) pause_time = gpGlobals->time + 1;

		return TRUE;
	} else if (strcmp(cmd, "botskill") == 0) {
		if (arg1 && *arg1) {
			int skill = atoi(arg1);
			skill = max(skill, 1);
			skill = min(skill, 5);
			current_skill = skill;
		}
		return TRUE;
	} else if (strcmp(cmd, "bot_chat") == 0) {
		if (arg1 != 0 && *arg1 != '\0') {
			int newFreq = -1;
			newFreq = atoi(arg1);
			if (newFreq < 0) newFreq = 0;
			if (newFreq > 100) newFreq = 100;
			bot_chat_freq = newFreq;
		}
		if (IS_DEDICATED_SERVER())
			printf("bot_chat is now: %d \n", bot_chat_freq);
		return TRUE;
	} else if (strcmp(cmd, "min_bots") == 0) {
		if (arg1 != 0 && *arg1 != '\0') {
			min_bots = atoi( arg1 );
			if ((min_bots < 0) || (min_bots > 31)) min_bots = 1;

			if (IS_DEDICATED_SERVER()) {
				printf("min_bots set to %d\n", min_bots);
			} else {
				sprintf(buffer, "min_bots set to %d \n", min_bots);
				ALERT(at_console, buffer);
			}
		}
		return TRUE;
	} else if (strcmp(cmd, "max_bots") == 0) {
		if (arg1 != 0 && *arg1 != '\0') {
			max_bots = atoi( arg1 );
			if ((max_bots < 0) || (max_bots > 31)) max_bots = 1;
			if (IS_DEDICATED_SERVER()) {
				printf("max_bots set to %d\n", max_bots);
			} else {
				sprintf(buffer, "max_bots set to %d \n", max_bots);
				ALERT(at_console, buffer);
			}
		}
		return TRUE;
	} else if ((strcmp(cmd, "pause") == 0) && pause) {
		ALERT(at_console, "Pausing for ");
		if (arg1 != 0 && *arg1 != '\0') {
			pause_time = gpGlobals->time + atoi( arg1 );
			ALERT(at_console, arg1);
			ALERT(at_console, "\n");
		} else {
			pause_time = gpGlobals->time + 1;
		}
		return TRUE;
	}
	return FALSE; //unknown command
}

void LoadTextFiles(void) {
	//***** loads the names from a file
	char filename[256];
	int str_index;
	FILE *nf=NULL;
	bool good = FALSE;

	//load the names
	UTIL_BuildFileName(filename, "odd_names.txt", "");
	nf = fopen(filename, "r");
	if (nf) {
		for(names_used = 0; names_used < 128; names_used++) {
			good = FALSE;
			if (fgets(bot_names[names_used], 35, nf) == NULL) break; //finished
			good = TRUE;
			for (str_index = 0; str_index < 35; str_index++) {
				if (bot_names[names_used][str_index] == '\r'|| bot_names[names_used][str_index] == '\n') {
					bot_names[names_used][str_index] = '\0';
				}
				if (bot_names[names_used][str_index] == '\t') {
					bot_names[names_used][str_index] = ' ';
				}
			}
		}
		if (!good) {
			names_used--;
		}
		fclose(nf);
	}

	//load the victory speaches
	UTIL_BuildFileName(filename, "odd_victory.txt", "");
	nf = fopen(filename, "r");
	if (nf != NULL) {
		for(victory_used = 0; victory_used < 64; victory_used++) {
			good = FALSE;
			if (fgets(bot_victory[victory_used], 94, nf) == NULL) break; //finished
			good = TRUE;
			for (str_index = 0; str_index < 96; str_index++) {
				if (bot_victory[victory_used][str_index] == '\r'|| bot_names[victory_used][str_index] == '\n') {
					bot_victory[victory_used][str_index] = '\0';
				}
				if (bot_victory[victory_used][str_index] == '\t') {
					bot_victory[victory_used][str_index] = ' ';
				}
			}
		}
		if (!good) {
			victory_used--;
		}
		fclose(nf);
	}

	//load the losses from the file
	UTIL_BuildFileName(filename, "odd_loss.txt", "");
	nf = fopen(filename, "r");
	if (nf != NULL) {
		for(loss_used = 0; loss_used < 64; loss_used++) {
			good = FALSE;
			if (fgets(bot_loss[loss_used], 94, nf) == NULL) break; //finished
			good = TRUE;
			for (str_index = 0; str_index < 96; str_index++) {
				if (bot_loss[loss_used][str_index] == '\r'|| bot_names[loss_used][str_index] == '\n') {
					bot_loss[loss_used][str_index] = '\0';
				}
				if (bot_loss[loss_used][str_index] == '\t') {
					bot_loss[loss_used][str_index] = ' ';
				}
			}
		}
		if (!good) {
			loss_used--;
		}
		fclose(nf);
	}

	//load the taunts
	UTIL_BuildFileName(filename, "odd_taunt.txt", "");
	nf = fopen(filename, "r");
	if (nf != NULL) {
		for(taunt_used = 0; taunt_used < 64; taunt_used++) {
			good = FALSE;
			if (fgets(bot_taunt[taunt_used], 94, nf) == NULL) break; //finished
			good = TRUE;
			for (str_index = 0; str_index < 96; str_index++) {
				if (bot_taunt[taunt_used][str_index] == '\r'|| bot_names[taunt_used][str_index] == '\n') {
					bot_taunt[taunt_used][str_index] = '\0';
				}
				if (bot_taunt[taunt_used][str_index] == '\t') {
					bot_taunt[taunt_used][str_index] = ' ';
				}
			}
		}
		if (!good) {
			taunt_used--;
		}
		fclose(nf);
	}
}




C_DLLEXPORT int GetEntityAPI2 (DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion)
{
   gFunctionTable.pfnGameInit = GameDLLInit;
   gFunctionTable.pfnSpawn = Spawn;
   gFunctionTable.pfnKeyValue = KeyValue;
   gFunctionTable.pfnClientConnect = ClientConnect;
   gFunctionTable.pfnClientDisconnect = ClientDisconnect;
   gFunctionTable.pfnClientPutInServer = ClientPutInServer;
   gFunctionTable.pfnClientCommand = ClientCommand;
   gFunctionTable.pfnServerActivate = ServerActivate;
   gFunctionTable.pfnStartFrame = StartFrame;

   memcpy (pFunctionTable, &gFunctionTable, sizeof (DLL_FUNCTIONS));
   return (TRUE);
}
