//
// HPB bot - botman's High Ping Bastard bot
//
// (http://planethalflife.com/botman/)
//
// engine.cpp
//

#ifndef _WIN32
#include <string.h>
#endif

#include <extdll.h>
#include <dllapi.h>
#include <h_export.h>
#include <meta_api.h>

#include "bot.h"
#include "bot_client.h"
#include "engine.h"


extern enginefuncs_t g_engfuncs;
extern bot_t bots[32];
extern int mod_id;
extern bool isFakeClientCommand;
extern char g_argv[1024];
extern int fake_arg_count;

extern const char *GetField (const char *string, int field_number);

int current_type = TYPE_NONE;
int debug_engine = 0;

void (*botMsgFunction)(void *, int) = NULL;
int botMsgIndex;

static FILE *fp;

int text_state = 0;


void pfnChangeLevel(char* s1, char* s2)
{
   if (debug_engine) { fp=fopen("bot.txt","a"); fprintf(fp,"pfnChangeLevel:\n"); fclose(fp); }

   // kick any bot off of the server after time/frag limit...
   for (int index = 0; index < 32; index++)
   {
      if (bots[index].is_used)  // is this slot used?
      {
         char cmd[40];

         sprintf(cmd, "kick \"%s\"\n", bots[index].name);

         bots[index].respawn_state = RESPAWN_NEED_TO_RESPAWN;

         SERVER_COMMAND(cmd);  // kick the bot using (kick "name")
      }
   }

   RETURN_META (MRES_IGNORED);
}


void pfnMessageBegin(int msg_dest, int msg_type, const float *pOrigin, edict_t *ed)
{
   if (gpGlobals->deathmatch)
   {
      int index = -1;

      if (debug_engine) { fp=fopen("bot.txt","a"); fprintf(fp,"pfnMessageBegin: edict=%x dest=%d type=%d\n",ed,msg_dest,msg_type); fclose(fp); }

      if (ed) {
         index = UTIL_GetBotIndex(ed);

         // is this message for a bot?
         if (index != -1)
         {
            botMsgFunction = NULL;  // no msg function until known otherwise
            botMsgIndex = index;    // index of bot receiving message
						current_type = TYPE_NONE;

            if (mod_id == VALVE_DLL)
            {
               if (msg_type == GET_USER_MSG_ID (PLID, "WeaponList", NULL))
                  botMsgFunction = BotClient_Valve_WeaponList;
               else if (msg_type == GET_USER_MSG_ID (PLID, "CurWeapon", NULL))
                  botMsgFunction = BotClient_Valve_CurrentWeapon;
               else if (msg_type == GET_USER_MSG_ID (PLID, "AmmoX", NULL))
                  botMsgFunction = BotClient_Valve_AmmoX;
               else if (msg_type == GET_USER_MSG_ID (PLID, "AmmoPickup", NULL))
                  botMsgFunction = BotClient_Valve_AmmoPickup;
               else if (msg_type == GET_USER_MSG_ID (PLID, "WeapPickup", NULL))
                  botMsgFunction = BotClient_Valve_WeaponPickup;
               else if (msg_type == GET_USER_MSG_ID (PLID, "ItemPickup", NULL))
                  botMsgFunction = BotClient_Valve_ItemPickup;
               else if (msg_type == GET_USER_MSG_ID (PLID, "Health", NULL))
                  botMsgFunction = BotClient_Valve_Health;
               else if (msg_type == GET_USER_MSG_ID (PLID, "Battery", NULL))
                  botMsgFunction = BotClient_Valve_Battery;
               else if (msg_type == GET_USER_MSG_ID (PLID, "Damage", NULL))
                  botMsgFunction = BotClient_Valve_Damage;
							 else if (msg_type == GET_USER_MSG_ID (PLID, "SayText", NULL))
							    botMsgFunction = BotClient_TFC_SayText;
            }
            else if (mod_id == TFC_DLL)
            {
               if (msg_type == GET_USER_MSG_ID (PLID, "VGUIMenu", NULL))
                  botMsgFunction = BotClient_TFC_VGUI;
               else if (msg_type == GET_USER_MSG_ID (PLID, "WeaponList", NULL))
                  botMsgFunction = BotClient_TFC_WeaponList;
               else if (msg_type == GET_USER_MSG_ID (PLID, "CurWeapon", NULL))
                  botMsgFunction = BotClient_TFC_CurrentWeapon;
               else if (msg_type == GET_USER_MSG_ID (PLID, "AmmoX", NULL))
                  botMsgFunction = BotClient_TFC_AmmoX;
               else if (msg_type == GET_USER_MSG_ID (PLID, "AmmoPickup", NULL))
                  botMsgFunction = BotClient_TFC_AmmoPickup;
               else if (msg_type == GET_USER_MSG_ID (PLID, "WeapPickup", NULL))
                  botMsgFunction = BotClient_TFC_WeaponPickup;
               else if (msg_type == GET_USER_MSG_ID (PLID, "ItemPickup", NULL))
                  botMsgFunction = BotClient_TFC_ItemPickup;
               else if (msg_type == GET_USER_MSG_ID (PLID, "Health", NULL))
                  botMsgFunction = BotClient_TFC_Health;
               else if (msg_type == GET_USER_MSG_ID (PLID, "Battery", NULL))
                  botMsgFunction = BotClient_TFC_Battery;
               else if (msg_type == GET_USER_MSG_ID (PLID, "Damage", NULL))
                  botMsgFunction = BotClient_TFC_Damage;
			   else if (msg_type == GET_USER_MSG_ID (PLID, "StatusIcon", NULL))
				   botMsgFunction = BotClient_TFC_StatusIcon;
			   else if (msg_type == GET_USER_MSG_ID (PLID, "PlaySound", NULL))
				   botMsgFunction = BotClient_TFC_PlaySound;
			   else if (msg_type == GET_USER_MSG_ID (PLID, "SayText", NULL))
				   botMsgFunction = BotClient_TFC_SayText;
			   else if (msg_type == GET_USER_MSG_ID (PLID, "SecAmmoVal", NULL))
				   botMsgFunction = BotClient_TFC_Grenades;
			   else if (msg_type == GET_USER_MSG_ID (PLID, "TextMsg", NULL))
			   {
				   botMsgFunction = BotClient_TFC_TextMsg;
				   text_state = 0;
			   }
			   else if (msg_type == GET_USER_MSG_ID (PLID, "BuildSt", NULL))
				   botMsgFunction = BotClient_TFC_BuildSt;
			   else if (msg_type == GET_USER_MSG_ID (PLID, "SetFOV", NULL))
				   botMsgFunction = BotClient_TFC_SetFOV;
			   else if (msg_type == GET_USER_MSG_ID (PLID, "HudText", NULL))
			   {
				   botMsgFunction = BotClient_TFC_HudText;
				   text_state = 0;
			   }
			   else if (msg_type == GET_USER_MSG_ID (PLID, "StatusValue", NULL))
			   {
				   botMsgFunction = BotClient_TFC_StatusValue;
			   }
            }
            else if (mod_id == CSTRIKE_DLL)
            {
               if (msg_type == GET_USER_MSG_ID (PLID, "VGUIMenu", NULL))
                  botMsgFunction = BotClient_CS_VGUI;
               else if (msg_type == GET_USER_MSG_ID (PLID, "ShowMenu", NULL))
                  botMsgFunction = BotClient_CS_ShowMenu;
               else if (msg_type == GET_USER_MSG_ID (PLID, "WeaponList", NULL))
                  botMsgFunction = BotClient_CS_WeaponList;
               else if (msg_type == GET_USER_MSG_ID (PLID, "CurWeapon", NULL))
                  botMsgFunction = BotClient_CS_CurrentWeapon;
               else if (msg_type == GET_USER_MSG_ID (PLID, "AmmoX", NULL))
                  botMsgFunction = BotClient_CS_AmmoX;
               else if (msg_type == GET_USER_MSG_ID (PLID, "WeapPickup", NULL))
                  botMsgFunction = BotClient_CS_WeaponPickup;
               else if (msg_type == GET_USER_MSG_ID (PLID, "AmmoPickup", NULL))
                  botMsgFunction = BotClient_CS_AmmoPickup;
               else if (msg_type == GET_USER_MSG_ID (PLID, "ItemPickup", NULL))
                  botMsgFunction = BotClient_CS_ItemPickup;
               else if (msg_type == GET_USER_MSG_ID (PLID, "Health", NULL))
                  botMsgFunction = BotClient_CS_Health;
               else if (msg_type == GET_USER_MSG_ID (PLID, "Battery", NULL))
                  botMsgFunction = BotClient_CS_Battery;
               else if (msg_type == GET_USER_MSG_ID (PLID, "Damage", NULL))
                  botMsgFunction = BotClient_CS_Damage;
               else if (msg_type == GET_USER_MSG_ID (PLID, "Money", NULL))
                  botMsgFunction = BotClient_CS_Money;
            }
            else if (mod_id == GEARBOX_DLL)
            {
               if (msg_type == GET_USER_MSG_ID (PLID, "WeaponList", NULL))
                  botMsgFunction = BotClient_Gearbox_WeaponList;
               else if (msg_type == GET_USER_MSG_ID (PLID, "CurWeapon", NULL))
                  botMsgFunction = BotClient_Gearbox_CurrentWeapon;
               else if (msg_type == GET_USER_MSG_ID (PLID, "AmmoX", NULL))
                  botMsgFunction = BotClient_Gearbox_AmmoX;
               else if (msg_type == GET_USER_MSG_ID (PLID, "AmmoPickup", NULL))
                  botMsgFunction = BotClient_Gearbox_AmmoPickup;
               else if (msg_type == GET_USER_MSG_ID (PLID, "WeapPickup", NULL))
                  botMsgFunction = BotClient_Gearbox_WeaponPickup;
               else if (msg_type == GET_USER_MSG_ID (PLID, "ItemPickup", NULL))
                  botMsgFunction = BotClient_Gearbox_ItemPickup;
               else if (msg_type == GET_USER_MSG_ID (PLID, "Health", NULL))
                  botMsgFunction = BotClient_Gearbox_Health;
               else if (msg_type == GET_USER_MSG_ID (PLID, "Battery", NULL))
                  botMsgFunction = BotClient_Gearbox_Battery;
               else if (msg_type == GET_USER_MSG_ID (PLID, "Damage", NULL))
                  botMsgFunction = BotClient_Gearbox_Damage;
            }
						else if (mod_id == SI_DLL)
						{
							 if (msg_type == GET_USER_MSG_ID (PLID, "WeaponList", NULL))
							    botMsgFunction = BotClient_SI_WeaponList;
               else if (msg_type == GET_USER_MSG_ID (PLID, "CurWeapon", NULL))
                  botMsgFunction = BotClient_SI_CurrentWeapon;
               else if (msg_type == GET_USER_MSG_ID (PLID, "AmmoX", NULL))
                  botMsgFunction = BotClient_SI_AmmoX;
               else if (msg_type == GET_USER_MSG_ID (PLID, "AmmoPickup", NULL))
                  botMsgFunction = BotClient_SI_AmmoPickup;
               else if (msg_type == GET_USER_MSG_ID (PLID, "WeaponPickup", NULL))
                  botMsgFunction = BotClient_SI_WeaponPickup;
               else if (msg_type == GET_USER_MSG_ID (PLID, "ItemPickup", NULL))
                  botMsgFunction = BotClient_SI_ItemPickup;
               else if (msg_type == GET_USER_MSG_ID (PLID, "Health", NULL))
                  botMsgFunction = BotClient_SI_Health;
               else if (msg_type == GET_USER_MSG_ID (PLID, "Battery", NULL))
                  botMsgFunction = BotClient_SI_Battery;
               else if (msg_type == GET_USER_MSG_ID (PLID, "Damage", NULL))
                  botMsgFunction = BotClient_SI_Damage;
			   else if (msg_type == GET_USER_MSG_ID (PLID, "VGUIMenu", NULL))
				   botMsgFunction = BotClient_SI_VGUIMenu;
							 else if (msg_type == GET_USER_MSG_ID (PLID, "ShowMenu", NULL))
							    botMsgFunction = BotClient_SI_ShowMenu;
							 else if (msg_type == GET_USER_MSG_ID (PLID, "VoteState", NULL))
							    botMsgFunction = BotClient_SI_VoteState;
							 else if (msg_type == GET_USER_MSG_ID (PLID, "SciCarry", NULL))
							    botMsgFunction = BotClient_SI_SciCarry;
							 else if (msg_type == GET_USER_MSG_ID (PLID, "SayText", NULL))
							    botMsgFunction = BotClient_TFC_SayText;
						}
						else if (mod_id == FLF_DLL)
						{
							 if (msg_type == GET_USER_MSG_ID (PLID, "WeaponList", NULL))
							    botMsgFunction = BotClient_FLF_WeaponList;
               else if (msg_type == GET_USER_MSG_ID (PLID, "CurWeapon", NULL))
                  botMsgFunction = BotClient_FLF_CurrentWeapon;
               else if (msg_type == GET_USER_MSG_ID (PLID, "AmmoX", NULL))
                  botMsgFunction = BotClient_FLF_AmmoX;
               else if (msg_type == GET_USER_MSG_ID (PLID, "AmmoPickup", NULL))
                  botMsgFunction = BotClient_FLF_AmmoPickup;
               else if (msg_type == GET_USER_MSG_ID (PLID, "WeapPickup", NULL))
                  botMsgFunction = BotClient_FLF_WeaponPickup;
               else if (msg_type == GET_USER_MSG_ID (PLID, "ItemPickup", NULL))
                  botMsgFunction = BotClient_FLF_ItemPickup;
               else if (msg_type == GET_USER_MSG_ID (PLID, "Health", NULL))
                  botMsgFunction = BotClient_FLF_Health;
               else if (msg_type == GET_USER_MSG_ID (PLID, "Battery", NULL))
                  botMsgFunction = BotClient_FLF_Battery;
               else if (msg_type == GET_USER_MSG_ID (PLID, "Damage", NULL))
                  botMsgFunction = BotClient_FLF_Damage;
							 else if (msg_type == GET_USER_MSG_ID (PLID, "ShowMenu", NULL))
							    botMsgFunction = BotClient_FLF_ShowMenu;
							 else if (msg_type == GET_USER_MSG_ID (PLID, "SayText", NULL))
							    botMsgFunction = BotClient_FLF_SayText;
							 else if (msg_type == GET_USER_MSG_ID (PLID, "VGUIMenu", NULL))
							    botMsgFunction = BotClient_FLF_VGUI;
							 else if (msg_type == GET_USER_MSG_ID (PLID, "WinMessage", NULL))
								 botMsgFunction = BotClient_FLF_WinMessage;
							 else if (msg_type == GET_USER_MSG_ID (PLID, "WarmUp", NULL))
								 botMsgFunction = BotClient_FLF_WarmUp;
							 else if (msg_type == GET_USER_MSG_ID (PLID, "TextMessage", NULL))
								 botMsgFunction = BotClient_FLF_TextMessage;
							 else if (msg_type == GET_USER_MSG_ID (PLID, "ScreenFade", NULL))
							   botMsgFunction = BotClient_FLF_ScreenFade;
							 else if (msg_type == GET_USER_MSG_ID (PLID, "SetFOV", NULL))
							   botMsgFunction = BotClient_FLF_SetFOV;
							 else if (msg_type == GET_USER_MSG_ID (PLID, "StatusMessage", NULL)) {
								 //debug_engine = 1; // change!!!!!!
							 	 botMsgFunction = BotClient_FLF_StatusMessage;
							 }
						}
         }
      } else if (msg_dest == MSG_ALL) {
				botMsgFunction = NULL;  // no msg function until known otherwise
			  botMsgIndex = -1;       // index of bot receiving message (none)

			  if (mod_id == VALVE_DLL)
			  {
			    if (msg_type == GET_USER_MSG_ID (PLID, "DeathMsg", NULL))
			    	 botMsgFunction = BotClient_Valve_DeathMsg;
			  } else if (mod_id == TFC_DLL) {
			    	 if (msg_type == GET_USER_MSG_ID (PLID, "DeathMsg", NULL))
			        botMsgFunction = BotClient_TFC_DeathMsg;
			  } else if (mod_id == CSTRIKE_DLL) {
			      if (msg_type == GET_USER_MSG_ID (PLID, "DeathMsg", NULL))
			        botMsgFunction = BotClient_CS_DeathMsg;
			  } else if (mod_id == GEARBOX_DLL) {
            if (msg_type == GET_USER_MSG_ID (PLID, "DeathMsg", NULL))
			        botMsgFunction = BotClient_Gearbox_DeathMsg;
			  } else if (mod_id == FLF_DLL) {
			     if (msg_type == GET_USER_MSG_ID (PLID, "DeathMsg", NULL))
		        botMsgFunction = BotClient_FLF_DeathMsg;
			  } else if (mod_id == SI_DLL) {
			    if (msg_type == GET_USER_MSG_ID (PLID, "DeathMsg", NULL))
		       botMsgFunction = BotClient_SI_DeathMsg;
	     }
		 }

   }
   RETURN_META (MRES_IGNORED);
}


void pfnMessageEnd(void)
{
   if (gpGlobals->deathmatch)
   {
      if (debug_engine) { fp=fopen("bot.txt","a"); fprintf(fp,"pfnMessageEnd:\n\n"); fclose(fp); }

      // clear out the bot message function pointer...
      botMsgFunction = NULL;
			//debug_engine = 0; //change!!!!
   }

   RETURN_META (MRES_IGNORED);
}


void pfnWriteByte(int iValue)
{
   if (gpGlobals->deathmatch)
   {
      if (debug_engine) { fp=fopen("bot.txt","a"); fprintf(fp,"pfnWriteByte: %d\n",iValue); fclose(fp); }

      // if this message is for a bot, call the client message function...
      if (botMsgFunction) {
				current_type = TYPE_BYTE;
        (*botMsgFunction)((void *)&iValue, botMsgIndex);
			}
   }

   RETURN_META (MRES_IGNORED);
}


void pfnWriteChar(int iValue)
{
   if (gpGlobals->deathmatch)
   {
      if (debug_engine) { fp=fopen("bot.txt","a"); fprintf(fp,"pfnWriteChar: %d\n",iValue); fclose(fp); }

      // if this message is for a bot, call the client message function...
      if (botMsgFunction) {
				current_type = TYPE_CHAR;
         (*botMsgFunction)((void *)&iValue, botMsgIndex);
			}
   }

   RETURN_META (MRES_IGNORED);
}


void pfnWriteShort(int iValue)
{
   if (gpGlobals->deathmatch)
   {
      if (debug_engine) { fp=fopen("bot.txt","a"); fprintf(fp,"prnWriteShort: %d\n",iValue); fclose(fp); }

      // if this message is for a bot, call the client message function...
      if (botMsgFunction) {
				current_type= TYPE_SHORT;
         (*botMsgFunction)((void *)&iValue, botMsgIndex);
			 }
   }

   RETURN_META (MRES_IGNORED);
}


void pfnWriteLong(int iValue)
{
   if (gpGlobals->deathmatch)
   {
      if (debug_engine) { fp=fopen("bot.txt","a"); fprintf(fp,"pfnWriteLong: %d\n",iValue); fclose(fp); }

      // if this message is for a bot, call the client message function...
      if (botMsgFunction) {
				current_type= TYPE_LONG;
         (*botMsgFunction)((void *)&iValue, botMsgIndex);
			 }
   }

   RETURN_META (MRES_IGNORED);
}


void pfnWriteAngle(float flValue)
{
   if (gpGlobals->deathmatch)
   {
      if (debug_engine) { fp=fopen("bot.txt","a"); fprintf(fp,"pfnWriteAngle: %f\n",flValue); fclose(fp); }

      // if this message is for a bot, call the client message function...
      if (botMsgFunction) {
				current_type= TYPE_ANGLE;
         (*botMsgFunction)((void *)&flValue, botMsgIndex);
			 }
   }

   RETURN_META (MRES_IGNORED);
}


void pfnWriteCoord(float flValue)
{
   if (gpGlobals->deathmatch)
   {
      if (debug_engine) { fp=fopen("bot.txt","a"); fprintf(fp,"pfnWriteCoord: %f\n",flValue); fclose(fp); }

      // if this message is for a bot, call the client message function...
      if (botMsgFunction) {
				current_type= TYPE_COORD;
         (*botMsgFunction)((void *)&flValue, botMsgIndex);
			}
   }

   RETURN_META (MRES_IGNORED);
}


void pfnWriteString(const char *sz)
{
   if (gpGlobals->deathmatch)
   {
      if (debug_engine) { fp=fopen("bot.txt","a"); fprintf(fp,"pfnWriteString: %s\n",sz); fclose(fp); }

      // if this message is for a bot, call the client message function...
      if (botMsgFunction) {
				current_type= TYPE_STRING;
         (*botMsgFunction)((void *)sz, botMsgIndex);
			}
   }

   RETURN_META (MRES_IGNORED);
}


void pfnWriteEntity(int iValue)
{
   if (gpGlobals->deathmatch)
   {
      if (debug_engine) { fp=fopen("bot.txt","a"); fprintf(fp,"pfnWriteEntity: %d\n",iValue); fclose(fp); }

      // if this message is for a bot, call the client message function...
      if (botMsgFunction) {
				current_type= TYPE_ENTITY;
         (*botMsgFunction)((void *)&iValue, botMsgIndex);
			 }
   }

   RETURN_META (MRES_IGNORED);
}


const char *pfnCmd_Args (void)
{
   // this function returns a pointer to the whole current client command string. Since bots
   // have no client DLL and we may want a bot to execute a client command, we had to implement
   // a g_argv string in the bot DLL for holding the bots' commands, and also keep track of the
   // argument count. Hence this hook not to let the engine ask an unexistent client DLL for a
   // command we are holding here. Of course, real clients commands are still retrieved the
   // normal way, by asking the engine.

   if (isFakeClientCommand)
   {
      // is it a "say" or "say_team" client command ?
      if (strncmp ("say ", g_argv, 4) == 0)
         RETURN_META_VALUE (MRES_SUPERCEDE, &g_argv[0] + 4); // skip the "say" bot client command (bug in HL engine)
      else if (strncmp ("say_team ", g_argv, 9) == 0)
         RETURN_META_VALUE (MRES_SUPERCEDE, &g_argv[0] + 9); // skip the "say_team" bot client command (bug in HL engine)

      RETURN_META_VALUE (MRES_SUPERCEDE, &g_argv[0]); // else return the whole bot client command string we know
   }

   RETURN_META_VALUE (MRES_IGNORED, 0);
}


const char *pfnCmd_Argv (int argc)
{
   // this function returns a pointer to a certain argument of the current client command. Since
   // bots have no client DLL and we may want a bot to execute a client command, we had to
   // implement a g_argv string in the bot DLL for holding the bots' commands, and also keep
   // track of the argument count. Hence this hook not to let the engine ask an unexistent client
   // DLL for a command we are holding here. Of course, real clients commands are still retrieved
   // the normal way, by asking the engine.

   if (isFakeClientCommand)
      RETURN_META_VALUE (MRES_SUPERCEDE, GetField (g_argv, argc)); // returns the wanted argument

   RETURN_META_VALUE (MRES_IGNORED, 0);
}


int pfnCmd_Argc (void)
{
   // this function returns the number of arguments the current client command string has. Since
   // bots have no client DLL and we may want a bot to execute a client command, we had to
   // implement a g_argv string in the bot DLL for holding the bots' commands, and also keep
   // track of the argument count. Hence this hook not to let the engine ask an unexistent client
   // DLL for a command we are holding here. Of course, real clients commands are still retrieved
   // the normal way, by asking the engine.

   if (isFakeClientCommand)
      RETURN_META_VALUE (MRES_SUPERCEDE, fake_arg_count); // return the argument count

   RETURN_META_VALUE (MRES_IGNORED, 0);
}


void pfnSetClientMaxspeed(const edict_t *pEdict, float fNewMaxspeed)
{
   if (debug_engine) { fp=fopen("bot.txt","a"); fprintf(fp,"pfnSetClientMaxspeed: edict=%x %f\n",pEdict,fNewMaxspeed); fclose(fp); }
	 if (mod_id == FLF_DLL || mod_id == SI_DLL) {
	 	if (pEdict) {
	 	  int index = UTIL_GetBotIndex((edict_t *)pEdict);
			 // is this message for a bot?
			 if (index != -1) {
				 bots[index].f_max_speed = fNewMaxspeed;
			 }
	 	}
	 }
   RETURN_META (MRES_IGNORED);
}




C_DLLEXPORT int GetEngineFunctions (enginefuncs_t *pengfuncsFromEngine, int *interfaceVersion)
{
   meta_engfuncs.pfnChangeLevel = pfnChangeLevel;
   meta_engfuncs.pfnMessageBegin = pfnMessageBegin;
   meta_engfuncs.pfnMessageEnd = pfnMessageEnd;
   meta_engfuncs.pfnWriteByte = pfnWriteByte;
   meta_engfuncs.pfnWriteChar = pfnWriteChar;
   meta_engfuncs.pfnWriteShort = pfnWriteShort;
   meta_engfuncs.pfnWriteLong = pfnWriteLong;
   meta_engfuncs.pfnWriteAngle = pfnWriteAngle;
   meta_engfuncs.pfnWriteCoord = pfnWriteCoord;
   meta_engfuncs.pfnWriteString = pfnWriteString;
   meta_engfuncs.pfnWriteEntity = pfnWriteEntity;
   meta_engfuncs.pfnCmd_Args = pfnCmd_Args;
   meta_engfuncs.pfnCmd_Argv = pfnCmd_Argv;
   meta_engfuncs.pfnCmd_Argc = pfnCmd_Argc;
   meta_engfuncs.pfnSetClientMaxspeed = pfnSetClientMaxspeed;

   memcpy (pengfuncsFromEngine, &meta_engfuncs, sizeof (enginefuncs_t));
   return TRUE;
}
