
#ifndef LOGGING_H
#define LOGGING_H

#define CURRENT_LOG_VERSION 1

typedef struct {
	char mapName[32];
	unsigned short ver;
	int numberOfSentries;
	int numberOfTeams;
	int numberOfWaypoints;
	float totalMoves;
	float totalKills;
	float totalDeaths;
} LOG_FILE_HEADER;


typedef struct {
	unsigned int moves;
	unsigned int kills;
	unsigned int deaths;
} NORMAL_WAYPOINT_DATA;

typedef struct {
	unsigned int kills;
	unsigned int builds;
	int waypoint;
} SENTRY_DATA;

//function prototypes
void ReadData(void);

void InitLogs(void);

//saves the log data and optimises the active data
void SaveData(void);

void LogBotDie(int team, int waypoint);

void LogBotKill(int team, int waypoint);

void LogBotMove(int team, int waypoint);

void LogBotSentryKill(int team, int point);

float GetAverageKillDeath(void);

//smaller is better
float GetAverageMoveKill(void);

//smaller is better
float GetAverageDeathMove(void);

float GetKillDeath(int team, int waypoint);

float GetMoveKill(int team, int waypoint);

float GetDeathMove(int team, int waypoint);

void PrintLogData(edict_t * pent);
void PrintPointData(edict_t * pent);
void PrintTotalData(edict_t * pent);
void OptimiseData(void);

void WaypointsLoaded(void);

void ServerDeactivated(void);

#endif


