//
// HPB bot - botman's High Ping Bastard bot
//
// (http://planethalflife.com/botman/)
//
// waypoint.cpp
//

#ifndef _WIN32
#include <string.h>
#endif

#include <extdll.h>
#include <dllapi.h>
#include <h_export.h>
#include <meta_api.h>

#include "bot.h"
#include "waypoint.h"
#include "logging.h"

#define NONE 0
#define WAYPOINT_MENU 1
#define TEAM_MENU 2
#define FLAG_MENU 3
#define TFC_MENU 4
#define ACTIVITY_MENU 5
int CurrentMenu;
int CurrentMenuWaypoint;


extern int mod_id;
extern int m_spriteTexture;
extern bot_t bots[32];


// waypoints with information bits (flags)
extern WAYPOINT waypoints[MAX_WAYPOINTS];

// number of waypoints currently in use
extern int num_waypoints;

// declare the array of head pointers to the path structures...
extern PATH *paths[MAX_WAYPOINTS];

// time that this waypoint was displayed (while editing)
extern float wp_display_time[MAX_WAYPOINTS];


float RandomValue(int team, int waypoint) {
	return RANDOM_FLOAT(0.6, 1);
}

void AStar(bot_t * pBot);


// counts the number of nodes after head
int getLength(QNode * head) {
	QNode *current = head;
	int count = 1;
	current = current->next;
	while (current != head) {
		count++;
		current = current->next;
	}
	return count;
}

// the distance from one waypoint to another
float travelCost(int from, int to, edict_t * pEntity ) {
	if (from == to) return -1.0;
	int team = 0;
	PATH *pPath = NULL;
	int path_index = 0, i;
	while ((i=WaypointFindPath(&pPath, &path_index, from, team, pEntity)) != -1) {
		if (i == to) {
			return (waypoints[from].origin-waypoints[to].origin).Length();
		}
	}
	return -1;
}

QNode *enque(QNode *head, int num, int prev, float dist) {
	QNode *newNode;
	newNode = (QNode*)malloc(sizeof(QNode));
	//printf("Enqueing data: %d %d %d\n", num, prev, dist);
	newNode->num=num;
	newNode->prev=prev;
	newNode->dist=dist;
	newNode->next=NULL;
	if (head==NULL) {
		newNode->next = newNode;
		return newNode;
	} else {
		newNode->next=head->next;
		head->next=newNode;
		return newNode;
	}
}

QNode *deque(QNode *head, int *num, int *prev, float *dist) {
	QNode *killNode;
	if (head ==NULL) {return NULL;}
	killNode = head->next;
	*num = killNode->num;
	*prev = killNode->prev;
	*dist = killNode->dist;

	if (head->next == head) {
		free(head);
		return NULL;
	} else {
		head->next = killNode->next;
		free(killNode);
		return head;
	}
}

int FindNearestWaypoint(int from, int flags, bool dontcountStart, VNode* visited) {
	//VNode visited[MAX_WAYPOINTS];
	int i, index = -1, team=-1;;
	float shortest, dist;
	//doPath(from, team, &visited);
	for (i = 0; i < num_waypoints; i++) {
		if (dontcountStart && from == i) continue;
		if (visited[i].prev == -1) continue;
		if (waypoints[i].flags & flags) {
			dist = visited[i].dist;
			if (index < 0) {
				index = i;
				shortest = dist;
			} else if (dist < shortest) {
				index = i;
				shortest = dist;
			}
		}
	}
	return index;
}

int FindRandomWaypoint(int from, int flags, bool dontcountStart, VNode *visited) {
	//VNode visited[MAX_WAYPOINTS];
	int possibles[50];
	int used = 0, i, team = -1;;
	//doPath(from, team, &visited);
	for (i = 0; (i < num_waypoints && used < 50); i++) {
		if (dontcountStart && from == i) continue;
		if (visited[i].prev == -1) continue;
		if (waypoints[i].flags & flags) {
			possibles[used] = i;
			used++;
		}
	}
	if (used == 0) return -1;
	return possibles[RANDOM_LONG(0,used-1)];
}

int FLF_FindDefendPoint(bot_t *pBot, int from, VNode *visited) {
	VNode fromPoint[MAX_WAYPOINTS];
	int capturePoint = FLF_FindUncapturedPoint(pBot, from, visited);
	float shortest = 500; //stay this close to the capture point;
	int choice = -1, i, count = 0;
	int possible[50];
	doPath(capturePoint, Waypoint_GetTeam(pBot), fromPoint, pBot->pEdict, RandomValue);
	possible[count++] = capturePoint;
	for (i = 0; i < MAX_WAYPOINTS && count < 50; i++) {
		if (i == from) continue;
		if (waypoints[i].flags & W_FL_GUARD) {
			if (fromPoint[i].dist < shortest) {
				possible[count++] = i;
			}
		}
	}
	if (count > 0) {
		return possible[RANDOM_LONG(0, count -1)];
	} else {
		return capturePoint;
	}
}

int FLF_FindUncapturedPoint(bot_t *pBot, int from, VNode *visited) {
	int possibles[5];
	int used = 0, i = 0;
	for (i = 0; i < num_waypoints && used < 5; i++) {
		if (visited[i].prev == -1) continue; // can't reach
		if (waypoints[i].flags & W_FL_FLAG) {
			edict_t * pEnt = NULL;
			while ( (pEnt = UTIL_FindEntityByClassname(pEnt, "capture_point")) != NULL) {
				if ( (waypoints[i].origin - pEnt->v.origin).Length() < 100) {
					if (   (pEnt->v.skin!=UTIL_GetTeam(pBot->pEdict) && pBot->flf_attacking) ||
					   (pEnt->v.skin==UTIL_GetTeam(pBot->pEdict) && !(pBot->flf_attacking) ) ) { //it is uncaptured
					//if (pEnt->v.skin == 1) {
						 possibles[used++] = i;
					 }
				 }
			 }
		 }
	 }
	if (used == 0) return -1;
	//UTIL_SayText("I found an uncaptured point", pBot->pEdict);
	return possibles[RANDOM_LONG(0,used-1)];
}

int FindUndetonatedPoint(bot_t *pBot, int from, VNode *visited) {
	int possibles[50];
	int used = 0, i = 0;
	if (mod_id != TFC_DLL) return -1;
	for (i = 0; i < num_waypoints && used < 50; i++) {
		if (visited[i].prev == -1) continue; // can't reach
		if (waypoints[i].flags & W_FL_DETPACK) {
			/*
			edict_t * pEnt = NULL;
			while ( (pEnt = UTIL_FindEntityInSphere(pEnt, waypoints[i].origin, 150)) != NULL) {
				if (strcmp(STRING(pEnt->v.classname), "func_breakable")==0) {
		   		possibles[used++] = i;
			  }
		  }*/
		possibles[used++] = i;
	  }
  }
	if (used == 0) return -1;
	//UTIL_SayText("I found an uncaptured point", pBot->pEdict);
	return possibles[RANDOM_LONG(0,used-1)];
}


void WaypointShowMenu(edict_t *pEntity) {
	CurrentMenuWaypoint = -1;
	CurrentMenuWaypoint= WaypointFindNearest(pEntity, 50.0, -1);
	if (CurrentMenuWaypoint > -1) {
		UTIL_ShowMenu(pEntity, 1+2+4+8+16, -1, FALSE, "1. Team Specific\n2. Environment\n3. Activity\n4. TFC\n5. Cancel");
		CurrentMenu = WAYPOINT_MENU;
	} else {
		CurrentMenu = NONE;
	}
}

bool WaypointMenuSelect(edict_t *pEntity, int num) {
	int menu = CurrentMenu;
	CurrentMenu = NONE;
	if (menu == NONE) return FALSE;
	if (num == 5) return TRUE; // 5 is always cancel'
	if (menu == WAYPOINT_MENU) {
		if (num == 1) {
			char *pText = NULL;
			if (mod_id ==FLF_DLL) {
				pText = "1. Defenders\n2. Attackers\n5. Cancel";
			} else {
				pText = "1. Team 1\n2. Team 2\n3. Team 3\n4. Team 4\n5. Cancel";
			}
			UTIL_ShowMenu(pEntity, 1+2+4+8+16,-1, FALSE, pText);
			CurrentMenu = TEAM_MENU;
		} else if (num == 2) {
			char *pText;
			if (mod_id == FLF_DLL) {
				pText = "1. Sniper\n2. Interesting\n3. Capture Point\n5. Cancel";
			} else if (mod_id == SI_DLL) {
				pText = "1. Sniper\n2. Interesting\n3. Enemy Reseach Area\n4. Your Administrator\n5. Cancel";
			} else {
				pText = "1. Sniper\n2. Interesting\n3. Flag Location\n4. Flag Goal\n5. Cancel";
			}
			UTIL_ShowMenu(pEntity, 1+2+4+8+16,-1, FALSE, pText);
			CurrentMenu = FLAG_MENU;
		} else if (num == 3) {
			UTIL_ShowMenu(pEntity, 1+2+4+8+16,-1, FALSE, "1. Guard\n2. Check\n3. Door\n4. Lift\n5. Cancel");
			CurrentMenu = ACTIVITY_MENU;
		} else if (num == 4) {
			UTIL_ShowMenu(pEntity, 1+2+4+8+16+32,-1, FALSE, "1. Sentry\n2. Dispenser\n3. Detpack\n4. Jump\n5. Cancel");
			CurrentMenu = TFC_MENU;
		}
	} else if (menu == FLAG_MENU) {
		if (num == 1) {
			waypoints[CurrentMenuWaypoint].flags ^= W_FL_SNIPER;
		} else if (num == 2) {
			waypoints[CurrentMenuWaypoint].flags ^= W_FL_VISIT;
		} else if (num == 3) {
			waypoints[CurrentMenuWaypoint].flags ^= W_FL_FLAG;
		} else if (num == 4) {
			waypoints[CurrentMenuWaypoint].flags ^= W_FL_FLAG_GOAL;
		}
	} else if (menu == ACTIVITY_MENU) {
    if (num == 1) {
			waypoints[CurrentMenuWaypoint].flags ^= W_FL_GUARD;
		} else if (num == 2) {
			waypoints[CurrentMenuWaypoint].flags ^= W_FL_CHECK;
		} else if (num == 3) {
			waypoints[CurrentMenuWaypoint].flags ^= W_FL_DOOR;
		} else if (num == 4) {
			waypoints[CurrentMenuWaypoint].flags ^= W_FL_LIFT;
		}
	} else if (menu == TFC_MENU) {
		if (num == 1) {
			waypoints[CurrentMenuWaypoint].flags ^= W_FL_SENTRY;
		} else if (num == 2) {
			waypoints[CurrentMenuWaypoint].flags ^= W_FL_DISPENSER;
		} else if (num == 3) {
			waypoints[CurrentMenuWaypoint].flags ^= W_FL_DETPACK;
		} else if (num == 4) {
			waypoints[CurrentMenuWaypoint].flags ^= W_FL_JUMP;
		}
	}	else if (menu == TEAM_MENU) {
		waypoints[CurrentMenuWaypoint].flags ^= W_FL_TEAM_SPECIFIC;
		ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, "Item Selected\n");
		if (waypoints[CurrentMenuWaypoint].flags & W_FL_TEAM_SPECIFIC) { //if it is now team specific
			ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, "It's team specific\n");
			waypoints[CurrentMenuWaypoint].flags &= (~W_FL_TEAM); //erase the old team;
			num--;
			waypoints[CurrentMenuWaypoint].flags |= num;
		} else {
			ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, "It's not team specific\n");
		}
	}
	return TRUE;
}

int getNextWaypoint(bot_t *pBot) {
	int answer = -1;
	if (pBot->destination < 0) return -1;
	if (pBot->currentPoint < 0) return -1;
	if (pBot->waypoints_upto < 0 || pBot->waypoints_upto > 9) 
	{
		createPath(pBot);
		pBot->waypoints_upto = 0;

	}
	if (pBot->waypoints_upto == -1) return -1;
	answer = pBot->next_waypoints[pBot->waypoints_upto];
	(pBot->waypoints_upto)++;
	return answer;
}

void createPath(bot_t *pBot) {
	//find the paths from current
	QNode *qHead=NULL;
	VNode visited[MAX_WAYPOINTS];
	int start=pBot->currentPoint;
	int finish=pBot->destination;
	int current, i, count;
	//init();
	//FILE *fp;

	if (start < 0 || finish < 0) return;
	AStar(pBot); 	return;

	int team = Waypoint_GetTeam(pBot);
	int path_index = 0;

	float (* pfnWeight)(int, int);

	pfnWeight = RandomValue;
	/*
	if (pBot->moveType == MOVETYPE_NORMAL) {
	} else if (pBot->moveType == MOVETYPE_SCARED) {
		pfnWeight = GetDeathMove;
	} else if (pBot->moveType == MOVETYPE_KILL) {
		pfnWeight = GetMoveKill;
	} else {
		pfnWeight = RandomValue;
	}
	*/

	/*
	UTIL_ClientPrintAll( HUD_PRINTCENTER, "Calculating paths\n");
	for (i = 0; i < MAX_WAYPOINTS; i++) {
		visited[i].prev = -1;
		visited[i].dist = -1;
	}

	qHead = enque(qHead,start,-1, 0.0);

	while (qHead != NULL) {
		qHead = deque(qHead,&current, &prev, &distance);
	  pPath = NULL;
		path_index = 0;
		while ((i=WaypointFindPath(&pPath, &path_index, current, team)) != -1) {
			cost = travelCost(current,i);
			if (cost != -1) {
				oldDist = visited[i].dist;
				if (oldDist == -1 || oldDist > cost+distance) {
					visited[i].prev = current;
					visited[i].dist = cost+distance;
					qHead = enque(qHead, i, current, cost+distance);
				}
			}
		}
	}
	*/

	doPath(start, team, visited, pBot->pEdict, pfnWeight );

	//init the bot;
	for ( i = 0; i < 10; i++) 
	{
		pBot->next_waypoints[i] = -1;
	}

	// count the number of points
	current = finish;
	count = 0;
	while ((current = visited[current].prev) != start) {
		if (current == -1) break;
		count++;
	}
	if (current != start) return; // no path there you biatch


	current = finish;
	while (count >= 0) {
		if (current < 0) break;
		if (count < 10) {
			pBot->next_waypoints[count] = current;
		}
		count--;
		current = visited[current].prev;
	}

	pBot->waypoints_upto = 0;
}

void doPath(int from, int team, VNode *visited, edict_t *pEntity, float (* weight)(int , int) = RandomValue ){
	QNode *qHead=NULL;
	int start=from;
	float cost, oldDist, distance;
	int current, prev, i, path_index;
	PATH *pPath;

	for (i = 0; i < MAX_WAYPOINTS; i++) {
		visited[i].prev = -1;
		visited[i].dist = -1;
	}

	qHead = enque(qHead,start,-1, 0.0);

	while (qHead != NULL) {
		qHead = deque(qHead,&current, &prev, &distance);
	  pPath = NULL;
		path_index = 0;
		while ((i=WaypointFindPath(&pPath, &path_index, current, team, pEntity)) != -1) {
			cost = travelCost(current,i)* weight(team, i); //RANDOM_FLOAT(0.6,1.0); //GetDeathMove(team, i);
			if (cost != -1) {
				oldDist = visited[i].dist;
				if (oldDist == -1 || oldDist > cost+distance) {
					visited[i].prev = current;
					visited[i].dist = cost+distance;
					qHead = enque(qHead, i, current, cost+distance);
				}
			}
		}
	}
}

float travelCost(int from, int to) 
{
	return (waypoints[from].origin-waypoints[to].origin).Length();
}

int Waypoint_GetTeam(bot_t *pBot)
{
	if (mod_id == FLF_DLL) 
	{
		if (pBot->flf_attacking) 
		{
			return 1;
		} 
		else
		{
			return 0;
		}
	} 
	else
	{
		return UTIL_GetTeam(pBot->pEdict);
	}
}

int RepairSentry(bot_t *pBot) 
{
	bool sentry = FALSE;
	int level=0;
	float max_health=0;
	edict_t * pSentry = pBot->pSentry;
	if (mod_id == TFC_DLL)
	{
		if (pBot->bot_class == TFC_CLASS_ENGINEER) 
		{
			if (pSentry)
			{
				if(FStrEq(STRING(pSentry->v.model), "models/sentry1.mdl"))
				{
					level = 1;
					max_health = 150.0;
				} 
				else if(FStrEq(STRING(pSentry->v.model), "models/sentry2.mdl"))
				{
					level = 2;
					max_health = 180.0;
				}
				else if(FStrEq(STRING(pSentry->v.model), "models/sentry3.mdl"))
				{
					level = 3;
					max_health = 216.0;
				}

				if (pSentry->v.health < max_health)
				{
					if (pBot->m_rgAmmo[2] > 0) 
					{
						sentry = TRUE;
					}
				}
				else if (level < 3)
				{
					if (pBot->m_rgAmmo[2] > 150) 
					{ //upgrade
						sentry = TRUE;
					}
				}
				if (!sentry)
				{ //needs ammo ?
					if (pBot->sentry_ammo < 75)
					{
						sentry = TRUE;
					}
				}
			}
		}
	}
	if (sentry)
	{
		return WaypointFindNearest(pBot->pSentry, 150, UTIL_GetTeam(pBot->pEdict));
	}
	return -1;
}

int FindSniperPoint(bot_t * pBot, VNode * visited) {
	int j, i, dontuse[32], upto=0, dontuseupto=0, possibles[50], team = Waypoint_GetTeam(pBot), best = -1;
	float bestvalue = 999999;
	//sprintf(buffer, "%s is looking for a sniper point\n", STRING(pBot->pEdict->v.netname));
	//UTIL_ClientPrintAll(HUD_PRINTNOTIFY, buffer);
	for (i = 1; i <= gpGlobals->maxClients; i++) {
		j = UTIL_GetBotIndex(INDEXENT(i));
		if ( j == -1) continue;
		if (bots[j].is_used) {
			if (bots[j].state == STATE_SNIPING) {
				if (pBot->stateTime > gpGlobals->time) {
					dontuse[dontuseupto++] = bots[j].last_point;
				} else {
					dontuse[dontuseupto++] = bots[j].destination;
				}
			}
		}
	}
	//sprintf(buffer, "There are %d points i can't use\n", dontuseupto);
	//UTIL_ClientPrintAll(HUD_PRINTNOTIFY, buffer);
	for (i = 0; i < num_waypoints && upto < 50; i++) {
		if (waypoints[i].flags & W_FL_DELETED) continue;
		if (waypoints[i].flags & W_FL_SNIPER) {
			for (j = 0; j < dontuseupto; j++) {
				if (dontuse[j] == i) goto endloop;
			}
			if (visited[i].dist == -1.0) continue;
			possibles[upto++] = i;
		}
		endloop:;
	}
	//sprintf(buffer, "There are %d points i can use\n", upto);
	//UTIL_ClientPrintAll(HUD_PRINTNOTIFY, buffer);
	if (upto == 0) return -1;
	//return possibles[0];
	/*
	for (i = 0; i < upto; i++) {
		if ((current = GetMoveKill(team, possibles[i])) < bestvalue) {
			bestvalue = current;
			best = possibles[i];
		}
	}
	*/
	//sprintf(buffer, "The best is %d \n", best);
	//UTIL_ClientPrintAll(HUD_PRINTNOTIFY, buffer);

	//return best;
	return possibles[RANDOM_LONG(0,upto-1)];
}

void BotSetMoveType(bot_t * pBot) {
	int destflags;
	int moveType = 0;
	if (pBot->destination > -1 && pBot->destination < MAX_WAYPOINTS) {
		destflags = waypoints[pBot->destination].flags;
	} else {
		return;
	}
	if (mod_id == TFC_DLL) {
		if (pBot->gotFlag) {
			moveType = MOVETYPE_SCARED;
		} else {
			switch (pBot->bot_class) {
			case TFC_CLASS_CIVILIAN : moveType = MOVETYPE_SCARED; break;
			case TFC_CLASS_SCOUT : moveType = MOVETYPE_SCARED; break;
			case TFC_CLASS_HWGUY : moveType = MOVETYPE_KILL; break;
			}
		}
	}
	pBot->moveType = moveType;
}

/************** AStar Functions *************/
typedef struct
{
	float distance;
	int waypoint;
}
HeapNode;

/*id AddItemToHeap(HeapNode *heap, int &heapsize, float distance, int waypoint);
int RemoveItemFromHeap(HeapNode *heap, int &heapsize);
float AStarEstimate(float * table, int from, int to);
float AStarTravelCost(int from, int to);
*/


inline float AStarEstimate(int from, int to)
{
	Vector v_dist;
	v_dist = waypoints[from].origin - waypoints[to].origin;
	float dist = (v_dist.x * v_dist.x) + (v_dist.y * v_dist.y) + (v_dist.z * v_dist.z);
	dist *= RANDOM_FLOAT(0.8, 1.1);
	return dist;
}

inline float AStarEstimate(int * waypointList, int size, int from)
{
	Vector v_dist;
	float dist, min_dist = -1;
	int i;
	for (i = 0; i < size; i++)
	{
		dist = AStarEstimate(from, waypointList[i]);
		if (dist < min_dist || min_dist == -1.0)
		{
			min_dist = dist;
		}
	}
	return min_dist;
}

/*

	if (table[from] == -2)
	{
		v_dist = waypoints[from].origin - waypoints[to].origin;
		dist = (v_dist.x * v_dist.x) + (v_dist.y * v_dist.y) + (v_dist.z * v_dist.z);
		dist *= RANDOM_FLOAT(0.8, 1.1);
	}
	else
	{
		dist = table[from];
	}
	return dist;
}
*/


inline float AStarTravelCost(int from, int to)
{
	Vector v_dist = waypoints[from].origin - waypoints[to].origin;
	return (v_dist.x * v_dist.x) + (v_dist.y * v_dist.y) + (v_dist.z * v_dist.z);
}


inline void ReheapUp(HeapNode *heap, int &heapsize)
{
	int current = heapsize-1; //the last item
	int parent;
	HeapNode temp;
	while (current > 0)
	{
		parent = (current-1)/2;
		if (heap[parent].distance <= heap[current].distance) return;
		temp = heap[parent];
		heap[parent] = heap[current];
		heap[current] = temp;
		current = parent;
	}
}

inline void ReheapDown(HeapNode *heap, int &heapsize)
{
	int current =0;
	int lchild, rchild, smallest;
	HeapNode temp;
	temp = heap[heapsize -1];
	heap[heapsize -1] = heap[0];
	heap[0] = temp;
	while (current < heapsize)
	{
		lchild = 2*current + 1;
		rchild = 2*current + 2;
		if (lchild >= heapsize) return;
		if (rchild >= heapsize) rchild = 0;
		if (rchild && heap[rchild].distance < heap[lchild].distance)
		{
			smallest = rchild;
		}
		else
		{
			smallest = lchild;
		}
		if (heap[current].distance > heap[smallest].distance)
		{
			temp = heap[current];
			heap[current] = heap[smallest];
			heap[smallest] = temp;
			current = smallest;
		}
		else
		{
			return;
		}
	}
}

inline void AddItemToHeap(HeapNode *heap, int & heapsize, const float distance, const int waypoint)
{
		heap[heapsize].distance = distance;
		heap[heapsize].waypoint = waypoint;
		heapsize++;
		ReheapUp(heap, heapsize);
}


inline int RemoveItemFromHeap(HeapNode *heap, int &heapsize)
{
	int waypoint = heap->waypoint;
	if (heapsize == 0) return -1;
	heapsize--;
	*heap = heap[heapsize];
	if (heapsize > 0) ReheapDown(heap, heapsize);
	return waypoint;
}

void GetReachableWaypoints(bot_t  * pBot, bool *reachable)
{
	bool * pBool = reachable, *pLast = reachable + MAX_WAYPOINTS;
	int theStack[MAX_WAYPOINTS], 
		*pStack = theStack,
		i, current, path_index, 
		team = Waypoint_GetTeam(pBot);
	PATH * pPath;
	for (; pBool < pLast; pBool++)
	{
		*pBool = FALSE;
	}
	*theStack = pBot->currentPoint;
	while (pStack >= theStack)
	{
		current = *pStack;
		pStack--;
		i = -1;
		pPath = NULL;
		path_index = 0;
		while((i =WaypointFindPath(&pPath, &path_index, current, team, pBot->pEdict)) != -1)
		{
			if(!reachable[i])
			{
				reachable[i] = TRUE;
				pStack++;
				*pStack = i;
			}
		}
	}
	reachable[pBot->currentPoint] = FALSE;
}

int FindReachableWaypointSet(bool *reachable, int flags, int *possibles)
{
	int used = 0;
	for(int i = 0; i < MAX_WAYPOINTS; i++)
	{
		if (reachable[i] && (waypoints[i].flags & flags))
		{
			if (used == 50) break;
			possibles[used] = i;
			used++;
		}
	}
	return used;
}

int FindRandomReachableWaypoint(bool * reachable, int flags)
{
	int possibles[50];
	int used = FindReachableWaypointSet(reachable, flags, possibles);
	if (used == 0) return -1;
	return possibles[RANDOM_LONG(0, used-1)];
}

int FindRandomSniperPoint(bool * reachable)
{
	int possibles[50];
	int alreadyUsed[32];
	int available[50];
	int numAlreadyUsed = 0,
		numAvailable=0,
		i,j;
	bool taken;
	int used = FindReachableWaypointSet(reachable, W_FL_SNIPER, possibles);
	if (used == 0) return -1;
	for (i = 0; i <32; i++)
	{
		if (bots[i].is_used)
		{
			if(bots[i].state == STATE_SNIPING)
			{
				if (bots[i].stateTime > gpGlobals->time)
				{
					alreadyUsed[numAlreadyUsed] = bots[i].last_point;
				}
				else
				{
					alreadyUsed[numAlreadyUsed] = bots[i].destination;
				}
				numAlreadyUsed++;
			}
		}
	}
	for (i = 0; i < used; i++)
	{
		taken = FALSE;
		for ( j =0; j < numAlreadyUsed; j++)
		{
			if (alreadyUsed[j] == possibles[i])
			{
				taken = TRUE;
				break;
			}
		}
		if (!taken)
		{
			available[numAvailable] = possibles[i];
			numAvailable++;
		}
	}
	if (numAvailable == 0) return -1;
	return available[RANDOM_LONG(0, numAvailable-1)];
}

int FindRandomUncapturedPoint(bot_t *pBot, bool * reachable) 
{
	int possibles[50];
	int available[50];
	int used = FindReachableWaypointSet(reachable, W_FL_FLAG, possibles);
	int numAvailable = 0,
		i;
	edict_t * pEnt = NULL;
	float dist;
	for (i = 0; i < used; i++)
	{
		pEnt = NULL;
		while ((pEnt = UTIL_FindEntityByClassname(pEnt, "capture_point")) != NULL)
		{
			dist = (waypoints[possibles[i]].origin - pEnt->v.origin).Length();
			if ( dist < 100)
			{
					if (
						(pEnt->v.skin != UTIL_GetTeam(pBot->pEdict) && pBot->flf_attacking) ||
						(pEnt->v.skin == UTIL_GetTeam(pBot->pEdict) && !(pBot->flf_attacking))
					)
					{
						available[numAvailable++] = possibles[i];
					}
			}
		}
	}
	if (numAvailable == 0) return -1;
	return available[RANDOM_LONG(0, numAvailable -1)];
}

int FindRandomDefendPoint(bot_t * pBot, bool * reachable)
{
	int possibles[50];
	int used = 0, i;
	int point = FindRandomUncapturedPoint(pBot, reachable);
	if (point == -1) return -1; /* no points left */
	possibles[used++] = point;
	for (i = 0; i < num_waypoints; i++)
	{
		if (waypoints[i].flags & W_FL_GUARD)
		{
			if ((waypoints[i].origin - waypoints[point].origin).Length() < 1000)
			{
				possibles[used++] = i;
			}
		}
	}
	/*if (used == 1) return point;*/ /*not require anymore */
	return possibles[RANDOM_LONG(0, used-1)];
}




void AStar(bot_t * pBot)
{
	VNode visited[MAX_WAYPOINTS];
	int from=pBot->currentPoint;
	int to = pBot->destination;
	int team = Waypoint_GetTeam(pBot);

	float cost, oldDist, distance, estCost;
	int current, i, path_index;
	PATH *pPath;
	int heapsize = 0;
	HeapNode theheap[MAX_WAYPOINTS];

	pBot->waypoints_upto = 0;
	for (i = 0; i < MAX_WAYPOINTS; i++)
	{
		visited[i].prev = -1;
		visited[i].dist = -1;
		visited[i].closed = FALSE;
	}

	for ( i = 0; i < 10; i++) 
	{
		pBot->next_waypoints[i] = -1;
	}

	visited[from].dist = 0;
	visited[from].prev = from;


	AddItemToHeap(theheap, heapsize, 0, from);
	current = from;
	while(current != to && current != -1)
	{
		current = RemoveItemFromHeap(theheap, heapsize);
		//printf("Current: %d \n", current);
		pPath = NULL;
		path_index = 0;
		distance = visited[current].dist;
		if (visited[current].closed) continue;
		visited[current].closed = TRUE;
		while((i =WaypointFindPath(&pPath, &path_index, current, team, pBot->pEdict)) != -1)
		{
			if (visited[i].closed) continue;
			cost = AStarTravelCost(current, i);
			if (cost != -1)
			{
				oldDist = visited[i].dist;
				estCost = AStarEstimate(i, to);
				if (oldDist == -1 || oldDist > cost+distance)
				{
					visited[i].prev = current;
					visited[i].dist = cost+distance;
					AddItemToHeap(theheap, heapsize, cost+distance+estCost, i);
					if (heapsize >= MAX_WAYPOINTS)
					{
						printf("!");
						return;
					}
				}
			}
		}
	}
	if (current != to)
	{
		//printf("Failed\n");
		return;
	}
	else
	{
		int count=-1;
		while (current != from && current != -1)
		{
			current = visited[current].prev;
			count++;
			if (count >= MAX_WAYPOINTS)
			{
				printf("!!");
				return;
			}
		}
		if (current == -1) return;
		current = to;
		while (count >= 0 && count < MAX_WAYPOINTS)
		{
			if (current < 0) break;
			if (count < 10) 
			{
				pBot->next_waypoints[count] = current;
			}
			count--;
			current = visited[current].prev;
		}
	}
}

inline bool IsIn(int * set, int size, int num)
{
	int i;
	for (i = 0; i < size; i++)
	{
		if (set[i] == num) return TRUE;
	}
	return FALSE;
}

/*
Finds the nearest reachable waypoint for the bot, 
and sets up its next waypoint list t get there
*/
int FindNearestReachableWaypoint(bot_t *pBot, bool * reachable, int flags)
{
	VNode visited[MAX_WAYPOINTS];
	int possibles[50], possiblesUsed;
	int team = Waypoint_GetTeam(pBot);
	int destination;
	int from = pBot->currentPoint;

	float cost, oldDist, distance, estCost;
	int current, i, path_index;
	PATH *pPath;
	int heapsize = 0;
	HeapNode theheap[MAX_WAYPOINTS];

	pBot->waypoints_upto = 0;
	for (i = 0; i < MAX_WAYPOINTS; i++)
	{
		visited[i].prev = -1;
		visited[i].dist = -1;
		visited[i].closed = FALSE;
	}

	for ( i = 0; i < 10; i++) 
	{
		pBot->next_waypoints[i] = -1;
	}

	visited[from].dist = 0;
	visited[from].prev = from;

	possiblesUsed = FindReachableWaypointSet(reachable, flags, possibles);
	if (possiblesUsed == 0) return -1;


	AddItemToHeap(theheap, heapsize, 0, from);
	current = from;
	while(current != -1 && !IsIn(possibles, possiblesUsed, current) )
	{
		current = RemoveItemFromHeap(theheap, heapsize);
		//printf("Current: %d \n", current);
		pPath = NULL;
		path_index = 0;
		distance = visited[current].dist;
		if (visited[current].closed) continue;
		visited[current].closed = TRUE;
		while((i =WaypointFindPath(&pPath, &path_index, current, team, pBot->pEdict)) != -1)
		{
			if (visited[i].closed) continue;
			cost = AStarTravelCost(current, i);
			if (cost != -1)
			{
				oldDist = visited[i].dist;
				estCost = AStarEstimate(possibles, possiblesUsed, i);
				if (oldDist == -1 || oldDist > cost+distance)
				{
					visited[i].prev = current;
					visited[i].dist = cost+distance;
					AddItemToHeap(theheap, heapsize, cost+distance+estCost, i);
					if (heapsize >= MAX_WAYPOINTS)
					{
						printf("!");
						return -1;
					}
				}
			}
		}
	}
	destination = current;
	if (!IsIn(possibles, possiblesUsed, current))
	{
		//printf("Failed\n");
		return -1;
	}
	else
	{
		int count=-1;
		while (current != from && current != -1)
		{
			current = visited[current].prev;
			count++;
			if (count >= MAX_WAYPOINTS)
			{
				printf("!!");
				return -1;
			}
		}
		if (current == -1) return -1;
		current = destination;
		while (count >= 0 && count < MAX_WAYPOINTS)
		{
			if (current < 0) break;
			if (count < 10) 
			{
				pBot->next_waypoints[count] = current;
			}
			count--;
			current = visited[current].prev;
		}
	}
	return destination;
}
