#ifndef _WIN32
#include <string.h>
#endif

#include <extdll.h>
#include <dllapi.h>
#include <h_export.h>
#include <meta_api.h>

#include "bot.h"
#include "bot_func.h"
#include "waypoint.h"
#include "bot_weapons.h"
#include "my_navigate.h"
#include "logging.h"
#include "server.h"

#include <sys/types.h>
#include <sys/stat.h>

extern int mod_id;
extern int bot_chat_freq;
extern bot_t bots[32];
extern int min_bots;
extern int max_bots;


void ServerAddBot(void)
{
	const char *pcmd = CMD_ARGV(0);
	const char *arg1 = CMD_ARGV(1);
	const char *arg2 = CMD_ARGV(2);
	const char *arg3 = CMD_ARGV(3);
	const char *arg4 = CMD_ARGV(4);
	if (IS_DEDICATED_SERVER())
	{
		if (gpGlobals->time)// so we don't add a bot to an empty server == BAD!
		{
			BotCreate( NULL, arg1, arg2, arg3, arg4 );
			return;
		}
	}
	else
	{
		if (INDEXENT(1) != NULL)
		{
			BotCreate( NULL, arg1, arg2, arg3, arg4 );
			return;
		}
	}
	SERVER_PRINT("You have to start a game before you can add a bot!\n");
}

void ServerBotChat(void)
{
	const char *pcmd = CMD_ARGV(0);
	const char *arg1 = CMD_ARGV(1);
	const char *arg2 = CMD_ARGV(2);
	const char *arg3 = CMD_ARGV(3);
	const char *arg4 = CMD_ARGV(4);
	char buffer[80];

	if (*arg1 != '\0') {
		int newFreq = -1;
		newFreq = atoi(arg1);
		if (newFreq < 0) newFreq = 0;
		if (newFreq > 100) newFreq = 100;
		bot_chat_freq = newFreq;
	}
/*      if (IS_DEDICATED_SERVER())
         printf("Creating bot...\n");
      else if (pPlayer)
         ClientPrint( VARS(pPlayer), HUD_PRINTNOTIFY, "Creating bot...\n");
*/
	sprintf(buffer, "bot_chat is now: %d \n", bot_chat_freq);
	(*g_engfuncs.pfnServerPrint)(buffer);

	//ClientPrint( VARS(pEntity), HUD_PRINTNOTIFY, buffer);
}

void ServerBotCommand(void)
{
	const char *pcmd = CMD_ARGV(0);
	const char *arg1 = CMD_ARGV(1);
	const char *arg2 = CMD_ARGV(2);
	const char *arg3 = CMD_ARGV(3);
	const char *arg4 = CMD_ARGV(4);

	int state = -1;
	if (arg1 != NULL && *arg1 != '\0' && arg2 != NULL && *arg2 != '\0')
	{
		if (FStrEq(arg2, "normal"))
		{
			state = BEHAVE_NONE;
		}
		else if (FStrEq(arg2, "guard"))
		{
			state = BEHAVE_GUARD;
		}
		else if (FStrEq(arg2, "attack"))
		{
			state = BEHAVE_ATTACK;
		}
		if (state != -1) 
		{
			int i;
			edict_t *pPlayer;
			for (i = 1; i <= gpGlobals->maxClients; i++)
			{
				pPlayer = INDEXENT(i);
				if (!pPlayer) continue;
				if (FStrEq(arg1, STRING(pPlayer->v.netname)))
				{
					int bot_index = UTIL_GetBotIndex(pPlayer);
					if (bot_index != -1)
					{
						bots[bot_index].behaviour = state;
						bots[bot_index].destination = -1;
						bots[bot_index].currentPoint = -1;
						return;
					}
					//ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, "That player is not a bot!\n");
					(*g_engfuncs.pfnServerPrint)("That player is not a bot!\n");
					return;
				}
			}
			//ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, "That name is unknown\n");
			(*g_engfuncs.pfnServerPrint)("That name is unknown\n");
			return;
		}
		//ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, "That is not a valid command\nValid commands are: attack, guard and normal\n");
		(*g_engfuncs.pfnServerPrint)("That is not a valid command\nValid commands are: attack, guard and normal\n");
		return;
	}
	//ClientPrint(VARS(pEntity), HUD_PRINTNOTIFY, "Usage: bot_command <bot name> <command> \n");
	(*g_engfuncs.pfnServerPrint)("Usage: bot_command <bot name> <command>\n");
	return;
}

void ServerMinBots(void)
{
	const char *pcmd = CMD_ARGV(0);
	const char *arg1 = CMD_ARGV(1);
	char buffer[80];
	if (arg1 != 0 && *arg1 != '\0')
	{
		min_bots = atoi( arg1 );
		if ((min_bots < 0) || (min_bots > 31)) min_bots = 1;
		sprintf(buffer, "min_bots set to %d \n", min_bots);
	}
	else
	{
		sprintf(buffer, "min_bots is %d\n", min_bots);
	}
	SERVER_PRINT(buffer);
}

void ServerMaxBots(void)
{
	const char *pcmd = CMD_ARGV(0);
	const char *arg1 = CMD_ARGV(1);
	char buffer[80];
	if (arg1 != 0 && *arg1 != '\0')
	{
		max_bots = atoi( arg1 );
		if ((max_bots < 0) || (max_bots > 31)) max_bots = 1;
		sprintf(buffer, "max_bots set to %d\n", max_bots);
	}
	else
	{
		sprintf(buffer, "max_bots is %d\n", max_bots);
	}
	SERVER_PRINT(buffer);
}
